/*
FileName:AddBlocked.js
Version:1.0.0
Purpose:Adding Roadblock
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, Picker, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import ModalSelector from 'react-native-modal-selector';

// import {
//   Dropdown,
//   GroupDropdown,
//   MultiselectDropdown,
// } from 'sharingan-rn-modal-dropdown';
// import { Dropdown } from 'react-native-material-dropdown';

import Toast from 'react-native-simple-toast';
import log from '../LogFile/Log';

export default class AddBlocked extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      isLoading: true,
      dataSource: [],
      isFetching: false,
      open: false,
      ProjectTitle: "",
      ProjectDescription: "",
      role: '',
      userToken: '',
      empData: [],
      dependencyData: [],
      subTask: '',
      description: '',
      days: '',
      time: '',
      modifyTask: 'modify',
      dependencyid: '',
      person: '',
      prioritySelected: '',
      severitySelected: '',
      itemPressedDisabled: false,
      error1: '', error2: '', error3: '', error4: '', error5: '',
      moduleId: this.props.navigation.state.params.moduleId,

      // action: this.props.navigation.state.params.action,//getting action
      //subTask: this.props.navigation.state.params.subTask,//idea id
      subTaskId: this.props.navigation.state.params.subTaskId,
      roadblockId: this.props.navigation.state.params.roadblockId,
      subTaskName: this.props.navigation.state.params.subTaskName,
      description: this.props.navigation.state.params.description,
    };

  }
  //open Modal
  modalDidOpen = () => console.log("Modal did open.");
  //close Modal
  modalDidClose = () => {
    this.props.navigation.goBack();

    this.setState({ open: false }); this.setState({ open: false });
    console.log("Modal did close.");

  };

  //Dialog actions start
  moveUp = () => this.setState({ offset: -100 });

  resetPosition = () => {
    this.setState({ offset: 0 });
    this.props.navigation.goBack();
  }

  //open the dialog 
  openModal = () => {
    this.setState({ open: true })

  };
  //close Dialog
  closeModal = () => {
    this.setState({
      open: false,
      error1: '', error2: '', error3: '', error4: '', error5: '',
    });
    this.props.navigation.goBack();


  }
  //Dialog actions end
  componentDidMount() {
    log("Debug", "Add Sub Task Modal screen is loaded");
    this.empSearch();
    // this.dependencySearch();
    this.openModal();


  }

  //Refresh data
  // onRefresh() {
  //   this.setState({ isFetching: true }, function () { this.add() });
  // }
  //Refresh the maintask list
  onRefresh() {
    this.setState({
      // dataSource: [],
    })
    this.add();
  }
  //Text Field Validation method
  isValid() {
    const { roadBlockDescription, } = this.state;
    let valid = false;

    // if (subTask.length === 0) {
    //   log("Warn", "subTask should not be empty");
    //   this.setState({ error1: 'Enter sub Task ' });
    // }
    // else if (description.length === 0) {
    //   log("Warn", "description should not be empty");
    //   this.setState({ error2: 'Enter Description ' });
    // }
    if (roadBlockDescription.length === 0) {
      log("Warn", "Enter RoadBlock Description ");
      this.setState({ error3: 'Enter RoadBlock Description ' });
    }




    else {
      valid = true;
    }
    return valid;
  }//isValid method end


  isAdedSucess() {
    Toast.show("Roadblock Added Successfully", Toast.LONG);
  }

  //Add the subtask start
  addSubTask = () => {

    log("Info", " addSubTask() is used to add sub task");
    const { item, subTask, roadBlockDescription, description, days, time, prioritySelected, severitySelected } = this.state;
    const message = "User story moved to roadblock" + roadBlockDescription;
    // console.log(this.state.subTaskId);
    // alert(this.state.subTaskId)
    // alert(roadBlockDescription)
    // alert(prioritySelected)
    // alert(severitySelected)
    console.log(prioritySelected);
    console.log(severitySelected);
    // alert(moduleId+"  "+taskid);


    // let EstHours = Number(days * 24) + Number(time);
    // alert(Number(days) + "  " + Number(time));
    // alert(person);
    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            if (this.isValid()) {
              fetch(API + 'manage_roadblocks.php', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({


                  crop: cropcode,

                  empId: empId,
                  //   assignedTo: person,

                  action: "insert",
                  subTaskId: this.state.subTaskId,


                  roadBlockDescription: roadBlockDescription,
                  prioritySelected: prioritySelected,
                  severitySelected: severitySelected,
                  projectId:projectId,

                  // maintaskId: this.state.taskid,
                  // moduleId: this.state.moduleId,
                  // empId: empId,
                  // crop: cropcode,

                })
              }).then((response) => response.json())
                .then((responseJson) => {
                  //   alert(JSON.stringify(responseJson));
                  console.log(JSON.stringify(responseJson));
                  console.log(responseJson);
                  if (responseJson.status === 'True') {
                    this.addCommentUserStory(message, this.state.subTaskId, "4")
                    console.log("done")
                    // this.props.navigation.goBack();
                    this.setState({ open: false })
                  }
                }).catch((error) => {
                  console.error(error);
                  log("Error", "addSubTask  error");
                });
              this.closeModal();
              this.isAdedSucess();

            }
          }
        });
      });
    });
  });
  };


  // if dependency not exit this method will executes
  addCommentUserStory = (message, subtaskid, cardId) => {
    //   alert("message" + message)
    //   alert("subtaskid" + subtaskid)
    //   alert("cardId" + cardId)
    console.warn("message" + message)
    console.warn("subtaskid" + subtaskid)
    console.warn("cardId" + cardId)

    log("Info", "updateActiveTaskStatus() method is used to make subtask as active");
    // const { subtaskid, taskStatus, description, taskcompleteStatus, } = this.props;
    // const message="User story in progress";
    //Time();
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == "undefined" || state.type == "unknown") {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      } else {
        AsyncStorage.getItem("cropcode", (err, res) => {
          const cropcode = res;
          AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.warn("empId" + empId)
            fetch(API + 'storyComments.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  action: "addStoryComment",
                  storyId: subtaskid,
                  userId: empId,
                  message: message,
                  cardId: cardId
                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                console.warn(responseJson)
                if (responseJson.status === 'True') {
                  // this.props.navigation.navigate('Pending');
                  //   this.onRefresh();
                  // this.getSubtaskListPending();
                  alert("Success");
                } else {
                  // this.getSubtaskListPending();
                  alert("Not Success");
                  //   new Pending().onRefresh();

                  // alert("You not able active this task untill complete your activated task");

                  log("Warn", "You not able active this task untill complete your activated task");
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "Error in making subtask as active");
              });
          });
        });
      }
    });
  }

  //Getting the Employee List for Adding subtask
  empSearch() {
    log("Info", "empSearch(cropcode) method is used to employee's data");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const crop = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          console.log(state.type);
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          this.setState({ itemPressedDisabled: false })
          fetch(API + 'getEmployees.php', {
            method: 'POST',
            headers: {
              'Accept': 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              action: "add",
              crop: crop //Async
            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              this.setState({ itemPressedDisabled: false })
              this.setState({
                empData: [...responseJson.data],
              });
            }
            )
            .catch((error) => {
              console.error(error);
              log("Error", "error in geting employees details");
            });
        }
      });
    });
  }
  //Getting Employees List end

  //Getting dependency task list start
  dependencySearch() {
    console.warn(this.props.navigation.state.params.IdeaId)
    AsyncStorage.getItem("cropcode", (err, res) => {
      const crop = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          console.log(state.type);
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'getSubtasks.php', {
            method: 'POST',
            headers: {
              'Accept': 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              action: "setdependency",
              crop: crop, //Async
              ideaId: this.state.ideaId
            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)
              if (responseJson.status === 'true') {
                // alert("Your Task is Updated Successfully");
                // this.getdata();//to get the user pending my task list

                this.setState({
                  isLoading: false,
                  dependencyData: [...responseJson.data],
                  isFetching: false
                }, function () {
                });

              } else {
                Alert.alert("No depencency is available")
                // log("Info", "no pending my tasks at user side");
              }
              // if (responseJson.status === 'TRUE') {
              // this.setState({
              //   dependencyData: [...responseJson.data],
              // });
              //   }
              // else{
              //   dependencyData:[]
              // }
              // this.setState({
              //   dependencyData: [...responseJson.data],
              // });
            }
            )
            .catch((error) => {
              console.error(error);
              log("Error", "error in geting employees depencey ");
            });
        }
      });
    });
  }
  //Getting dependency task list end

  render() {
    let index = 0;
    const data = [
      { key: index++, label: '1' },
      { key: index++, label: '2' },
      { key: index++, label: '3' },
      { key: index++, label: '4' },

    ];

    const data1 = [
      { key: index++, label: '1' },
      { key: index++, label: '2' },
      { key: index++, label: '3' },
      { key: index++, label: '4' },

    ];



    return (
      <Modal
        offset={this.state.offset}
        open={this.state.open}
        modalDidOpen={this.modalDidOpen}
        modalDidClose={this.modalDidClose}
        style={{ alignItems: "center", backgroundColor: 'white' }} >


        <View style={{ alignItems: "center", backgroundColor: 'white' }}>
          <Text style={{ fontSize: 18, justifyContent: 'center', alignSelf: 'center', justifyContent: 'center' }}>Add Roadblock</Text>



          <View style={{ marginLeft: 10, width: '100%', }}>

            <Text style={{ color: 'red' }}>{this.state.error2}</Text>
            <TextInput placeholder="Roadblock Title" style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
              value={this.state.roadBlockDescription}
              onChangeText={(text) => this.setState({ roadBlockDescription: text })}></TextInput>

          </View>





          <View style={{ paddingTop: 20, width: '100%', marginLeft: '2%' }}>
            <ModalSelector
              data={data}
              initValue="Select Severity"
              // supportedOrientations={['landscape']}
              optionContainerStyle={{backgroundColor:'white'}}
              accessible={true}
              scrollViewAccessibilityLabel={'Scrollable options'}
              cancelButtonAccessibilityLabel={'Cancel Button'}
              onChange={(option) => { this.setState({ severitySelected: option.label }) }}>

              <TextInput
                style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '98%', marginLeft: '1%',color:'black' }}
                editable={false}
                placeholder="Select Severity"
                value={this.state.severitySelected} />

            </ModalSelector>
          </View>
          <View style={{ paddingTop: 20, width: '100%', marginLeft: '2%' }}>

            <ModalSelector
              data={data1}
              initValue="Select Priority "
              // supportedOrientations={['landscape']}
              optionContainerStyle={{backgroundColor:'white'}}
              accessible={true}
              scrollViewAccessibilityLabel={'Scrollable options'}
              cancelButtonAccessibilityLabel={'Cancel Button'}
              onChange={(option) => { this.setState({ prioritySelected: option.label }) }}>

              <TextInput
                style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '98%', marginLeft: '1%' ,color:'black'}}
                editable={false}
                placeholder="Select Priority "
                value={this.state.prioritySelected} />

            </ModalSelector>
          </View>




          <View style={{ flexDirection: 'row', }}>
            <TouchableOpacity style={styles.opensave} onPress={this.addSubTask} disabled={this.state.itemPressedDisabled}>
              <Text style={{ color: 'white' }}>SAVE</Text>

            </TouchableOpacity>
            <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
              <Text style={{ color: 'white' }}>CANCEL</Text>
            </TouchableOpacity>

          </View>


        </View>

      </Modal>



    );

  }

}
//Styles for UI

const styles = StyleSheet.create(
  {
    MainContainer:
    {
      flex: 1,
      width: Dimensions.get('window').width,
      height: Dimensions.get('window').height
    },
    bottomView: {
      flexDirection: 'row',
      justifyContent: 'center',
      position: 'absolute',
      height: FOOTER_MAX_HEIGHT,
      bottom: 0,
      left: 0,
      right: 0,
      backgroundColor: 'black',
      alignItems: 'center'
    },

    textStyle: {
      color: '#fff',
      fontSize: 18
    },
    container: {
      flex: 1,
      width: '90%',
      paddingLeft: hp('2%'),
    },
    footer: {
      position: 'absolute',
      flex: 0.1,
      left: 0,
      right: 0,
      bottom: -10,
      backgroundColor: 'green',
      flexDirection: 'row',
      height: 80,
      alignItems: 'center',
    },
    bottomButtons: {
      alignItems: 'center',
      justifyContent: 'center',
      flex: 1,
    },
    footerText: {
      color: 'white',

      alignItems: 'center',
      fontSize: 18,
    },
    buttonContainer: {
      width: wp('90%'),
      alignSelf: 'baseline',
      marginBottom: 25,
      color: '#d2691e',
      marginLeft: 4,



    },
    signupButton: {

      backgroundColor: '#ffffff',
    },
    subcontainer: {
      flex: 2,
      flexDirection: 'row',
      paddingTop: 40
    },
    signUpText0: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,

    },
    signUpText1: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,

      paddingLeft: 10,
    },
    end: {

      alignItems: 'flex-end',

    },
    end1: {
      flex: 2,
      height: '50%',
      paddingTop: 20,
      justifyContent: 'space-between',

      flexDirection: 'row',
    },
    s: {
      justifyContent: 'center',

      backgroundColor: '#ed7070',
      shadowOffset: { width: 50, height: 50 },
      alignItems: 'center',
      width: wp('40%'),
      height: hp('12%'),

    },
    signUpText2: {
      fontSize: 10,
      marginLeft: 200,
      fontSize: 13,
      color: 'green',
      paddingTop: 10,

      //  marginRight: 10,
      //textAlign: "right"

    },
    signUpText3: {

      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 10,

      alignItems: 'center',
    },
    signUpText4: {
      fontSize: 12,
      paddingTop: 10,


      alignItems: 'center',
    },
    signup: {
      //paddingTop:20,
      color: "#FFF",

    },
    boxone: {
      flex: 1,
      marginTop: 5,

    },
    boxtwo: {
      flex: 1,

    },
    boxthree: {
      flex: 1,

    },
    box: {
      flexDirection: 'row',
      position: 'relative',
      marginBottom: 10,


    },
    signUpText: {
      fontSize: 20,
      justifyContent: 'center',


      color: 'white',
      alignSelf: 'center',
    },
    buttonView: {
      display: 'flex',
      justifyContent: 'center',
      flexDirection: 'row',
      marginTop: 10,
    },
    containerButton: {
      paddingTop: 30,
      marginLeft: 20,
      marginRight: 20,
      flex: 1,
    },
    opencancel: {
      flex: 1,
      ...Platform.select({
        ios: {
          backgroundColor: 'red', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
        android: {
          backgroundColor: 'red', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
      }),
    },
    opensave: {
      flex: 1,
      ...Platform.select({
        ios: {
          backgroundColor: 'green', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
        android: {
          backgroundColor: 'green', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
      }),
    },

  });



