/*
FileName:AddSquad.js
Version:1.0.0
Purpose: Add or Modify the Maintask 
Devloper:Mahesh Reddy, Santhosh Panjala
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, StatusBar, Dimensions, Picker, TouchableOpacity, Linking, TextInput, Alert } from 'react-native';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Icon from 'react-native-vector-icons/MaterialCommunityIcons';
import SearchableDropdown from 'react-native-searchable-dropdown';
import AsyncStorage from '@react-native-community/async-storage';
// import { tsMethodSignature } from '@babel/types';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import ModalSelector from 'react-native-modal-selector';
// import { Dropdown } from 'react-native-material-dropdown';
import log from '../LogFile/Log';
import Toast from 'react-native-whc-toast';
import { MAINTASKINFO, MAINTASKTITLE, DESCRIPTION, } from '../CommonComponents/Header';
import { ScrollView } from 'react-native-gesture-handler';
import { EMPLOYEEID1, FULLNAME, USERNAME1, EMAIL1, MOBILE1, ADDEMPLOYEE, EMPLOYEEDETAILS } from '../CommonComponents/Header';
import RadioButtonRN from 'radio-buttons-react-native';


export default class AddSquad extends Component {

    constructor(props) {
        super(props);

        this.state = {
            assignedName: 'Squad Name',
            epicName: 'Select Epic Name',
            tasktitle: '',

            taskdescription: '',
            modalVisible: false,
            resource: [],
            epics: [],
            epicId: '',
            // name: "",
            assignedto: '',
            acceptanceCriteria: '',
            storyPoints: '',
            priorityLevel: '',
            user: '',
            empId: '',
            fullname: '',
            email: '',
            username: '',
            mobile: '',
            usertype: '',


        };
    }

    //getting the Employees list for addind maintask
    getEmployees() {
        log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
        const { ModuleId } = this.state;
        const { ideaid } = this.state;
        // console.warn("ModuleId"+ModuleId)
        AsyncStorage.getItem("projectId", (err, res) => {
            const projectId = res;

            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'get_user.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    crop: cropcode,
                                    projectId: projectId,
                                    action: "get_squads_list"
                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                //alert(JSON.stringify(responseJson))
                                if (responseJson.status === 'True') {

                                    var empList = [];
                                    responseJson.data.map((employee) => {
                                        return (
                                            empList.push({
                                                'id': employee.id, 'name': employee.name, 'email': employee.email, 'mobileNumber': employee.mobileNumber, 'userName': employee.userName
                                            })
                                        );
                                    })

                                    this.setState({
                                        resource: empList,
                                    });
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "requested projects error");
                            });
                    }
                });
            });
        });
    }


    //Adding the new Employee
    onSignIn() {
        log("Info", " onSignIn( usertype, user_status, password) is used to Adding the new Employee");

        if (this.isValid()) {
            console.log("staredt.,.................");
            // console.log(this.state.designation);
            // console.log(this.state.team);
            // console.warn(this.state.usertype);
            console.warn("empId" + this.state.empId + "fulllname" + this.state.fullname + "username" + this.state.username + "mobile" + this.state.mobile + "emp_role" + this.state.emp_role);
            console.log(this.state.user_status);
            console.warn(this.state.user_status);
            console.log(this.state.password);
            const { empId, user_status, password, usertype } = this.state;
            var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
            var string_length = 8;
            var pass_code = '';
            for (var i = 0; i < string_length; i++) {
                var num = Math.floor(Math.random() * chars.length);
                pass_code += chars.substring(num, num + 1);
            }
            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                AsyncStorage.getItem("userToken", (err, res) => {
                    const userToken = res;

                    AsyncStorage.getItem("projectId", (err, res) => {
                        const projectId = res;

                        NetInfo.fetch().then(state => {
                            if (state.type == "none") {
                                console.log(state.type);
                                log("Warn", "No internet connection");
                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {
                                fetch(API + 'manage_user.php', {
                                    method: 'POST',
                                    headers: {
                                        'Accept': 'application/json',
                                        'Content-Type': 'application/json',
                                    },
                                    body: JSON.stringify({
                                        empId: empId,
                                        fullname: this.state.fullname,
                                        email: this.state.email,
                                        username: this.state.username,
                                        mobile: this.state.mobile,
                                        action: "check_user",
                                        corp: cropcode,
                                        password: pass_code,
                                        // team: team,
                                        // functionalManager: fmanager,
                                        // reportingManager: rmanager,
                                        // designation: designation,
                                        userType: usertype,
                                        // user_status: user_status,
                                        // created_by: "admin",
                                        // created_by: userToken,
                                        projectId: projectId,
                                    })
                                }).then((response) => response.json())
                                    .then((responseJson) => {
                                        //alert(responseJson);
                                        console.log(JSON.stringify(responseJson));
                                        console.log(responseJson);
                                        //  alert(JSON.stringify(responseJson));
                                        if (responseJson.status === 'True') {

                                            this.props.navigation.navigate('UserManageEmployees');

                                        }
                                        else {
                                            console.log(JSON.stringify(responseJson));
                                            log("Warn", "Error  found");
                                            // alert("error");
                                            alert(responseJson.message)
                                        }

                                    }).catch((error) => {
                                        console.error(error);
                                        log("Error", "Adding the new Employee error");
                                    });
                            }
                        });
                    });
                });
            });

        }
    }
    //getting the Employees list for addind maintask
    getEpic() {
        log("Info", " getEpic(cropcode) is used for getting the Epics list for adding Epic to userstory");
        // const { ModuleId } = this.state;
        // const { ideaid } = this.state;

        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;

            AsyncStorage.getItem("emp_role", (err, res) => {
                const emp_role = res;
                AsyncStorage.getItem("userToken", (err, res) => {
                    const userToken = res;
                    AsyncStorage.getItem("projectId", (err, res) => {
                        const projectId = res;

                        NetInfo.fetch().then(state => {
                            if (state.type == "none") {
                                console.log(state.type);
                                log("Warn", "No internet connection");
                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {
                                fetch(API + 'get_epics.php',
                                    {
                                        method: 'POST',
                                        headers: {
                                            Accept: 'application/json',
                                            'Content-Type': 'application/json',
                                        },
                                        body: JSON.stringify({
                                            corp: cropcode,
                                            action: "get_epics",
                                            userType: emp_role,
                                            empId: userToken,
                                            projectId: projectId,

                                        })
                                    })
                                    .then((response) => response.json())

                                    .then((responseJson) => {
                                        // alert(JSON.stringify(responseJson))
                                        if (responseJson.status === 'True') {

                                            var epicsList = [];
                                            responseJson.data.map((epics) => {
                                                return (
                                                    epicsList.push({
                                                        'id': epics.id, 'name': epics.idea_title
                                                    })
                                                );
                                            })

                                            this.setState({
                                                epics: epicsList
                                            });
                                        }
                                    })
                                    .catch((error) => {
                                        console.error(error);
                                        log("Error", "requested projects error");
                                    });
                            }
                        });
                    });
                });
            });
        });
    }

    //Checking the Validations start
    isValid() {
        var { empId, fullname, email, username, mobile } = this.state;
        let valid = false;

        // if (empId.length === 0) {
        //     log("Warn", "empId should not be empty");
        //     alert("Enter Employee Id");
        // }

        if (fullname.length === 0) {
            log("Warn", "fullname should not be empty");
            alert("Enter Fullname");
        }
        else if (email.length === 0) {
            log("Warn", "email should not be empty");
            alert("Enter email");
        }
        else if (!this.verifyEmail(email)) {
            log("Warn", "email Validaton should not be empty");
            alert("Invalid Email");
        }
        else if (username.length === 0) {
            log("Warn", "username should not be empty");
            alert("Enter User name");
        }

        // else if (mobile.length === 0) {
        //     log("Warn", "mobile should not be empty");
        //     alert("Enter phonenumber");
        // }
        // else if (mobile.length > 10) {
        //     log("Warn", "mobile should not be greater than 10");
        //     alert("Invalid phonenumber");
        // }
        // else if (mobile.length < 10) {
        //     log("Warn", "mobile should not be less than 10");
        //     alert("Invalid phonenumber");
        // }

        else {
            valid = true;
        }
        return valid;
    }
    verifyEmail(email) {
        var reg = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return reg.test(email);
    }
    //Checking the Validations end






    //Add or Mpdify the Maintask close
    componentDidMount() {
        //Getting Employees List
        log("Debug", "Add Task screen is loaded");
        this.getEmployees();
        this.getEpic();
    }

    render() {


        let index = 0;
        const data1 = [
            { key: index++, label: '1' },
            { key: index++, label: '2' },
            { key: index++, label: '3' },
            { key: index++, label: '5' },
            { key: index++, label: '8' },
            { key: index++, label: '13', },

        ];

        const data = [
            {
                // id: 'Scrum Master',
                label: 'Scrum Master'
            },
            {
                id: 'Contributor',
                label: 'Contributor'
            },
            {
                id: 'Product Owner',
                label: 'Product Owner'
            }
        ];
        // console.warn("assigned to in render"+this.state.assignedto);
        const data2 = [
            {
                id: 'Contributor',
                label: 'Full Access'
            },
            {
                id: 'Limited Access Contributor',
                label: 'Limited Access'
            }
        ];
        return (
            <Container>
                <Header
                    androidStatusBarColor="#00A2C1"

                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <Left>
                        <Icon name="arrow-left" size={25} style={{ color: '#fff', }} onPress={() =>
                            this.props.navigation.navigate('UserManageEmployees')} />
                    </Left>
                    <Body>
                        <Title style={{ color: '#fff', fontWeight: '600' }}>Add Squad</Title>
                    </Body>
                    <Right></Right>
                </Header>

                <Content>
                    <Toast ref="toast" />
                    <View style={{ paddingTop: 20, }}>


                        <View style={{ paddingTop: 10, }}>

                            <SearchableDropdown
                                placeholder={this.state.assignedName}
                                onTextChange={text => console.log(text)}
                                // value={this.state.assignedName}
                                // onItemSelect={item => item.name}
                                onItemSelect={(item) => this.setState({ empId: item.id, username: item.name, email: item.userName, mobile: item.mobileNumber, fullname: item.userName })}
                                placeholderTextColor='black'
                                containerStyle={{ padding: 5 }}
                                textInputStyle={{
                                    padding: 12,
                                    borderWidth: 1,
                                    borderColor: '#ccc',
                                    // backgroundColor: '#FAF7F6',
                                }}
                                itemStyle={{
                                    padding: 10,
                                    marginTop: 2,
                                    backgroundColor: '#FAF9F8',
                                    borderColor: '#bbb',
                                    borderWidth: 1,
                                }}
                                itemTextStyle={{

                                    color: '#222',
                                }}
                                itemsContainerStyle={{

                                    // maxHeight: '60%',
                                }}
                                items={this.state.resource}

                                defaultIndex={2}

                                // placeholder=""

                                resetValue={false}

                                underlineColorAndroid="transparent"

                            />
                            <Text style={{ color: 'red' }}>{this.state.error3}</Text>
                        </View>

                        <View style={{ paddingLeft: 10, }}>

                            <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                placeholder={FULLNAME}
                                underlineColorAndroid='transparent'
                                value={this.state.fullname}
                                onChangeText={(fullname) => this.setState({ fullname })}

                            />
                        </View>
                        <View style={{ paddingLeft: 10, }}>


                            <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                placeholder={EMAIL1}
                                underlineColorAndroid='transparent'
                                value={this.state.email}
                                onChangeText={(email) => this.setState({ email })}

                            />
                        </View>

                        <View style={{ paddingLeft: 10, }}>


                            <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                placeholder={MOBILE1}
                                maxLength={10}
                                keyboardType={"number-pad"}
                                underlineColorAndroid='transparent'
                                value={this.state.mobile}
                                onChangeText={(mobile) => this.setState({ mobile })}

                            />
                        </View>
                        <View style={{ paddingLeft: 10, }}>


                            <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                placeholder={USERNAME1}
                                underlineColorAndroid='transparent'
                                value={this.state.username}
                                onChangeText={(username) => this.setState({ username })}
                            />
                        </View>

                        <View style={{ paddingLeft: 10, paddingTop: 10, }}>
                            <Text>Select Role</Text>
                            <RadioButtonRN
                                data={data}
                                box={false}
                                // horizontal={true}
                                // style={styles.types}
                                // activeButtonId={this.state.role}
                                selectedBtn={(option) => this.setState({ usertype: option.id })}
                                circleStyle={{ fillColor: 'black', borderColor: 'black' }}
                                icon={
                                    <Icon
                                        name="check-circle"
                                        size={25}
                                        color="black"
                                    />
                                }
                            />
                        </View>

                        <View style={{ paddingLeft: 10, paddingTop: 10, }}>
                            <Text>Contributor Access</Text>
                            <RadioButtonRN
                                data={data2}
                                box={false}
                                // horizontal={true}
                                // style={styles.types}
                                // activeButtonId={this.state.role}
                                selectedBtn={(option) => this.setState({ usertype: option.id })}
                                circleStyle={{ fillColor: 'black', borderColor: 'black' }}
                                icon={
                                    <Icon
                                        name="check-circle"
                                        size={25}
                                        color="black"
                                    />
                                }
                            />
                        </View>

                        <View style={{ flexDirection: 'row', marginTop: 10, justifyContent: "space-between" }}>
                            <TouchableOpacity style={styles.opensave}
                                onPress={() => this.onSignIn()}                            >
                                <Text style={{ color: 'white' }}>ADD</Text>
                            </TouchableOpacity>

                            <TouchableOpacity style={styles.opencancel} onPress={() => this.props.navigation.navigate('UserManageEmployees')}>
                                <Text style={{ color: 'white' }}>CANCEL</Text>
                            </TouchableOpacity>

                        </View>

                    </View>
                </Content>
            </Container>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create({
    opencancel: {
        flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'red', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
            android: {
                backgroundColor: 'red', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
        }),
    },
    opensave: {
        flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'green', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
            android: {
                backgroundColor: 'green', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
        }),
    },
});