/*
FileName:AssignTodo.js
Version:1.0.0
Purpose:Assigning the todo list
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, Picker, FlatList, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Icon, Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import SearchableDropdown from 'react-native-searchable-dropdown';
import Toast from 'react-native-whc-toast';
import log from '../LogFile/Log';
import { ScrollView } from 'react-native-gesture-handler';
import { ADDMODULE, MODULE_TITLE, MAINTASKTITLE, TASKID } from '../CommonComponents/Header';

import ModalSelector from 'react-native-modal-selector';
export default class AssignTodo extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            open: false,
            modulename: '',
            resource: [],
            epics: [],
            moduleId: this.props.navigation.state.params.moduleId,
            role: '',
            userToken: '',
            modalVisible: false,
            pt_id: this.props.navigation.state.params.pt_id,
            action: this.props.navigation.state.params.action,//getting action
            epicId: this.props.navigation.state.params.ideaid,//idea id
            taskdescription: this.props.navigation.state.params.story_desc,//moduledesc
            tasktitle: this.props.navigation.state.params.story_title,
            targetDate: this.props.navigation.state.params.targetDate,
            // assignedName: this.props.navigation.state.params.assigntto,
            assignedto: this.props.navigation.state.params.assignedto,
            // assignedTo:this.props.navigation.state.params.assignedTo,
            acceptanceCriteria: this.props.navigation.state.params.acceptanceCriteria,
            storyPoints: this.props.navigation.state.params.storyPoints,
            priorityLevel: this.props.navigation.state.params.priorityLevel,
            taskid: this.props.navigation.state.params.taskid,
            // projectitle: this.props.navigation.state.params.projectitle,
            projectitle:'Select Epic',
            error1: '',
            itemPressedDisabled: false,
            assignedName:'Select User',
            // dataSource:[],
            // sprintDesc: this.props.navigation.state.params.sprintDesc,
        };


        // alert("Hello"+this.state.projectitle)
    }
    //Open the Dialog Modal
    modalDidOpen = () => console.log("Modal did open.");
    //close the Dialog Modal
    modalDidClose = () => {
        this.props.navigation.goBack();
        this.setState({ open: false }); this.setState({ open: false });
        console.log("Modal did close.");

    };

    //Dialog actions start
    moveUp = () => this.setState({ offset: -100 });

    resetPosition = () => {
        this.setState({ offset: 0 });
        this.props.navigation.goBack();
    }

    //open the dialog 
    openModal = () => {
        this.setState({ open: true })

    };
    //close the dialog
    closeModal = () => {
        this.setState({ open: false });
        this.props.navigation.goBack();
    }
    //Dialog actions end
    componentDidMount() {
        log("Debug", "Module Add screen is loaded");
        this.openModal();
        this.getEmployees();
        // this.getEpic();
        this.GetStatus();

        if (this.props.navigation.state.params.projectitle === null) {

            this.setState({
                projectitle: 'Select Epic '
            });

        }

        // this.setModalVisible(!this.state.modalVisible);
    }


    //getting the Employees list for addind maintask
    getEmployees() {
        log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
        const { ModuleId } = this.state;
        const { ideaid } = this.state;
        // console.warn("ModuleId"+ModuleId)

        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'agile_squads.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    corp: cropcode,
                                    projectId: projectId,
                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                if (responseJson.status === 'True') {

                                    var epicsList = [];
                                    responseJson.data.map((epics) => {
                                        return (
                                            epics.workingStatus === "Active" ?
                                                epicsList.push({
                                                    'id': epics.id, 'name': epics.name
                                                }) : null
                                        );
                                    })

                                    this.setState({
                                        resource: epicsList,
                                    });
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "requested projects error");
                            });
                    }
                });
            });
        });
    }


    //getting the Employees list for addind maintask
    getEpic(projectId) {
        log("Info", " getEpic(cropcode) is used for getting the Epics list for adding Epic to userstory");
        // const { ModuleId } = this.state;
        // const { ideaid } = this.state;
        // alert(projectId)

        // AsyncStorage.getItem("cropcode", (err, res) => {
        //     const cropcode = res;

        AsyncStorage.getItem("emp_role", (err, res) => {
            const emp_role = res;
            AsyncStorage.getItem("userToken", (err, res) => {
                const userToken = res;
                // AsyncStorage.getItem("projectId", (err, res) => {
                //     const projectId = res;
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'get_epics.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    // corp: cropcode,
                                    action: "get_epics",
                                    userType: emp_role,
                                    empId: userToken,
                                    projectId: projectId,


                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                if (responseJson.status === 'True') {
                                    // alert("Data Epis" + JSON.stringify(responseJson))
                                    var epicsList = [];
                                    responseJson.data.map((epics) => {
                                        return (
                                            epicsList.push({
                                                'id': epics.idea_id, 'name': epics.idea_title
                                            })
                                        );
                                    })

                                    this.setState({
                                        epics: epicsList
                                    });
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "requested projects error");
                            });
                    }
                });
            });
            // });
            // });
        });
    }



    //Refresh data
    onRefresh() {
        this.setState({ isFetching: true }, function () { this.add() });
    }

    // //Validatios
    // isValid() {
    //     const { moduledesc } = this.state;
    //     let valid = false;

    //     if (moduledesc.length === 0) {
    //         log("Warn", "moduledesc should not be empty");
    //         this.setState({ error1: 'Enter Module Title ' });
    //     }

    //     else {
    //         valid = true;
    //     }
    //     return valid;
    // }


    //Checking the Validations
    isValid() {
        const { tasktitle, taskdescription, assignedto } = this.state;
        let valid = false;

        if (tasktitle.length === 0) {
            log("Warn", "tasktitle title should not be empty");
            this.setState({ error1: 'Enter Task Title ' });
        }
        else if (taskdescription.length === 0) {
            // alert("Enter Description");
            log("Warn", "taskdescription title should not be empty");
            this.setState({ error2: 'Enter Description ' });
        }
        else if (assignedto.length === 0) {
            log("Warn", "taskdescription title should not be empty");
            this.setState({ error3: 'Select Source ' });
        }

        else {
            valid = true;
        }
        return valid;
    }


    //to add the new project from user 
    addMainTask = () => {
        log("Info", "addProject() method is used to add new project at user side");
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == "unknown" || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
            }
            else {
                const {  pt_id, projectId,item, taskid, tasktitle, taskdescription, assignedto, acceptanceCriteria, storyPoints, moduleId, priorityLevel, epicId } = this.state;
                const message = "User story Reassigned";
                console.warn("tasktitle" + tasktitle);
                console.warn("taskdescription" + taskdescription);
                console.warn("assignedto" + assignedto);
                console.warn("acceptanceCriteria" + acceptanceCriteria);

                console.warn("epicId" + epicId)
                console.warn("priorityLevel" + priorityLevel)
                console.warn("storypoints" + storyPoints);
                console.warn("Moduleid" + moduleId);
                console.warn("taskid" + taskid);

                // alert(this.state.action)

                // alert(taskid)

                if (this.isValid()) {
                    this.setState({ itemPressedDisabled: true })
                    AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
                        const cropcode = response[0][1];
                        const userToken = response[1][1];
                        console.warn("userToken" + userToken)
                        const role = response[2][1];
                        // AsyncStorage.getItem("projectId", (err, res) => {
                        //     const projectId = res;
                            AsyncStorage.getItem("userId", (err, res) => {
                                const userId = res;
                                fetch(API + 'private_todo.php', {
                                    method: 'POST',
                                    headers: {
                                        'Accept': 'application/json',
                                        'Content-Type': 'application/json',
                                    },
                                    body: JSON.stringify({
                                        
                                        action: "add",
                                        // action: this.state.action,
                                        // mainTaskId: taskid,
                                        // crop: cropcode,
                                        title: this.state.tasktitle,
                                        description: this.state.taskdescription,
                                        // module_id: moduleId,
                                        idea_id: epicId,
                                        added_by:userToken,
                                        added_to: this.state.assignedto,
                                        acceptanceCriteria: acceptanceCriteria,
                                        storyPoints: storyPoints,
                                        added_by: userToken,
                                        priorityLevel: priorityLevel,
                                        pt_id:pt_id,
                                        // epicId: epicId,
                                        projectId: projectId,
                                        device_id: userId,
                                        // sprintDesc: this.state.sprintDesc,
                                    })
                                }).then((response) => response.json())
                                    .then((responseJson) => {
                                        console.log("Data Testing" + JSON.stringify(responseJson));
                                        console.log(responseJson);
                                        // alert("Data Testing" + JSON.stringify(responseJson))


                                        if (responseJson.status === 'True') {
                                            // this.addCommentUserStory(message, taskid, "5")
                                            // this.refs.toast.showCenter('User Story Modified');
                                            this.props.navigation.goBack();
                                            console.log(responseJson);



                                            //   alert("User Story Modified");
                                            this.setState({ itemPressedDisabled: false })
                                            console.log("done")

                                            Snackbar.show({
                                                title: 'Task Added To Project Successfully',
                                                backgroundColor: 'green',
                                                duration: Snackbar.LENGTH_LONG,
                                            });


                                        }
                                    }).catch((error) => {
                                        console.error(error);
                                        log("Error", "error in User Story adding");
                                    });
                            });
                        });
                    // });
                    // this.closeModal();
                }
            }


        });

    };

    // if dependency not exit this method will executes
    addCommentUserStory = (message, subtaskid, cardId) => {
        console.warn("message" + message)
        console.warn("subtaskid" + subtaskid)
        console.warn("cardId" + cardId)
        AsyncStorage.getItem("projectId", (err, res) => {
            const projectId = res;

            log("Info", "updateActiveTaskStatus() method is used to make subtask as active");
            // const { subtaskid, taskStatus, description, taskcompleteStatus, } = this.props;
            // const message="User story in progress";
            //Time();
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == "undefined" || state.type == "unknown") {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    AsyncStorage.getItem("cropcode", (err, res) => {
                        const cropcode = res;
                        AsyncStorage.getItem("userToken", (err, res) => {
                            const empId = res;
                            console.warn("empId" + empId)
                            fetch(API + 'story_comments.php',
                                {
                                    method: 'POST',
                                    headers: {
                                        Accept: 'application/json',
                                        'Content-Type': 'application/json',
                                    },
                                    body: JSON.stringify({
                                        corp: cropcode,
                                        action: "add_story_comment",
                                        storyId: subtaskid,
                                        userId: empId,
                                        message: message,
                                        cardId: cardId,
                                        projectId: projectId

                                    })
                                })
                                .then((response) => response.json())
                                .then((responseJson) => {
                                    console.warn(responseJson)
                                    if (responseJson.status === 'True') {
                                        // this.props.navigation.navigate('Pending');
                                        this.onRefresh();
                                        // this.getSubtaskListPending();
                                        alert("Success");
                                    } else {

                                        new Pending().onRefresh();

                                        alert("You not able active this task untill complete your activated task");

                                        log("Warn", "You not able active this task untill complete your activated task");
                                    }
                                })
                                .catch((error) => {
                                    console.error(error);
                                    log("Error", "Error in making subtask as active");
                                });
                        });
                    });
                }
            });
        });
    }


    //get project list dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                    this.getAgileProjects()//For Getting Project List in Offline
                } else {

                    fetch(API + 'squads.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({

                            empId: empId,
                            action: 'get_squads',


                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)
                            //   alert(JSON.stringify(responseJson))
                            if (responseJson.status == 'True') {
                                // this.addAgileProjects(responseJson.data) //Project list store in offline
                                // this.setState({
                                //     isLoading: false,
                                //     dataSource: [...responseJson.data],
                                // }, function () {
                                //     // In this block you can do something with new state.
                                // });


                                var dataSource = [];
                                responseJson.data.map((epics) => {
                                    return (
                                        dataSource.push({
                                            'key': epics.id, 'label': epics.value
                                        })
                                    );
                                })

                                this.setState({
                                    dataSource: dataSource
                                });

                                // const data2 = [];

                                // responseJson.data.map(x => {
                                //     data2.push({ label: x.value, value: x.value })
                                // })
                                // this.setState({
                                //     data2: data2,
                                // })
                                // console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                // console.warn(this.state.data2);
                            } else {
                                this.setState({
                                    dataSource: dataSource
                                });
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }

    render() {
        // alert(this.state.dataSource)

        let index = 0;
        const data = [
            { key: index++, label: '1' },
            { key: index++, label: '2' },
            { key: index++, label: '3' },
            { key: index++, label: '5' },
            { key: index++, label: '8' },
            { key: index++, label: '13', accessibilityLabel: 'Tap here for cranberries' },

        ];

        const data1 = [
            { key: index++, label: '1' },
            { key: index++, label: '2' },
            { key: index++, label: '3' },
            { key: index++, label: '4' },
            { key: index++, label: '5' },


        ];

        return (
            <Modal
                offset={this.state.offset}
                closeOnTouchOutside={false}
                open={this.state.open}
                modalDidOpen={this.modalDidOpen}
                modalDidClose={this.modalDidClose}
                style={{ alignItems: "center" }} >


                <View style={{ paddingTop: 10, }}>
                    <View style={{ paddingLeft: 10, }}>

                        <TextInput style={{ width: wp('80%'), height: 45, color: 'black', borderBottomWidth: 1, }}
                            placeholder={MAINTASKTITLE}
                            underlineColorAndroid='transparent'
                            value={this.state.tasktitle}
                            // selectionColor='white'
                            onChangeText={(maintask) => this.setState({ tasktitle: maintask })}
                        >
                        </TextInput>

                        <Text style={{ color: 'red' }}>{this.state.error1}</Text>
                    </View>

                    <View style={{ paddingLeft: 10, }}>


                        <TextInput style={{ width: wp('80%'), height: 45, color: 'black', borderBottomWidth: 1, }}
                            placeholder='Description:'
                            underlineColorAndroid='transparent'
                            value={this.state.taskdescription}
                            // selectionColor='white'
                            onChangeText={(description) => this.setState({ taskdescription: description })}>
                        </TextInput>
                        <Text style={{ color: 'red' }}>{this.state.error2}</Text>
                    </View>

                    <View style={{ paddingLeft: 10, }}>


                        <TextInput style={{ width: wp('80%'), height: 45, color: 'black', borderBottomWidth: 1, }}
                            placeholder="Acceptance Criteria/Definition of Done"
                            underlineColorAndroid='transparent'
                            value={this.state.acceptanceCriteria}
                            // selectionColor='white'
                            onChangeText={(acceptanceCriteria) => this.setState({ acceptanceCriteria: acceptanceCriteria })}>
                        </TextInput>
                        <Text style={{ color: 'red' }}>{this.state.error2}</Text>
                    </View>


                    <View style={{ width: '100%', borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>

                        <ModalSelector
                            style={{  width: '98%', backgroundColor: 'transparent', borderColor: 'transparent', marginLeft: 5 }}
                            data={this.state.dataSource}
                            //   initValue={this.state.squadName}
                            optionContainerStyle={{ backgroundColor: 'white' }}
                            //   onChange={(itemValue) => { this.UpdateStatus(itemValue.label) }} >
                            onChange={(itemValue) => { this.getEpic(itemValue.key), this.setState({ projectId: itemValue.key,projectName:itemValue.label }) } } >
                            <View style={{ width: '98%',  height: 45, flexDirection: 'row',borderColor:'grey',borderWidth:1 }}>
                                <Text style={{ marginTop: 15, color: 'black', width: '45%',paddingLeft:10 }}>PROJECT : </Text>

                                <Text style={{ marginTop: 15, color: 'black', width: '45%', }}>{this.state.projectName}</Text>

                                <Icon name="md-chevron-down-outline" size={25} style={{ color: 'black', marginTop: 10, }}
                                />
                            </View>

                        </ModalSelector>
                    </View>

                    <View style={{ paddingTop: 20, }}>
                        <SearchableDropdown
                            placeholder={this.state.assignedName}
                            onTextChange={text => console.log(text)}
                            // value={this.state.assignedto}
                            // onItemSelect={item => item.name}
                            onItemSelect={(item) => this.setState({ assignedto: item.id, assignedName: item.name, })}
                            containerStyle={{ padding: 5 }}
                            placeholderTextColor='black'
                            textInputStyle={{
                                padding: 12,
                                borderWidth: 1,
                                borderColor: '#ccc',
                                backgroundColor: '#FAF7F6',
                            }}
                            itemStyle={{
                                padding: 10,
                                marginTop: 2,
                                backgroundColor: '#FAF9F8',
                                borderColor: '#bbb',
                                borderWidth: 1,
                            }}
                            itemTextStyle={{

                                color: '#222',
                            }}
                            itemsContainerStyle={{

                                // maxHeight: '60%',
                            }}
                            items={this.state.resource}

                            defaultIndex={2}

                            // placeholder=""

                            resetValue={false}

                            underlineColorAndroid="transparent"

                        />
                        <Text style={{ color: 'red' }}>{this.state.error3}</Text>
                    </View>

                    <View style={{ paddingTop: 20, }}>
                        <SearchableDropdown
                            placeholder={this.state.projectitle}
                            onTextChange={text => console.log(text)}
                            value={this.state.epicId}
                            // onItemSelect={item => item.name}
                            onItemSelect={(item) => this.setState({ epicId: item.id, projectitle: item.name })}
                            containerStyle={{ padding: 5 }}
                            placeholderTextColor='black'
                            textInputStyle={{
                                padding: 12,
                                borderWidth: 1,
                                borderColor: '#ccc',
                                backgroundColor: '#FAF7F6',
                            }}
                            itemStyle={{
                                padding: 10,
                                marginTop: 2,
                                backgroundColor: '#FAF9F8',
                                borderColor: '#bbb',
                                borderWidth: 1,
                            }}
                            itemTextStyle={{

                                color: '#222',
                            }}
                            itemsContainerStyle={{

                                // maxHeight: '60%',
                            }}
                            items={this.state.epics}

                            defaultIndex={2}

                            // placeholder=""

                            resetValue={false}

                            underlineColorAndroid="transparent"

                        />
                        {/* <Text style={{ color: 'red' }}>{this.state.error}</Text> */}
                    </View>



                    <Text style={{ marginLeft: 10, paddingTop: 10 }}>Story Points</Text>


                    <ModalSelector
                        //  value={this.state.storyPoints}
                        data={data}
                        optionContainerStyle={{ backgroundColor: 'white' }}
                        initValue="Select something yummy!"
                        // supportedOrientations={['landscape']}
                        accessible={true}
                        scrollViewAccessibilityLabel={'Scrollable options'}
                        cancelButtonAccessibilityLabel={'Cancel Button'}
                        onChange={(option) => { this.setState({ storyPoints: option.label }) }}>

                        <TextInput
                            style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '96%', marginLeft: '2%', color: 'black' }}
                            editable={false}
                            placeholder="Select Story Points!"
                            value={this.state.storyPoints} />

                    </ModalSelector>

                    {/* <Text>Priority Level</Text>

          <Picker
            value={this.state.priorityLevel}
            // placeholder= "Acceptance Criteria/Definition of Done"
            selectedValue={this.state.priorityLevel}
            style={{ height: 50, width: '98%' }}
            onValueChange={(priorityLevel) => this.setState({ priorityLevel: priorityLevel })} >
            <Picker.Item label="1" value="1" />
            <Picker.Item label="2" value="2" />
            <Picker.Item label="3" value="3" />
            <Picker.Item label="4" value="4" />
            <Picker.Item label="5" value="5" />
           
          </Picker> */}

                    <Text style={{ marginLeft: 10, paddingTop: 10 }}>Priority Level</Text>

                    <ModalSelector
                        data={data1}
                        initValue="Select Priority  Level"
                        // supportedOrientations={['landscape']}
                        accessible={true}
                        optionContainerStyle={{ backgroundColor: 'white' }}
                        scrollViewAccessibilityLabel={'Scrollable options'}
                        cancelButtonAccessibilityLabel={'Cancel Button'}
                        onChange={(option) => { this.setState({ priorityLevel: option.label }) }}>

                        <TextInput
                            style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '96%', marginLeft: '2%', color: 'black' }}
                            editable={false}
                            placeholder="Select Priority  Level"
                            value={this.state.priorityLevel} />

                    </ModalSelector>

                    <View style={{ flexDirection: 'row', marginTop: 10, justifyContent: "space-between" }}>
                        <TouchableOpacity style={styles.opensave} onPress={() => { this.addMainTask() }} disabled={this.state.itemPressedDisabled}>
                            <Text style={{ color: 'white' }}>SAVE</Text>
                        </TouchableOpacity>

                        <TouchableOpacity style={styles.opencancel} onPress={() => this.props.navigation.goBack()}>
                            <Text style={{ color: 'white' }}>CANCEL</Text>

                        </TouchableOpacity>

                    </View>

                </View>

            </Modal>


        );

    }

}
//Styles for UI
const styles = StyleSheet.create(
    {
        MainContainer:
        {
            flex: 1,
            width: Dimensions.get('window').width,
            height: Dimensions.get('window').height
        },
        bottomView: {
            flexDirection: 'row',
            justifyContent: 'center',
            position: 'absolute',
            height: FOOTER_MAX_HEIGHT,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundColor: 'black',
            alignItems: 'center'
        },

        textStyle: {
            color: '#fff',
            fontSize: 18
        },
        container: {
            flex: 1,
            width: '90%',
            paddingLeft: hp('2%'),
        },
        footer: {
            position: 'absolute',
            flex: 0.1,
            left: 0,
            right: 0,
            bottom: -10,
            backgroundColor: 'green',
            flexDirection: 'row',
            height: 80,
            alignItems: 'center',
        },
        bottomButtons: {
            alignItems: 'center',
            justifyContent: 'center',
            flex: 1,
        },
        footerText: {
            color: 'white',
            fontWeight: 'bold',
            alignItems: 'center',
            fontSize: 18,
        },
        buttonContainer: {
            width: wp('90%'),
            alignSelf: 'baseline',
            marginBottom: 25,
            color: '#d2691e',
            marginLeft: 4,



        },
        signupButton: {

            backgroundColor: '#ffffff',
        },
        subcontainer: {
            flex: 2,
            flexDirection: 'row',
            paddingTop: 40
        },
        signUpText0: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText1: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            paddingLeft: 10,
        },
        end: {

            alignItems: 'flex-end',

        },
        end1: {
            flex: 2,
            height: '50%',
            paddingTop: 20,
            justifyContent: 'space-between',

            flexDirection: 'row',
        },
        s: {
            justifyContent: 'center',

            backgroundColor: '#ed7070',
            shadowOffset: { width: 50, height: 50 },
            alignItems: 'center',
            width: wp('40%'),
            height: hp('12%'),

        },
        signUpText2: {
            fontSize: 10,
            marginLeft: 200,
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            //  marginRight: 10,
            //textAlign: "right"

        },
        signUpText3: {

            fontSize: 12,
            paddingTop: 10,
            paddingLeft: 10,

            alignItems: 'center',
        },
        signUpText4: {
            fontSize: 12,
            paddingTop: 10,


            alignItems: 'center',
        },
        signup: {
            //paddingTop:20,
            color: "#FFF",

        },
        boxone: {
            flex: 1,
            marginTop: 5,

        },
        boxtwo: {
            flex: 1,

        },
        boxthree: {
            flex: 1,

        },
        box: {
            flexDirection: 'row',
            position: 'relative',
            marginBottom: 10,


        },
        signUpText: {
            fontSize: 20,
            justifyContent: 'center',


            color: 'white',
            alignSelf: 'center',
        },
        opencancel: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
        opensave: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
    });