/*
FileName:ChangeStatus.js
Version:1.0.0
Purpose:Adding Epic to Backlogs
Devloper:Mahesh
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import Toast from 'react-native-whc-toast';
import log from '../LogFile/Log';
import SearchableDropdown from 'react-native-searchable-dropdown';


export default class ChangeStatus extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            open: false,
            modulename: '',
            sprintName: 'Select Sprint',
            taskid: this.props.navigation.state.params.taskid,
            role: '',
            userToken: '',
            modalVisible: false,
            sprintId: '',
            action: this.props.navigation.state.params.action,//getting action
            idea_id: this.props.navigation.state.params.idea_id,//idea id
            sprintDesc: this.props.navigation.state.params.sprintDesc,
            idea_description: this.props.navigation.state.params.idea_description,
            tasktitle: this.props.navigation.state.params.tasktitle,
            id: this.props.navigation.state.params.taskid,
            activeStatus:this.props.navigation.state.params.activeStatus,
            completeStatus:this.props.navigation.state.params.completeStatus,

            error: '',
            resource: [],

            itemPressedDisabled: false,
        };

    }
    //Open the Dialog Modal
    modalDidOpen = () => console.log("Modal did open.");
    //close the Dialog Modal
    modalDidClose = () => {
        this.props.navigation.goBack();
        this.setState({ open: false }); this.setState({ open: false });
        console.log("Modal did close.");

    };

    //Dialog actions start
    moveUp = () => this.setState({ offset: -100 });

    resetPosition = () => {
        this.setState({ offset: 0 });
        this.props.navigation.goBack();
    }

    //open the dialog 
    openModal = () => {
        this.setState({ open: true })

    };
    //close the dialog
    closeModal = () => {
        this.setState({ open: false });
        this.props.navigation.goBack();
    }
    //Dialog actions end
    componentDidMount() {
        log("Debug", "Module Add screen is loaded");
        this.openModal();
        // this.getSprints();

        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ cropcode: res });
            console.warn(this.state.cropcode);
        });

        // this.setModalVisible(!this.state.modalVisible);
    }

    //Refresh data
    onRefresh() {
        this.setState({ isFetching: true }, function () { this.add() });
    }

    userTaskUpdate(){
        if((completeStatus === 'pending' && activeStatus === '0')){
            this.userTaskUpdate1()

        }
        else{
            this.userTaskUpdate2()

        }
    }


     // if dependency not exit this method will executes
  userTaskUpdate1 = () => {
    log("Info", "updateActiveTaskStatus() method is used to make subtask as active");
    // const { item, taskStatus, description, taskcompleteStatus, } = this.props;
    const { item, } = this.state;
    const message = "User story in progress";
    //Time();
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == "undefined" || state.type == "unknown") {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      } else {
        AsyncStorage.getItem("cropcode", (err, res) => {
          const cropcode = res;
          AsyncStorage.getItem("empId", (err, res) => {
            const empId = res;
            fetch(API + 'manage_userstories.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  action: "activate_user_story",
                  story_id: this.state.taskid,
                  empId: empId,
                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                // console.log(JSON.stringify(responseJson))
                // alert( JSON.stringify(responseJson))

                console.warn(responseJson)
                if (responseJson.status === 'true') {
                //   alert(responseJson.message)
                  this.addCommentUserStory(message, this.state.taskid, "1")

                }
              
                 else {

                //   new Pending().onRefresh();

                //   alert("You not able active this task untill complete your activated task");

                  log("Warn", "You not able active this task untill complete your activated task");
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "Error in making subtask as active");
              });
          });
          this.closeModal();
        });
      }
    });
  }
    //check dependency 
    // userTaskUpdate = () => {
    //     log("Info", "UserPendingMyTask:userTaskUpdate() method is used to check dependency");
    //     const { item, } = this.state;
    //     const dependency = item.dependencyId;
    //     if (dependency == "NA") {
    //         this.updateStatus();
    //     } else {
    //         this.updateStatus();
    //         // alert("You can't update until your dependency task completed");
    //     }
    // }

    // if dependency not exit this method will executes
    userTaskUpdate2 = () => {
        const message = "User story is done/completed";
        log("Info", "UserPendingMyTask:userTaskUpdate() method is used to update  pending subtasks tasks at user side");
        const { item, taskStatus, description, taskcompleteStatus } = this.state;
        //task completed status 
        // if (taskcompleteStatus == 100) {
        //   this.setState({
        //     taskStatus: (Number(taskcompleteStatus)),
        //     taskcompleteStatus: (Number(taskcompleteStatus) / 100).toString(),
        //   })
        // }
        // else {
        //   this.setState({
        //     taskStatus: (Number(taskcompleteStatus) * 100)
        //   })
        // }
        //Checking the Internet Connections
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == "undefined" || state.type == "unknown" || state.type == "cell") {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
            } else {
                // if (this.isValid()) {
                // const taskcomplete = this.state.taskcompleteStatus;
                AsyncStorage.getItem("cropcode", (err, res) => {
                    const cropcode = res;

                    AsyncStorage.getItem("userToken", (err, res) => {
                        const userToken = res;

                        fetch(API + 'manage_userstories.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    crop: cropcode,
                                    action: "update",
                                    task_id: this.state.id,

                                    task_status: 100,
                                    task_status_desc: "completed",
                                    //   task_complete_status: taskcomplete,
                                    task_complete_status: 1,
                                    //   mainTaskId: item.mainTaskid,
                                    empId: userToken,
                                })

                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.log(JSON.stringify(responseJson))
                                // alert(JSON.stringify(responseJson))
                                if (responseJson.status === 'True') {
                                    alert("Your User Story is Updated Successfully");
                                    this.addCommentUserStory(message, this.state.taskid, "1")

                                    this.setState({ open: false });
                                    this.setState({ itemPressedDisabled: false })

                                    //Navigate to AddModule screen
                                    // this.props.navigation.navigate("UserTaskStatus1", );
                                    this.props.navigation.navigate("UserBacklog", );

                                    // Snackbar.show({
                                    //     title: 'Your User Story is Updated Successfully',
                                    //     backgroundColor: 'green',
                                    //     duration: Snackbar.LENGTH_LONG,
                                    // });
                                
                                    // this.addCommentUserStory(message, item.id, "3")
                                    // this.getSubtaskListPending();//to get the user pending my task list

                                    // this.setState({
                                    //     isLoading: false,
                                    //     dataSource: responseJson.data,
                                    //     isFetching: false
                                    // }, function () {
                                    // });

                                    // this.onRefresh();

                                }
                                
                                else if(responseJson.status === 'false') {
                                    alert(responseJson.message)
                                }
                                else {
                                   
                                    log("Info", "no pending my tasks at user side");
                                }

                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "Error in getting of pending my tasks at user side");
                            });
                    });
                });
                this.closeModal();
            }
            //   }
        });
    }


  // if dependency not exit this method will executes
  addCommentUserStory = (message, subtaskid, cardId) => {
    console.warn("message" + message)
    console.warn("subtaskid" + subtaskid)
    console.warn("cardId" + cardId)
    AsyncStorage.getItem("projectId", (err, res) => {
      const projectId = res;

      log("Info", "updateActiveTaskStatus() method is used to make subtask as active");
      // const { subtaskid, taskStatus, description, taskcompleteStatus, } = this.props;
      // const message="User story in progress";
      //Time();
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == "undefined" || state.type == "unknown") {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
            AsyncStorage.getItem("userToken", (err, res) => {
              const empId = res;
              console.warn("empId" + empId)
              fetch(API + 'story_comments.php',
                {
                  method: 'POST',
                  headers: {
                    Accept: 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    corp: cropcode,
                    action: "add_story_comment",
                    storyId: subtaskid,
                    userId: empId,
                    message: message,
                    cardId: cardId,
                    projectId: projectId

                  })
                })
                .then((response) => response.json())
                .then((responseJson) => {
                  console.warn(responseJson)
                  if (responseJson.status === 'True') {
                    // this.props.navigation.navigate('Pending');
                    // this.onRefresh();
                    // this.getSubtaskListPending();
                    // alert("Success");
                  } else {

                    // new Pending().onRefresh();

                    // alert("You not able active this task untill complete your activated task");

                    log("Warn", "You not able active this task untill complete your activated task");
                  }
                })
                .catch((error) => {
                  console.error(error);
                  log("Error", "Error in making subtask as active");
                });
            });
          });
        }
      });
    });
  }


    //Validatios
    isValid() {
        const { sprintId, } = this.state;
        let valid = false;

        if (sprintId.length === 0) {
            log("Warn", "Select Sprint");
            this.setState({ error1: 'Select Sprint ' });
        }


        else {
            valid = true;
        }
        return valid;
    }


    render() {

        return (
            <Modal
                offset={this.state.offset}
                closeOnTouchOutside={false}
                open={this.state.open}
                modalDidOpen={this.modalDidOpen}
                modalDidClose={this.modalDidClose}
                style={{ alignItems: "center" }} >

                <View style={{ alignItems: "center", }}>
                    <Toast ref="toast" />
                    <Text>Change Status</Text>

                    <View style={{ paddingTop: 10, width: '100%', marginLeft: '5%' }}>
                        <Text style={{ fontSize: 15 }}>{this.state.tasktitle}  Will be moved to Doing</Text>
                        {/* <Text>{(this.props.cropcode).substring(0, 3).toUpperCase()}</Text> */}

                    </View>

                </View>

                <View style={{ flexDirection: 'row', alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>
                    <TouchableOpacity style={styles.opensave} onPress={this.userTaskUpdate2} disabled={this.state.itemPressedDisabled}>
                        <Text style={{ color: 'white' }}>CONFIRM</Text>
                    </TouchableOpacity>
                    <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                        <Text style={{ color: 'white' }}>CANCEL</Text>
                    </TouchableOpacity>
                </View>
            </Modal>


        );

    }

}
//Styles for UI
const styles = StyleSheet.create(
    {
        MainContainer:
        {
            flex: 1,
            width: Dimensions.get('window').width,
            height: Dimensions.get('window').height
        },
        bottomView: {
            flexDirection: 'row',
            justifyContent: 'center',
            position: 'absolute',
            height: FOOTER_MAX_HEIGHT,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundColor: 'black',
            alignItems: 'center'
        },

        textStyle: {
            color: '#fff',
            fontSize: 18
        },
        container: {
            flex: 1,
            width: '90%',
            paddingLeft: hp('2%'),
        },
        footer: {
            position: 'absolute',
            flex: 0.1,
            left: 0,
            right: 0,
            bottom: -10,
            backgroundColor: 'green',
            flexDirection: 'row',
            height: 80,
            alignItems: 'center',
        },
        bottomButtons: {
            alignItems: 'center',
            justifyContent: 'center',
            flex: 1,
        },
        footerText: {
            color: 'white',
            fontWeight: 'bold',
            alignItems: 'center',
            fontSize: 18,
        },
        buttonContainer: {
            width: wp('90%'),
            alignSelf: 'baseline',
            marginBottom: 25,
            color: '#d2691e',
            marginLeft: 4,



        },
        signupButton: {

            backgroundColor: '#ffffff',
        },
        subcontainer: {
            flex: 2,
            flexDirection: 'row',
            paddingTop: 40
        },
        signUpText0: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText1: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            paddingLeft: 10,
        },
        end: {

            alignItems: 'flex-end',

        },
        end1: {
            flex: 2,
            height: '50%',
            paddingTop: 20,
            justifyContent: 'space-between',

            flexDirection: 'row',
        },
        s: {
            justifyContent: 'center',

            backgroundColor: '#ed7070',
            shadowOffset: { width: 50, height: 50 },
            alignItems: 'center',
            width: wp('40%'),
            height: hp('12%'),

        },
        signUpText2: {
            fontSize: 10,
            marginLeft: 200,
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            //  marginRight: 10,
            //textAlign: "right"

        },
        signUpText3: {

            fontSize: 12,
            paddingTop: 10,
            paddingLeft: 10,

            alignItems: 'center',
        },
        signUpText4: {
            fontSize: 12,
            paddingTop: 10,


            alignItems: 'center',
        },
        signup: {
            //paddingTop:20,
            color: "#FFF",

        },
        boxone: {
            flex: 1,
            marginTop: 5,

        },
        boxtwo: {
            flex: 1,

        },
        boxthree: {
            flex: 1,

        },
        box: {
            flexDirection: 'row',
            position: 'relative',
            marginBottom: 10,


        },
        signUpText: {
            fontSize: 20,
            justifyContent: 'center',


            color: 'white',
            alignSelf: 'center',
        },
        opencancel: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
        opensave: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
    });