/*
FileName:EpicUserStory.js
Version:1.0.0
Purpose:getting all the user stories from epic
Devloper:Mahesh
*/
import React, { Component } from 'react';
import moment from "moment";
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, LayoutAnimation, UIManager, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert, TouchableWithoutFeedback } from 'react-native';
import { Left, Button, Container, Header, Body, Title, Content, Item, Input, Right, Subtitle } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import SearchableDropdown from 'react-native-searchable-dropdown';
import Icon from 'react-native-vector-icons/FontAwesome';
import { API } from "../WebServices/RestClient";
import { Collapse, CollapseHeader, CollapseBody } from "accordion-collapse-react-native";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import Toast from 'react-native-whc-toast';
import { NavigationEvents } from 'react-navigation';
import {
  BallIndicator,
  BarIndicator,
  DotIndicator,
  MaterialIndicator,
  PacmanIndicator,
  PulseIndicator,
  SkypeIndicator,
  UIActivityIndicator
} from 'react-native-indicators';
import {TASKNO,ASSIGNED_TO,ASSIGNED_BY,ADDSUBTASK,ADDMAINTASK ,TASKTITLE, DESCRIPTION, TARGETTIME, TASKSTATUS, TIMELEFT, MODIFY,VIEWSUBTASK,DELETE} from '../CommonComponents/Header';

FOOTER_MAX_HEIGHT = 50
FOOTER_MIN_HEIGHT = 40

class ListItem extends React.Component {

  constructor(props) {
    super(props)

    this.state = {
      expanded: false,
      deletevisibility: false,
      dataSource2:[]
    }
    this.getMessages();
    if (Platform.OS === 'android') {
      UIManager.setLayoutAnimationEnabledExperimental(true);
    }
  }
  changeLayout = () => {
    LayoutAnimation.configureNext(LayoutAnimation.Presets.easeInEaseOut);
    this.setState({ expanded: !this.state.expanded });
  }
  componentDidMount() {

    this.VisibleActions();
  }
  //Visable actions by role
  async VisibleActions() {

    AsyncStorage.getItem("emp_role", (err, res) => {

      //Alert.alert(res);

      if (res == 'Emp' || res == 'Manager' || res == 'Approver') {

        this.setState({ deletevisibility: true });
      } else {

        this.setState({ deletevisibility: false });
      }

    });

  }


  getMessages() {
    log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
    // const groupId = this.state.subtaskId;
    // console.warn("getmessages");
    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      this.setState({ userid: userToken });
      // console.warn("userToken"+userToken)
      // console.warn("cropcode"+cropcode)

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + "mainTaskChat.php",
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({

                action: "getAllTaskMessages",
                corp_code: cropcode,
                // sendBy: userToken,


              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              // console.warn("Messages For chat application" + JSON.stringify(responseJson.data));

              // console.warn("Messages from users" + JSON.stringify(responseJson))
              // console.warn("Send By Name" + JSON.stringify(responseJson.data))
              if (responseJson.status === 'True') {

                // console.warn("Setted Data")



                this.setState({
                  dataSource2: responseJson.data,
                });
                // console.warn("Method data" + responseJson.data.sendBy)
              }
              else {
                // console.warn("Empty  Data")
                this.setState({
                  dataSource2: '',
                });
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "getting task related messages error");
            });

        }
      });
    });
  }


 //Navigates to TaskChat Screen
 TaskChat(taskid,action,msgCount) {
  // console.warn("msgCount"+msgCount);
  // console.warn("taskid"+taskid);
  log("Info", "UserPendingMyTasks:TaskChat(item, index) used to navigate to taskchat")
  this.props.navigation.navigate("TaskChat", { id: taskid, action: "maintask",sno:msgCount });
}


  render() {
    const { item } = this.props;

    let button;

    if (this.state.deletevisibility === false) {
      button =
        <TouchableOpacity onPress={this.props.DeleteMainTaskAction}>
          <View style={{ width: wp('14%'), backgroundColor: 'red', marginRight: 5 }}>
            <Text style={{ color: '#fff', textAlign: 'center', fontSize: 13 }}>{DELETE}</Text>
          </View>
        </TouchableOpacity>;
    } else {
      button = null;
    }

        // var data1=this.state.dataSource1;
        const getMessagesCount = (id, msg, empId) => {
          //  console.warn("ids"+JSON.stringify(data1) +id)
    
          //  var msg=this.state.dataSource1;
          // console.warn("Datasource and id send by"+JSON.stringify(data1.sendBy))
          // let msgCount = data1.filter(message => message.sendBy === id).map((messages, i) => {
            let msgCount = msg.filter(message => message.readBy.split(",").indexOf(empId) === -1 && message.messagedBy !== empId && message.groupId === id  ).map((messages, i) => {
    
            return i,messages
    
          })
    
          // console.warn("iiiiiiii" + id)
          // console.warn("msgcount"+msgCount)
    
          return (
            // console.warn("iiiiiiii" + msgCount),
            <View>
              <Text style={{ color: 'red' }}> {msgCount.length > 0 ? msgCount.length : null} </Text>
              {/* {msgCount.length > 0 ? msgCount.length : null} */}
              {
                msgCount.length > 0 ?
    
                  <Icon name="comments" style={{ color: '#808080', paddingRight: 5, }} size={25} onPress={() => { this.TaskChat(id,"maintask",msgCount) }} />
    
                  :
                  <Icon name="comments" style={{ color: '#808080', paddingRight: 5,}} size={25} onPress={() => { this.TaskChat(id,"maintask",msgCount) }} />
    
    
              }
    
            </View>
          )
    
        }
    
    


    return (
      <View>
        <View style={[item.taskStatus == 100 ? styles.container1 : styles.container]}>
          <View style={styles.boxheader}>
            {/* <Collapse style={styles.container}> */}
            {/* <Collapse style={[item.taskStatus ==100 ? styles.container1 : styles.container]}> */}
            <TouchableOpacity activeOpacity={0.8} onPress={this.changeLayout} >
              {/* <CollapseHeader style={styles.boxheader}> */}



              <View style={{ flexDirection: 'row' }}>
                <Text style={styles.signUpText0} >{TASKNO}:</Text>
                <Text style={styles.signUpText1} >{item.story_id.substring(0, 5).toUpperCase()}</Text>
                <Text style={styles.signUpText2}> {item.assignedDate}</Text>
                <View style={{marginLeft:'40%'}}>
                {getMessagesCount( item.us_id,this.state.dataSource2,this.props.empId)}
                </View>
              </View>

             


              <View style={{ flexDirection: 'row', marginRight: 35, width: wp('65%') }}>
                <Text style={styles.signUpText4} >{TASKTITLE}:</Text>
                <Text style={styles.signUpText3text} >{item.story_title}</Text>
                
              </View>

              {/* </CollapseHeader> */}
            </TouchableOpacity>
            <View style={{ height: this.state.expanded ? null : 0, overflow: 'hidden' }}>
              <CollapseBody>
              <View style={{ flexDirection: 'row', width: wp('85%'), paddingRight: 25 }}>
                  <Text style={styles.signUpText4} >Epic Name:</Text>
                  <Text style={styles.signUpText3} >{item.epic_name}</Text>
                </View>
                <View style={{ flexDirection: 'row', width: wp('85%'), paddingRight: 25 }}>
                  <Text style={styles.signUpText4} >Sprint Name:</Text>
                  <Text style={styles.signUpText3} >{item.sprint_desc}</Text>
                </View>

                <View style={{ flexDirection: 'row', width: wp('80%'), paddingRight: 25 }}>
                  <Text style={styles.signUpText4} >{DESCRIPTION}:</Text>
                  <Text style={styles.signUpText3} >{item.story_desc}</Text>
                </View>
                <View style={{ flexDirection: 'row', width: wp('70%'), paddingRight: 25 }}>
                  <Text style={styles.signUpText4} >Acceptance Criteria:</Text>
                  <Text style={styles.signUpText3} >{item.acceptance_criteria}</Text>
                </View>
                <View style={{ flexDirection: 'row', width: wp('85%'), paddingRight: 25 }}>
                  <Text style={styles.signUpText4} >Story Points:</Text>
                  <Text style={styles.signUpText3} >{item.story_points}</Text>
                </View>
                <View style={{ flexDirection: 'row', width: wp('90%') }}>
                  <View style={{ flexDirection: 'row', width: wp('50%'), paddingRight: 25 }}>
                    <Text style={styles.listgap} >{TARGETTIME}:</Text>
                    <Text style={styles.signUpText3} >{moment(item.target_date).format('MM.DD.YYYY hh:mm:ss')}</Text>
                  </View>
                  {/* <View style={{ flexDirection: 'row', width: wp('40%'), paddingRight: 25 }}>
                    <Text style={styles.listgap} >{TASKSTATUS}:</Text>
                    <Text style={styles.signUpText3} >{item.taskStatus}%completed</Text>
                  </View> */}
                </View>
                <View style={{ flexDirection: 'row', }}>
                  <View style={{ flexDirection: 'row', paddingRight: 25, width: wp('50%') }}>

                    <Text style={styles.signUpText4} >{ASSIGNED_TO}:</Text>
                    <Text style={styles.signUpText3} >{item.assignedto} </Text>
                  </View>
                 
                </View>
                <View style={{ flexDirection: 'row', }}>
                
                  <View style={{ flexDirection: 'row', paddingRight: 25, width: wp('45%') }}>
                    <Text style={styles.listgap} >{ASSIGNED_BY}:</Text>
                    <Text style={styles.signUpText3} >{item.assignedby}</Text>
                  </View>
                </View>

                <View style={{ flexDirection: 'row', width: wp('90%') }}>
                  
                  <View style={{ flexDirection: 'row', width: wp('40%'), paddingRight: 25 }}>
                    <Text style={styles.listgap} >{TASKSTATUS}:</Text>
                    <Text style={styles.signUpText3} >{item.taskStatus}%completed</Text>
                  </View>
                </View>

                {/* <View style={{ flexDirection: 'row', paddingRight: 25, }}>
                  <Text style={styles.signUpText4} >{TIMELEFT}:</Text>
                  <Text style={styles.signUpText3} >{item.timeleft}</Text>
                </View> */}

                <View style={{ flexDirection: 'row', justifyContent: 'flex-end', alignItems: 'center', paddingTop: 15 }}>

                  {/* action Visable by role */}
                  {button}


                  {/* <TouchableOpacity onPress={() => this.props.AddSubTask()} style={{ width: wp('22%'), backgroundColor: 'black', }}>
                    <Text style={{ color: '#fff', textAlign: 'center' }}>{ADDSUBTASK}</Text></TouchableOpacity> */}
                  {/* <TouchableOpacity onPress={() => this.props.ViewSubTasks()} style={{
                    width: wp('25%'), backgroundColor: '#00A2C1',
                    marginLeft: 5
                  }}>
                    <Text style={{ color: '#fff', textAlign: 'center' }}>{VIEWSUBTASK}</Text></TouchableOpacity> */}
                    <TouchableOpacity style={{ width: 70, backgroundColor: 'black', marginLeft: 10, marginRight: 10, }} onPress={() => this.props.ReassignStory()}>
            <Text style={{ color: 'white' }}>Reassign</Text>
          </TouchableOpacity>


                  {/* <TouchableOpacity onPress={this.props.ModifyMaintask} style={{ width: wp('15%'), backgroundColor: 'black', marginLeft: 5, marginRight: 5 }}> */}
                    {/* <Text style={{ color: '#fff', textAlign: 'center', marginRight: 5 }}>{MODIFY}</Text></TouchableOpacity> */}
                  {/* <Icon size={22} style={{ paddingLeft: 10, paddingTop: 4 }} name="comments-o" onPress={() => { this.props.TaskChat() }}></Icon> */}
                </View>
              </CollapseBody>
            </View>
            {/* </Collapse> */}
          </View>
        </View>
        <View style={{ backgroundColor: '#474545', height: 1 }}>
        </View>
      </View>
    )
  }
}

export default class AddMainTask extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      open: false,
      ProjectTitle: "",
      ProjectDescription: "",
      role: '',
      userToken: '',
      isLoading: true,
      dataSource: [],
      isFetching: false,
      modalVisible: false,
      addTask: 'add',
      modifyTask: 'modify',
      moduleId: this.props.navigation.state.params.moduleId,//getting module id
      ideaid: this.props.navigation.state.params.idea_id,//getting idea id
      moduledesc: this.props.navigation.state.params.moduledesc,//getting moduledesc
      idea_title: this.props.navigation.state.params.idea_title,//getting ideatitle
      dependencyid: 'NA',
      person: '',
      subTask: '',
      description: '',
      days: '',
      time: '',
      error1: '', error2: '', error3: '', error4: '', error5: '',

    };
    
  }

  //getting the role and id 
  modalDidOpen = () => {
    AsyncStorage.getItem("role", (err, res) => {
      this.setState({ role: res });

    });
    AsyncStorage.getItem("userToken", (err, res) => {
      this.setState({ userToken: res });

    });

  }


  componentDidMount() {
    log("Debug", "Main Task Screen is loaded");
    this.add();

    AsyncStorage.getItem("userToken", (err, res) => {
      this.setState({ empId: res });
      console.warn(this.state.empId);
    });
  }
  //Dialog actions end

  //get ModuleList
  add() {

    this.getModulesList();
  }
  //Refresh the maintask list
  onRefresh() {
    this.setState({
      // dataSource: [],
    })
    this.add();
  }

  componentWillReceiveProps(nextProps) {
    // console.log(nextProps);
    // console.log("re loading...........")
    //this.getModulesList();
  }

  //getModulesList for Projects
  getModulesList() {

    // const { moduleId } = this.state;
    const { ideaid } = this.state;
    // alert(ideaid)

    // console.log("moduleid" + moduleId + "ideaid" + ideaid);

    AsyncStorage.getItem("cropcode", (err, res) => {
      log("Info", " getModulesList(cropcode) is used to get all module list");

      const cropcode = res;
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;

      console.log(cropcode)
      // console.log(moduleId)
      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',

            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'epic_info.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                ideaId : ideaid,

                // moduleId: moduleId,
                crop: cropcode,
                action:"maintasks",
                projectId:projectId,

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
                //  alert(JSON.stringify(responseJson));
              console.warn("User Story Data"+JSON.stringify(responseJson))


              if (responseJson.status === 'True') {

                // console.warn("Setted Data")



                this.setState({
                  isLoading: false,
  
                  dataSource: responseJson.data,
                  isFetching: false
                }, function () {
  
                });
                // console.warn("Method data" + responseJson.data.sendBy)
              }
              else {
                log("Info", "no pending my tasks at user side");
                this.arrayholder = [];
                this.setState({
                  isLoading: false,
                  dataSource:[],
                })
                Snackbar.show({
                  title: 'No User Stories',
                  backgroundColor: '#3BB9FF',
                  duration: Snackbar.LENGTH_LONG,
                });
              }


              // console.log(responseJson)
              //  this.refs.toast.showBottom('Main Task Added');
              // this.setState({
              //   isLoading: false,

              //   dataSource: responseJson.data,
              //   isFetching: false
              // }, function () {

              // });
            })
            .catch((error) => {
              console.error(error);
              log("Error", "Adding project error");
            });
        }
      });
      //this.refs.toast.showCenter('Main Task Added');
    });
  });

  }
  //Action for Adding subtask
  AddSubTask(item, index) {
    console.log(item);
    console.log(index);
    log("Info", "AddSubTask method is used to move Add Main Task  to Add SubTask Modal screen");
    this.props.navigation.navigate('AddSubTaskModal', { action: 'add',IdeaId:item.ideaid, moduleId: item.moduleId, taskid: item.id });

  }

 //Navigate to Project Modify Screen
//  ReassignStory(item, index) {
//   console.log(item);
//   console.log(index);
//   log("Info", "ReassignStory() method is used to move Add Module to Add ModifyUserStory screen");
//   this.props.navigation.navigate('ModifyUserStory', { action: 'reassign', assigntto: item.toEmp, projectitle: item.projectName, idea_id: item.idea_id, moduleId: item.moduleId, taskid: item.id, tasktitle: item.taskTitle, taskdescription: item.taskDesc, acceptanceCriteria: item.acceptanceCriteria, storyPoints: item.storyPoints, priorityLevel: item.priorityLevel });

// }



//Navigate to Project Modify Screen
ReassignStory(item, index) {
  console.log(item);
  console.log(index);
  log("Info", "ReassignStory() method is used to move Add Module to Add ModifyUserStory screen");
  this.props.navigation.navigate('ModifyUserStory', { action: 'reassign',assigntto:item.assignedto, assignedto: item.assignedTo, projectitle: item.epic_name, ideaid: item.epic_id, moduleId: item.moduleId, taskid: item.story_id, tasktitle: item.story_title, taskdescription: item.story_desc, acceptanceCriteria: item.acceptance_criteria, storyPoints: item.story_points, priorityLevel: item.priority_level });

}
  // Navigaete ViewSubTasks screen
  ViewSubTasks = (item, index) => {
    const { id } = this.state;
    console.log(item.id);
    console.log(index);
    //alert(item.id);
    log("Info", "ViewSubTasks method is used to move Add Main Task  to ViewSubTasks screen to see the  sub tasks");
    this.props.navigation.navigate("ViewSubTasks", { taskId: item.id });

  }

  //Modify Maintask start
  ModifyMaintask(item, index) {

    const { moduleId } = this.state;
    const { ideaid } = this.state;
    const { modifyTask } = this.state;
    console.log("moduleid" + moduleId + "ideaid" + ideaid + "action" + modifyTask + "mid" + item.id);
    log("Info", "ModifyMaintask method is used to move Add Main Task  to AddTask screen ");
    this.props.navigation.navigate("ModifyMaintask", { moduleid: moduleId, IdeaId: ideaid,toEmp:item.toEmp, modifyTask: modifyTask, maintaskid: item.id, maintasktitle: item.taskTitle, maintaskdesc: item.taskDesc });

  }
  //Modify Maintask close

  // //Navigates to TaskChat Screen
  // TaskChat(item, index) {
  //   log("Info", "TaskChat method is used to move Add Main Task  to TaskChat screen to view messages and chatting purpose");
  //   this.props.navigation.navigate("TaskChat", { taskid: item.id, action: "maintask" });
  // }


  //Delete MainTask alert start
  DeleteMainTaskAction(item, index) {
    log("Warn", "do you want to delete project");
    Alert.alert(
      'Alert..!',
      'Do you want to delete Task',
      [
        {
          text: 'Cancel',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'OK', onPress: () => this.DeleteMaintask(item.story_id) },
      ],
      { cancelable: false },
    );

  }
  //Delete MainTask  alert end

  //Delete MainTask start
  DeleteMaintask(maintaskid) {
    log("Info", "DeleteMaintask() method is used to delete project");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          console.log(state.type);
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'manageMaintasks.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({

                action: 'maintaskdelete',
                mainTaskId: maintaskid,
                crop: cropcode
              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.log(responseJson)

              if (responseJson.status === 'True') {

                this.setState({
                  isLoading: false,
                  isFetching: false
                }, function () {

                });

              } else if (responseJson.status === 'false') {

                Alert.alert(responseJson.message);
              } else {
                log("Warn", "no projects deleted");

              }


            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in project deleting");
            });
        }
      });
    });

  }
  //Delete MainTask end


  FlatListItemSeparator = () => {
    return (
      <View
        style={{
          //  height: .5,
          width: "100%",
          backgroundColor: "#000",
        }}
      />
    );
  }



  _listEmptyComponent = () => {
    return (
      <View style={{ width: '90%', height: '80%' }}>
        <Text></Text>
      </View>
    )
  }

  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }

    return (
      <Container>
        {/* <Header
          androidStatusBarColor="#00A2C1"
          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <Left>
            <Icon size={20} name="arrow-left" style={{ color: '#fff' }} onPress={() =>
              this.props.navigation.goBack(null)} />

          </Left>
          <Body style={{ width: wp('80%') }}>
            <Title style={{ color: 'white', fontWeight: '600' }}>{this.state.idea_title}</Title>
          </Body>
          <Right></Right>
        </Header> */}
        <View style={styles.MainContainer}>
          <NavigationEvents
            onDidFocus={() => this.onRefresh()}
          />
          <Toast ref="toast" />
          <View style={{ height: '90%' }}>

            <FlatList

              extraData={this.state}
              keyExtractor={this._keyExtractor}
              renderItem={this._renderItem}

              data={this.state.dataSource}

              onRefresh={() => this.onRefresh()}
              refreshing={this.state.isFetching}

              ItemSeparatorComponent={this.FlatListItemSeparator}
              renderItem={({ item, index }) =>
                <View>

                  <ListItem navigation={this.props.navigation}
                    item={item}
                    empId={this.state.empId}
                    ModifyMaintask={() => this.ModifyMaintask(item, index)}//modify maintask
                    AddSubTask={() => this.AddSubTask(item, index)}//add subtask
                    ReassignStory={() => this.ReassignStory(item, index)}//For Reassign Sprint 
                    ViewSubTasks={() => this.ViewSubTasks(item, index)}//view subtasks list
                    TaskChat={() => this.TaskChat(item, index)}//For Chat
                    DeleteMainTaskAction={() => this.DeleteMainTaskAction(item, index)}//delete the maintask
                  />
                </View>
              }
              keyExtractor={item => item.id}
              ListEmptyComponent={this._listEmptyComponent}
            />

          </View>
          <TouchableOpacity onPress={() => this.props.navigation.navigate("AddStory", { moduleid: this.state.moduleId, IdeaId: this.state.ideaid, addTask: this.state.addTask })} style={styles.bottomView}>
            <View style={styles.bottomView} >
              <Text style={styles.textStyle}>{ADDMAINTASK}</Text>
            </View>
          </TouchableOpacity>
        </View>
      </Container>

    );

  }

}
const styles = StyleSheet.create(
  {
    MainContainer:
    {
      paddingTop: 4,
      flex: 1,
      width: Dimensions.get('window').width,
      height: Dimensions.get('window').height,
      backgroundColor: '#F8F8F8'
    },
    bottomView: {
      flexDirection: 'row',
      justifyContent: 'center',
      position: 'absolute',
      height: FOOTER_MAX_HEIGHT,
      bottom: 0,
      left: 0,
      right: 0,
      backgroundColor: 'black',
      alignItems: 'center'
    },

    textStyle: {
      color: '#fff',
      fontSize: 18,
      backgroundColor: '#00a2c1',
      paddingLeft: 10,
      paddingRight: 10,
      // paddingBottom: 5,
      paddingTop: 5,
      borderRadius: 5,
    },
    container: {
      flex: 1,
      width: '100%',
      paddingLeft: hp('2%'),
      backgroundColor: '#fff'
    },
    container1: {
      flex: 1,
      width: '100%',
      paddingLeft: hp('2%'),
      // backgroundColor: '#EAFAF1',
      backgroundColor:'#dcf2cb',
    },
    footer: {
      position: 'absolute',
      flex: 0.1,
      left: 0,
      right: 0,
      bottom: -10,
      backgroundColor: 'green',
      flexDirection: 'row',
      height: 80,
      alignItems: 'center',
    },
    bottomButtons: {
      alignItems: 'center',
      justifyContent: 'center',
      flex: 1,
    },
    footerText: {
      color: 'white',
      fontWeight: 'bold',
      alignItems: 'center',
      fontSize: 18,
    },
    buttonContainer: {
      width: wp('90%'),
      alignSelf: 'baseline',
      marginBottom: 10,
      color: '#d2691e',
      marginLeft: 4,



    },
    signupButton: {

      backgroundColor: '#ffffff',
    },
    subcontainer: {
      flex: 2,
      flexDirection: 'row',
      paddingTop: 40
    },
    signUpText0: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,
      // fontWeight:'bold'

    },
    signUpText1: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,
      // fontWeight:'bold',
      width: '30%',

    },
    end: {

      alignItems: 'flex-end',

    },
    end1: {
      flex: 2,
      height: '50%',
      paddingTop: 20,
      justifyContent: 'space-between',

      flexDirection: 'row',
    },
    s: {
      justifyContent: 'center',

      backgroundColor: '#ed7070',
      shadowOffset: { width: 50, height: 50 },
      alignItems: 'center',
      width: wp('40%'),
      height: hp('12%'),

    },
    signUpText2: {
      fontSize: 12,
      color: 'black',
      paddingTop: 10,

    },
    signUpText3: {

      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 5,
      //width: '50%',
      color: 'black',
      // alignItems: 'center',
    },
    signUpText3text: {
      color: 'black',
      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 10,
      //fontWeight: 'bold',


      alignItems: 'center',
    },


    signUpText03: {
      width: '25%',
      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 10,
      color: 'black',

      alignItems: 'center',
    },
    signUpText4: {
      fontSize: 12,
      paddingTop: 10,
      color: 'black',


      //alignItems: 'center',
    },
    listgap: {
      fontSize: 12,
      paddingTop: 10,
      color: 'black',


      alignItems: 'center',
    },


    listgap1: {
      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 70,
      color: 'black',
      // paddingRight:40,

      alignItems: 'center',
    },
    signup: {
      //paddingTop:20,
      color: "#FFF",

    },
    boxone: {
      flex: 1,
      marginTop: 5,

    },
    boxtwo: {
      flex: 1,

    },
    boxthree: {
      flex: 1,

    },
    box1: {
      justifyContent: 'space-between',
      flexDirection: 'row',
      position: 'relative',
      // marginBottom: 10,

    },
    box: {
      flexDirection: 'row',
      position: 'relative',
      marginBottom: 10,


    },
    signUpText: {
      fontSize: 20,
      justifyContent: 'center',


      color: 'white',
      alignSelf: 'center',
    },
    boxheader: {
      justifyContent: 'space-between',
      flexDirection: 'column',
      position: 'relative',
      marginBottom: 5,

    },
    opencancel: {
      flex: 1,
      ...Platform.select({
        ios: {
          backgroundColor: 'red', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
        android: {
          backgroundColor: 'red', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
      }),
    },
    opensave: {
      flex: 1,
      ...Platform.select({
        ios: {
          backgroundColor: 'green', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
        android: {
          backgroundColor: 'green', margin: 20, height: 30, alignItems:
            "center", justifyContent: 'center'
        },
      }),
    },
  });