import React, { Component } from 'react';
import {
    Platform, StyleSheet, TextPropTypes, Picker, Text, Button, View, Image, StatusBar, Dimensions, TextInput, Alert,
    KeyboardAvoidingView,
    TouchableWithoutFeedback,
    FlatList,
    Keyboard
} from 'react-native';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import UserDatabase from "../OfflineDB/UserDatabase";
const db = new UserDatabase();


// import Icon from 'react-native-vector-icons/FontAwesome';
import Icon from 'react-native-vector-icons/MaterialIcons';
import Icon1 from 'react-native-vector-icons/Ionicons';

export class HomeIcon extends Component {
    render() {
        return (
            <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                <Icon name="home" size={25} style={{ color: '#fff', }} />

            </View>
        );
    }
}



export class ScannerIcon extends Component {
    render() {
        return (
            <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                <Icon1 name="scan" size={25} style={{ color: '#fff', }} />

            </View>
        );
    }
}

export class PaymentIcon extends Component {
    render() {
        return (
            <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                <Icon name="add-circle" size={25} style={{ color: '#fff', }} />

            </View>
        );
    }
}
export class TodoIcon extends Component {
    render() {
        return (
            <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                <Icon name="content-paste" size={25} style={{ color: '#fff', }} />

            </View>
        );
    }
}
export class CalendarIcon extends Component {
    render() {
        return (
            <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                <Icon name="event" size={25} style={{ color: '#fff', }} />

            </View>
        );
    }
}

export class NotificationIcon extends Component {
    render() {
        return (
            <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                <Icon name="notifications" size={25} style={{ color: '#fff', }} />

            </View>
        );
    }
}
export class ChatIcon extends Component {
    constructor(props) {
        super(props);

        this.state = {
            isLoading: false,
            isVisibleB: false,
            dataSource2: [],
        }

        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
        });

        AsyncStorage.getItem("userToken", (err, res) => {
            this.setState({ empId: res });
        })

    }
    componentDidMount() {
        this.getMessages();
    }
    getMessages() {
        log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            this.setState({ userid: userToken });

            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                }
                else {
                    fetch(API + "squad_chat.php",
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                action: "get_all_messages",
                                sendBy: userToken,
                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            if (responseJson.status === 'True') {
                                this.setState({
                                    dataSource2: responseJson.data,
                                });
                                AsyncStorage.setItem('ChatCount', this.dataSource2.length);
                            }
                            else {
                                this.setState({
                                    dataSource2: [],
                                });
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "getting task related messages error");
                        });

                }
            });
        });
    }
    render() {
        return (
            <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
               {this.state.dataSource2.length === 0 ? null:
                <View style={{backgroundColor:'red',borderRadius:100,width:20,height:20,justifyContent:'center',alignContent:'center',alignItems:'center'}}>
                <Text style={{ color: 'white' }}>{this.state.dataSource2.length}</Text>
                </View>}
                <Icon name="mail-outline" size={25} style={{ color: '#fff', }} />

            </View>
        );
    }
}