/*
FileName:UserManageProjects1.js
Version:1.0.0
Purpose:Getting the List of ApprovedProjects and also verify the project by role and Add RO
Developer:Mahesh, Naveen Kumar (GNK)
*/
import React, { Component } from 'react';
import Icon from 'react-native-vector-icons/FontAwesome';
import {
    Platform, StyleSheet, Text, View, Dimensions, FlatList, TextInput,
    TouchableHighlight, Image, TouchableOpacity, Alert, KeyboardAvoidingView,
    TouchableWithoutFeedback,
    Keyboard
} from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import Toast from 'react-native-whc-toast';
import SearchableDropdown from 'react-native-searchable-dropdown';
// import DropDownPicker from 'react-native-dropdown-picker';
import ModalSelector from 'react-native-modal-selector';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import { NavigationEvents } from 'react-navigation';
import jwt_decode from "jwt-decode";
import Main from '../Maintenance/Main';
const check = new Main()
import UserDatabase from '../OfflineDB/UserDatabase';
const db = new UserDatabase();
import {
    BallIndicator,
    BarIndicator,
    DotIndicator,
    MaterialIndicator,
    PacmanIndicator,
    PulseIndicator,
    SkypeIndicator,
    UIActivityIndicator
} from 'react-native-indicators';
import { PROJECTNO, TITLE, ADDPROJECT, REQUESTED_BY, RELEASEOWNER, PROJECTSTATUS, RO, VERIFY, DELETE } from '../CommonComponents/Header';


class ListItem extends React.Component {


    constructor(props) {
        super(props);
        this.state = {

            roledata: '',


        }

    }

    render() {

        const { item } = this.props;
        const { emp_role, empId, username } = this.props;




        return (

            <View style={Number(item.taskStatus) === 1 ? styles.buttonContainer : styles.buttonContainer1}>
                {/* <TouchableOpacity onPress={this.props.Module}> */}
                <TouchableOpacity onPress={this.props.MainTask}>
                    <View style={styles.signup}>

                        <View style={[styles.buttonContainer, styles.signupButton]} >
                            <View style={styles.box}>
                                <View style={{ flexDirection: 'row', width: wp('65%') }}>
                                    <Text style={styles.signUpText0} >Kidos Description : </Text>

                                    <Text style={styles.signUpText1} >{item.kudo_description}</Text>

                                </View>
                                {/* <Text style={styles.signUpText2} > {item.acceptedDate}</Text> */}
                            </View>




                            <View style={{ flexDirection: 'row', paddingRight: 25, }}>
                                <Text style={styles.signUpText4} >Description: </Text>
                                <Text style={styles.signUpText9} >{item.description}</Text>
                            </View>


                            <View style={{ flexDirection: 'row', paddingRight: 25, }}>
                                <Text style={styles.signUpText4} >Kudos Award:</Text>
                                <Text style={styles.signUpText99} >{item.kudos_award}</Text>
                            </View>


                            <View style={{ flexDirection: 'row', paddingRight: 25, }}>
                                <Text style={styles.signUpText4} >Awarded By: </Text>
                                <Text style={styles.signUpText9} >{item.awardedby}</Text>
                            </View>

                            <View style={{ flexDirection: 'row', paddingRight: 25, }}>
                                <Text style={styles.signUpText4} >Date of Award: </Text>
                                <Text style={styles.signUpText9} >{item.award_date}</Text>
                            </View>

                        </View>
                        <View style={{ backgroundColor: 'grey', height: 0.5 }}>

                        </View>
                    </View>
                </TouchableOpacity>
            </View>

        )
    }
}
export default class KudosPoints extends Component {
    static navigationOptions = () => {
        return {
            tabBarOnPress({ navigation, defaultHandler }) {
                navigation.state.params.onTabFocus();
                defaultHandler();
                this.onRefresh();
            }
        };
    }
    constructor(props) {

        super(props);
        props.navigation.setParams({
            onTabFocus: this.handleTabFocus
        });
        this.state = {
            isLoading: true,
            dataSource: [],
            isFetching: false,
            ProjectTitle: '',
            kudo_description: 'Kudos Reason *',
            open: false,
            resource: [],
            ideaid: '',
            error1: '',
            error2: '',
            error3: '',
            thanksPointId:'',
            description:'',

        }
        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
            console.warn("squadname" + this.state.squadName);
        });
        this.arrayholder = [];
    }
    handleTabFocus = () => {
        this.onRefresh();
    };
    moveUp = () => this.setState({ offset: -110 });

    resetPosition = () => this.setState({ offset: 0 });

    openModal = () => this.setState({ open: true });

    closeModal = () => {
        //this.props.navigation.goBack();

        this.setState({
            open: false,
            kudo_description: '',
            description: '',
            error1: '',
            error2: '',
            error3: '',
            thanksPointId:'',
        });
    }

    //lifecycle method to call api methods 
    componentDidMount() {
        log("Debug", "User Approved projects screen is loaded");
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.GetStatus();
                this.getApprovedProjectsListOffline() //Offline Approved Projects List
            } else {
                //userApprovedProjects getting
                this.userApprovedProjects()
                this.GetStatus();
            }
        });
        AsyncStorage.getItem("emp_role", (err, res) => {
            this.setState({ emp_role: res });

            console.warn("Emp role" + this.state.emp_role)
        });
        AsyncStorage.getItem("userToken", (err, res) => {
            this.setState({ empId: res });

            // console.warn(this.state.empId);
        });
        AsyncStorage.getItem("userName", (err, res) => {
            this.setState({ username: res });


        });

        this.getResource()


    }


    //For store Agile projects for offline Start
    addAgileProjects(data) {
        console.warn("hello naveen" + JSON.stringify(data));
        db.addAgileProjects(data).then((result) => {
            console.log(result);
        }).catch((err) => {
            console.log(err);
        })
    }
    //For store Agile projects for offline End
    //For Getting offline Project List Start
    getAgileProjects() {
        db.getAgileProjects().then((data) => {
            console.warn("AgileProjectsList" + JSON.stringify(data))
            this.setState({
                data2: data,
            });
        }).catch((err) => {
        })
    }
    //For Getting offline Project List End

    //get project list dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                    this.getAgileProjects(); //Get offline Project List
                } else {

                    fetch(API + 'squads.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({

                            empId: empId,
                            action: 'get_squads',


                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)
                            // alert(responseJson.data)
                            if (responseJson.status == 'True') {
                                // this.setState({
                                //     isLoading: false,
                                //     dataSource1: [...responseJson.data],
                                // }, function () {
                                //     // In this block you can do something with new state.
                                // });
                                console.log("Testing" + JSON.stringify(responseJson.data))
                                const data2 = [];
                                this.addAgileProjects(responseJson.data) //Project list store in offline

                                responseJson.data.map(x => {
                                    data2.push({ label: x.value, value: x.value })
                                })
                                this.setState({
                                    data2: data2,
                                })
                                console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                console.warn(this.state.data2);
                            } else {
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }

    // Update Status of Employee
    UpdateStatus(squadName) {
        // const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
        console.warn("project" + JSON.stringify(squadName));
        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.log(res);

            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;

                // console.log(cropcode);
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                        //for offline project switching start
                        this.setState({
                            squadName: squadName
                        });
                        AsyncStorage.setItem('cropcode', squadName);
                        this.getApprovedProjectsListOffline()
                        //for offline project switching end
                    } else {

                        fetch(API + 'squad_login.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                username: empId,
                                corp: squadName,
                                projectId: projectId

                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'TRUE') {
                                    AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                                    const tokenDetails = jwt_decode(responseJson.jwt);
                                    console.log(tokenDetails.data)
                                    AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                                    // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                                    AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                                    AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                                    AsyncStorage.setItem('userName', tokenDetails.data.userName);
                                    AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                                    AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
                                    AsyncStorage.setItem('projectId', tokenDetails.data.projectId);

                                    if (tokenDetails.data.role === "NA") {
                                        this.props.navigation.navigate('Instruction')
                                    }
                                    // this.props.navigation.navigate('UserProfile');
                                    // console.warn("HI" + empstatus)
                                    this.setState({

                                        squadName: tokenDetails.data.corp,

                                    });
                                    this.userApprovedProjects();
                                    //  alert("Project Changed Successfully")


                                } else {
                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
        });

    }





    //For Approved Projects from offline
    getApprovedProjectsListOffline() {
        AsyncStorage.getItem("cropcode", (err, res) => {
            const projectName = res;
            db.getApprovedProjectsListOffline(projectName, "pending").then((data) => {
                console.warn("Approved ProjectList" + JSON.stringify(data))
                this.setState({
                    dataSource: data,
                    isLoading: false,
                });
                this.arrayholder = data;
            }).catch((err) => {
                console.log(err);
                this.setState = {
                    isLoading: false
                }
            })
        });
    }

    //For store Approved Projects list from offline
    addApprovedProjectsListOffline(data, cropcode, status) {
        db.addApprovedProjectsListOffline(data, cropcode, status).then((result) => {
            this.setState({
                isLoading: false,
            });
        }).catch((err) => {

            this.setState({
                isLoading: false,
            });
        })
    }

    //to get the user approved projects in to the list 
    getResource() {
        log("Info", "UserApprovedProjects:getResource() method is used to get all employee list");
        const { ModuleId } = this.state;
        const { ideaid } = this.state;

        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'usersAwards.php',
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                crop: cropcode,
                                action: "getThanksPoints",
                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(JSON.stringify(responseJson))
                           // alert(JSON.stringify(responseJson))
                            if (responseJson.status === 'True') {
            
                              var empList = [];
                              responseJson.data.map((employee) => {
                                return (
                                  empList.push({
                                    'id': employee.k_id, 'name': employee.kudo_description
                                  })
                                );
                              })
            
                              this.setState({
                                resource: empList,
                              });
                            }
                          })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in listing employees");
                        });
                }
            });
        });
    }

    //to refreshthe data in user apprroved projects
    onRefresh() {
        this.setState({
            dataSource: [],
        })
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getApprovedProjectsListOffline() //Offline Approved Projects List
            } else {
                //userApprovedProjects getting
                this.userApprovedProjects()
            }
        });
    }

    isValid() {
        const { thanksPointId, description  } = this.state;
        let valid = false;

        if (thanksPointId.length === 0) {
            this.setState({ error1: 'Enter Kudos Points ' });
            log("Warn", "Enter Kudos Points");
            // alert("project title should not be empty ");

        }
        //   else if (!this.verifyProjectTitle(ProjectTitle)) {
        //     log("Warn", "project title should start with character");
        //     alert("project title should start with character");
        // }
        // else if (ProjectTitle.trim().length < 5) {
        //     this.setState({ error3: 'Project Title Should contain alteast 5 Characters' });
        //     log("Warn", "Project Title Should contain alteast 5 Characters");
        //     // alert("project title should start with character");

        // }
        else if (description.length === 0) {
            this.setState({ error2: 'Enter  Description ' });
            log("Warn", "Description should not be empty");
            // alert("project description should not be empty");
        }

        else {
            valid = true;
        }
        return valid;
    }//isValid method end

    verifyProjectTitle(ProjectTitle) {
        var reg = /^[^!-\\/:-@\\[-`{-~]+$/;
        return reg.test(ProjectTitle);
    }

    //to add the new project from user 
    addProject = () => {
        log("Info", "addProject() method is used to add new project at user side");
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == "unknown" || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
            }
            else {
                const { thanksPointId, description } = this.state;
                if (this.isValid()) {
                    // alert(ProjectTitle)
                    // alert(ProjectDescription)

                    this.setState({ itemPressedDisabled: true })
                    AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
                        const cropcode = response[0][1];
                        const userToken = response[1][1];
                        console.warn("userToken" + userToken)
                        const role = response[2][1];
                        AsyncStorage.getItem("projectId", (err, res) => {
                            const projectId = res;
                            fetch(API + 'usersAwards.php', {
                                method: 'POST',
                                headers: {
                                    'Accept': 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    thanksPointId: thanksPointId,
                                    description: description,
                                    awardedTo: this.props.navigation.state.params.empId,
                                    awardedBy: userToken, //Async
                                    action: "userawards",
                                    crop: cropcode,//Async
                                    projectId: projectId
                                })
                            }).then((response) => response.json())
                                .then((responseJson) => {
                                    console.log(JSON.stringify(responseJson));
                                    console.log(responseJson);
                                    // alert(JSON.stringify(responseJson))

                                    if (responseJson.status === 'True') {
                                        this.refs.toast.showBottom('Kudos Points Succesfully');
                                        this.setState({ itemPressedDisabled: false })
                                        console.log("done")
                                        this.setState({
                                            open: false,
                                            // ProjectTitle: '',
                                            description: '',
                                        })
                                        this.userApprovedProjects()

                                    }
                                }).catch((error) => {
                                    console.error(error);
                                    log("Error", "error in project adding");
                                });
                        });
                    });
                    this.closeModal();
                }
            }

        });


    };

    //Set the RO
    setRO(ideaid) {
        log("Info", "UserApprovedProjects:setRO(ideaid) method is used to set release owner");
        AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            const role = response[2][1];
            // alert(cropcode+userToken+role)
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'manageIdeas.php',
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                crop: cropcode,
                                action: 'ro',
                                empId: userToken,
                                userType: role,
                                ideaId: ideaid,
                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            //    alert(JSON.stringify(responseJson));
                            console.log(responseJson)
                            if (responseJson.setState == "True") {

                                this.setState({ open: false });
                                this.setState({
                                    isLoading: false,

                                    isFetching: false
                                }, function () {

                                });
                            }


                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in Release owner setting");
                        });
                }
            });
        });
    }

    componentWillReceiveProps(nextProps) {

        this.userApprovedProjects();
    }
    //userApprovedProjects getting
    userApprovedProjects() {
        log("Info", "UserApprovedProjects:setRO(userApprovedProjects() method is used to list the user approved projects");
        AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            const role = response[2][1];
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
                // console.warn(userToken)
                // alert(cropcode+userToken+role)
                NetInfo.addEventListener(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'usersAwards.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    crop: cropcode,
                                    // action: 'approved',
                                    action: 'getUserAwards',
                                    empId: this.props.navigation.state.params.empId,


                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                // alert(JSON.stringify(responseJson));
                                console.warn(JSON.stringify(responseJson));

                                if (responseJson.status === 'True') {
                                    // this.addApprovedProjectsListOffline(responseJson.data, cropcode,"pending") //Store Approved Projects List Offline
                                    this.setState({
                                        isLoading: false,
                                        dataSource: responseJson.data,
                                        isFetching: false
                                    }, function () {

                                    });
                                    //  console.warn(responseJson.taskStatus);
                                    this.arrayholder = responseJson.data;
                                } else {
                                    this.arrayholder = [];
                                    this.setState({
                                        isLoading: false,
                                        dataSource: [],
                                    })
                                    Snackbar.show({
                                        title: 'No UserApproved Projects',
                                        backgroundColor: '#3BB9FF',
                                        duration: Snackbar.LENGTH_LONG,
                                    });
                                }


                            })
                            .catch((error) => {
                                check.Maintenance();
                                console.error(error);
                                log("Error", "error in listing approved projects at user side");
                            });
                    }
                });
            });
        });
    }


    //Relese the owner Navigation
    ReleaseOwner = (item, index) => {
        log("Info", "UserApprovedProjects:ReleaseOwner = (item, index) method used to navigate to Release owner screen");
        this.props.navigation.navigate('ReleaseOwner', { idea_id: item.idea_id });

    }

    //Navigate to AddModule sctreen
    Module = (item, index) => {
        log("Info", "UserApprovedProjects:Module() method is used to move module listing screen");
        console.log(item);
        console.log(index);
        this.props.navigation.navigate("AddModule", { idea_id: item.idea_id, idea_title: item.idea_title });

    }

    //Navigate to maintask screen
    // MainTask(item, index) {

    //   console.log(item);
    //   console.log(index);

    //   console.log(item.ideaId + item.moduleId);
    //   log("Info", "MainTask() method is used to move Add Module to Add MainTask screen");

    //   this.props.navigation.navigate('AddMainTask', { moduleId: item.moduleId, empId: item.empId, ideaid: item.idea_id, moduledesc: item.moduleDesc, idea_title: this.state.idea_title });

    // }
    //Navigate to Manageepic screen
    MainTask(item, index) {

        console.log(item);
        console.log(index);

        console.log(item.ideaId + item.moduleId);
        log("Info", "MainTask() method is used to move Add Module to Add MainTask screen");

        this.props.navigation.navigate('ManageEpic', { moduleId: item.moduleId, empId: item.empId, idea_id: item.idea_id, moduledesc: item.moduleDesc, idea_title: item.idea_title });

    }

    //list seperator
    FlatListItemSeparator = () => {
        return (
            <View
                style={{
                    //  height: .5,
                    width: "100%",
                    backgroundColor: "#000",
                }}
            />
        );
    }
    //List data for Empty
    _listEmptyComponent = () => {
        return (
            <View style={{ width: '90%', height: '80%' }}>
                <Text></Text>
            </View>
        )
    }


    //to filter the search in put by user 
    SearchFilterFunction(text) {
        log("Info", "UserApprovedProjects:SearchFilterFunction(text) method is used for search functionality");
        console.log(text);
        const newData = this.arrayholder.filter(function (item) {
            const idea_id = item.idea_id.toUpperCase()
            const idea_id1 = text.toUpperCase()
            // const created_on = item.created_on.toUpperCase()
            // const created_on1 = text.toUpperCase()
            const idea_title = item.idea_title.toUpperCase()
            const idea_title1 = text.toUpperCase()
            const userName = item.userName.toUpperCase()
            const userName1 = text.toUpperCase()

            return idea_id.indexOf(idea_id1) > -1 ||
                idea_title.indexOf(idea_title1) > -1 ||
                //  created_on.indexOf(created_on1) > -1 ||
                userName.indexOf(userName1) > -1

        })
        this.setState({
            dataSource: newData,
            text: text
        })
    }

    render() {
        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }
        return (
            <KeyboardAvoidingView
                behavior={Platform.OS === "ios" ? "padding" : "height"}
                style={styles.container}
            >
                <TouchableWithoutFeedback onPress={Keyboard.dismiss}>
                    <Container style={{ height: Dimensions.get('window').height }}>
                        <NavigationEvents
                            onDidFocus={() => this.onRefresh()}
                        />

                        <Header
                            androidStatusBarColor="#00A2C1"
                            style={{
                                backgroundColor: '#00A2C1',
                                height: 60,
                                width: Dimensions.get('window').width,
                                borderBottomColor: '#ffffff',
                                justifyContent: 'space-between',
                            }}>
                            <View>
                                <Icon name="arrow-left" size={20} style={{ color: '#fff', paddingTop: 17 }} onPress={() =>
                                    this.props.navigation.goBack(null)} />
                            </View>


                            {/* <View style={{ flexDirection: 'row', marginLeft: 15 }}> */}
                            {/* <View style={{backgroundColor:'white',width:300,borderRadius:20,height:50,marginTop:5}}> */}



                        </Header>
                        {/* </View> */}
                        <Item>
                            <Input placeholder="Search"
                                onChangeText={(text) => this.SearchFilterFunction(text)} />
                            <Icon size={20} style={{ marginRight: 10 }} name="search" />
                        </Item>
                        <View>
                            <Toast ref="toast" />
                            <View style={{ height: '92%' }}>

                                <FlatList

                                    extraData={this.state}
                                    keyExtractor={this._keyExtractor}
                                    renderItem={this._renderItem}
                                    style={{ flex: 1, marginBottom: 50 }}
                                    data={this.state.dataSource}

                                    onRefresh={() => this.onRefresh()}
                                    refreshing={this.state.isFetching}

                                    ItemSeparatorComponent={this.FlatListItemSeparator}
                                    renderItem={({ item, index }) =>
                                        <View style={styles.container} >

                                            <ListItem
                                                item={item}
                                                empId={this.state.empId}
                                                username={this.state.username}
                                                MainTask={() => this.MainTask(item, index)}//For Add Maintask
                                                emp_role={this.state.emp_role}
                                                Module={() => this.Module(item, index)}
                                                ReleaseOwner={() => this.ReleaseOwner(item, index)}
                                            />
                                        </View>
                                    }
                                    keyExtractor={item => item.id}
                                    ListEmptyComponent={this._listEmptyComponent}
                                />

                                <TouchableOpacity onPress={this.openModal} style={styles.bottomView}>
                                    <View style={styles.bottomView} >


                                        <Text style={styles.textStyle}>Award Kudos Points</Text>


                                    </View>
                                </TouchableOpacity>

                            </View>


                            {/* <View>



          </View> */}




                            <Modal
                                // offset={this.state.offset}
                                open={this.state.open}
                                closeOnTouchOutside={false}
                                modalDidOpen={this.modalDidOpen}
                                modalDidClose={this.modalDidClose}
                                style={{ alignItems: "center" }}
                            // disableOnBackPress={false}
                            >

                                <View style={{ alignItems: "center" }}>

                                    <Text>Kudos Points</Text>

                                  
                                    <SearchableDropdown
                                        placeholder={this.state.kudo_description}
                                        onTextChange={text => console.log(text)}
                                        // value={this.state.assignedName}
                                        // onItemSelect={item => item.name}
                                        onItemSelect={(item) => this.setState({ thanksPointId: item.id, kudo_description: item.name })}
                                        placeholderTextColor='black'
                                        containerStyle={{ padding: 5 }}
                                        textInputStyle={{
                                            padding: 12,
                                            borderWidth: 1,
                                            borderColor: '#ccc',
                                            // backgroundColor: '#FAF7F6',
                                        }}
                                        itemStyle={{
                                            padding: 10,
                                            marginTop: 2,
                                            backgroundColor: '#FAF9F8',
                                            borderColor: '#bbb',
                                            borderWidth: 1,
                                        }}
                                        itemTextStyle={{

                                            color: '#222',
                                        }}
                                        itemsContainerStyle={{

                                            // maxHeight: '60%',
                                        }}
                                        items={this.state.resource}

                                        defaultIndex={2}

                                        // placeholder=""

                                        resetValue={false}

                                        underlineColorAndroid="transparent"

                                    />
                                    <Text style={{ color: 'red' }}>{this.state.error1}</Text>


                                    <TextInput placeholder='Kudos Description'
                                        style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 10 }}
                                        maxLength={1024}
                                        onChangeText={(text) => this.setState({ description: text })}
                                        value={this.state.description} />
                                    <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error2}</Text>




                                </View>
                                <View style={{ flexDirection: 'row', marginBottom: 20, alignItems: 'center', justifyContent: 'center', alignSelf: 'center' }}>

                                    <TouchableOpacity style={styles.opensave} onPress={this.addProject} disabled={this.state.itemPressedDisabled}>
                                        <Text style={{ color: 'white' }}>ADD</Text>
                                    </TouchableOpacity>
                                    <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                                        <Text style={{ color: 'white' }}>CANCEL</Text>
                                    </TouchableOpacity>


                                </View>
                            </Modal>


                        </View>
                    </Container>
                </TouchableWithoutFeedback>
            </KeyboardAvoidingView>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create({
    container: {
        flex: 1,
        width: '100%',
        backgroundColor: '#fff',
        // paddingLeft: hp('1%'),
    },
    container1: {
        flex: 1,
        width: '98%',
        backgroundColor: '#BEF29F',

    },
    bottomView: {
        flex: 1,
        ...Platform.select({
            ios: {
                flexDirection: 'row',
                justifyContent: 'center',
                position: 'absolute',
                height: FOOTER_MAX_HEIGHT,
                bottom: 5,
                left: 0,
                right: 0,
                backgroundColor: 'black',
                alignItems: 'center'
            },
            android: {
                flexDirection: 'row',
                justifyContent: 'center',
                position: 'absolute',
                height: FOOTER_MAX_HEIGHT,
                bottom: 0,
                left: 0,
                right: 0,
                backgroundColor: 'black',
                alignItems: 'center'
            },
        }),
    },


    textStyle: {

        color: '#fff',
        fontSize: 22,
        justifyContent: 'center',
        backgroundColor: '#00A2C1',
        paddingBottom: 5,
        paddingLeft: 5,
        paddingRight: 5,
        paddingTop: 5,
        borderRadius: 5,
        marginLeft: 5


    },
    footer: {
        position: 'absolute',
        flex: 0.1,
        left: 0,
        right: 0,
        bottom: -10,
        backgroundColor: 'green',
        flexDirection: 'row',
        height: 80,
        alignItems: 'center',
    },
    bottomButtons: {
        alignItems: 'center',
        justifyContent: 'center',
        flex: 1,
    },
    footerText: {
        color: 'white',
        // fontWeight: 'bold',
        alignItems: 'center',
        fontSize: 18,
    },
    buttonContainer: {
        width: wp('98%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        color: '#d2691e',
        marginLeft: 4,



    },
    buttonContainer1: {
        width: wp('98%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        // backgroundColor: '#BEF29F',
        marginLeft: 4,



    },
    signupButton: {

        backgroundColor: '#ffffff',
    },
    subcontainer: {
        flex: 2,
        flexDirection: 'row',
        paddingTop: 40
    },
    signUpText0: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,
        // fontWeight:"bold",

    },
    signUpText1: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,
        // fontWeight:"bold",
        paddingLeft: 10,
    },
    end: {

        alignItems: 'flex-end',

    },
    end1: {
        flex: 2,
        height: '50%',
        paddingTop: 20,
        justifyContent: 'space-between',

        flexDirection: 'row',
    },
    s: {
        justifyContent: 'center',

        backgroundColor: '#ed7070',
        shadowOffset: { width: 50, height: 50 },
        alignItems: 'center',
        width: wp('40%'),
        height: hp('12%'),

    },
    signUpText2: {
        fontSize: 13,
        //marginLeft: 200,
        // fontSize: 13,
        color: 'black',
        paddingTop: 10,

        //  marginRight: 10,
        //textAlign: "right"

    },
    listgap: {
        fontSize: 13,
        paddingTop: 10,
        // paddingLeft: 130,


        alignItems: 'center',
    },
    signUpText03: {
        width: '25%',
        fontSize: 13,
        paddingTop: 10,
        paddingLeft: 10,

        alignItems: 'center',
    },
    signUpText3: {

        fontSize: 13,
        paddingTop: 10,
        paddingLeft: 10,
        // fontWeight:"bold",
        alignItems: 'center',
    },
    signUpText4: {
        fontSize: 13,
        paddingTop: 10,

        color: 'black',
        // fontWeight:"bold",
        alignItems: 'center',
    },
    signUpText9: {
        fontSize: 13,
        paddingTop: 10,
        width: wp('70%'),
        color: 'black',
        // fontWeight:"bold",
        alignItems: 'center',
    },
    signUpText99: {
        fontSize: 13,
        paddingTop: 10,
        width: wp('60%'),
        color: 'black',
        // fontWeight:"bold",
        alignItems: 'center',
    },

    signup: {
        //paddingTop:20,
        color: "#FFF",

    },
    boxone: {
        flex: 1,
        marginTop: 5,

    },
    boxtwo: {
        flex: 1,

    },
    boxthree: {
        flex: 1,

    },
    box: {
        flexDirection: 'row',
        position: 'relative',
        marginBottom: 10,


    },
    signUpText: {
        fontSize: 13,
        justifyContent: 'center',


        color: 'white',
        alignSelf: 'center',
    },
    //Based ON Platform
    opencancel: {
        flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'red', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
            android: {
                backgroundColor: 'red', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
        }),
    },
    opensave: {
        flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'green', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'

            },
            android: {
                backgroundColor: 'green', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'

            },
        }),
    },
});