/*
FileName:ModifyPersonalTodo.js
Version:1.0.0
Purpose:Modify the existing Personal todo based on pt_id
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import SearchableDropdown from 'react-native-searchable-dropdown';
import Toast from 'react-native-simple-toast';
import log from '../LogFile/Log';
import { DESCRIPTION, ESTIMATEDTIME, DAYS, HOURS, SUBTASKTITLE1 } from '../CommonComponents/Header';
import ModalSelector from 'react-native-modal-selector';
export default class ModifyPersonalTodo extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            open: false,
            isLoading: true,
            dataSource: [],
            isFetching: false,
            modalVisible: false,
            pt_id: this.props.navigation.state.params.pt_id,
            action: this.props.navigation.state.params.action,//getting action
            story_title: this.props.navigation.state.params.story_title,//idea id
            story_desc: this.props.navigation.state.params.story_desc,

            priorityLevel: this.props.navigation.state.params.priorityLevel,
            storyPoints: this.props.navigation.state.params.storyPoints,
            acceptanceCriteria: this.props.navigation.state.params.acceptanceCriteria,
            error1: '', error2: '', error3: '', error4: '', error5: '',
            itemPressedDisabled: false,
        };

    }
    modalDidOpen = () => console.log("Modal did open.");

    modalDidClose = () => {
        this.props.navigation.goBack();
        this.setState({ open: false }); this.setState({ open: false });
        console.log("Modal did close.");

    };

    //Dialog actions start
    moveUp = () => this.setState({ offset: -100 });

    resetPosition = () => {
        this.setState({ offset: 0 });
        this.props.navigation.goBack();
    }

    //open the dialog 
    openModal = () => {
        this.setState({ open: true })

    };
    //Close the dialog
    closeModal = () => {
        this.setState({
            open: false,
            error1: '', error2: '', error3: '', error4: '', error5: '',
        });
        // this.props.navigation.goBack();
        // const { params } = this.props.navigation.state;
        const { goBack } = this.props.navigation;
        // params.callHome();
        goBack();
    }
    //Dialog actions end
    componentDidMount() {
        log("Debug", "modify Sub Task screen is loaded");
        this.empSearch();//Getting the Employees List
        this.dependencySearch();//Getting the Dependency Task List
        this.openModal();//open dialog

        // alert(this.props.navigation.state.params.person);

    }

    //Refresh data
    onRefresh() {
        this.setState({ isFetching: true }, function () { this.add() });
    }

    //Checking the Validations
    isValidData() {
        const { story_title, story_desc, acceptanceCriteria, } = this.state;
        let valid = false;
        console.warn(this.state.assignedto);
        if (story_title.length === 0) {
            log("Warn", "tasktitle title should not be empty");
            this.setState({ error1: 'Enter Title ' });
        }
        else if (story_desc.length === 0) {
            // alert("Enter Description");
            log("Warn", "taskdescription title should not be empty");
            this.setState({ error2: 'Enter Description ' });
        }
        else if (acceptanceCriteria.length === 0) {
            log("Warn", "acceptanceCriteria should not be empty");
            this.setState({ error4: 'Enter Acceptance Criteria' });
        }


        else {
            valid = true;
        }
        return valid;
    }

    isUpdatedSucess() {
        Toast.show("Personal ToDo Modified successfully", Toast.LONG);
    }

    //Add the subtask start
    addSubTask = () => {
        // log("Info", " addSubTask( person, item, dependencyid,  description, days, time, ) is used to Add the subtask");
        const { pt_id,story_title, story_desc, acceptanceCriteria, storyPoints, description, days, time, priorityLevel } = this.state;
        // console.warn(assignedTo);
        // console.log(dependency);
        // console.log(subTask);
        // console.log(item);

        let EstHours = Number(days * 24) + Number(time);

        //employee id
        // AsyncStorage.getItem("empId", (err, res) => {
        //     const empId = res;

            AsyncStorage.getItem("userToken", (err, res) => {
                const empId = res;
            //cropcode
            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {

                        if (this.isValidData()) {
                            this.setState({ itemPressedDisabled: true })

                            fetch(API + 'private_todo.php', {
                                method: 'POST',
                                headers: {
                                    'Accept': 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({

                                    action: "personal_todo_modify",
                                    crop: cropcode,
                                    title: this.state.story_title,
                                    description: this.state.story_desc,
                                    added_to: this.state.assignedto,
                                    acceptanceCriteria: acceptanceCriteria,
                                    storyPoints: storyPoints,
                                    added_by: empId,
                                    priorityLevel: this.state.priorityLevel,
                                    pt_id:pt_id  
                                })
                            }).then((response) => response.json())
                                .then((responseJson) => {
                                    // alert(JSON.stringify(responseJson));
                                    // console.log(days);
                                    // console.log(description);
                                    // console.log(person);
                                    // console.log(responseJson);
                                    // console.warn(responseJson);
                                    if (responseJson.status === 'True') {
                                        this.setState({ itemPressedDisabled: false })
                                        console.log("done")
                                        this.setState({ open: false })
                                    } else {
                                        log("Warn", "task not modified");
                                        alert("Personal Todo not modified");
                                    }
                                }).catch((error) => {
                                    console.error(error);
                                    log("Error", "Add the subtask error");
                                });
                            this.closeModal();
                            this.isUpdatedSucess();
                        }
                    }
                });
            });
        // });
        });

    };
    //Getting the Employees List start
    empSearch() {
        log("Info", " empSearch(cropcode) is used to Getting the Employees List");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const crop = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'getEmployees.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            action: "add",
                            crop: crop //Async
                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {

                            this.setState({
                                empData: [...responseJson.data],
                            });
                        }
                        )
                        .catch((error) => {
                            console.error(error);
                            log("Error", "Getting the Employees error");
                        });
                }
            });
        });
    }
    //Getting Employees List end

    //Getting dependency task list start
    dependencySearch() {
        log("Info", " dependencySearch(cropcode) is used to Getting the Dependency List");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const crop = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'getSubtasks.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            action: "setdependency",
                            crop: crop, //Async
                            ideaId: this.state.ideaId
                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            if (responseJson.status === 'true') {
                                // alert("Your Task is Updated Successfully");
                                // this.getdata();//to get the user pending my task list

                                this.setState({
                                    isLoading: false,
                                    dependencyData: [...responseJson.data],
                                    isFetching: false
                                }, function () {
                                });

                            } else {
                                // Alert.alert("No depencency is available")
                                // log("Info", "no pending my tasks at user side");
                            }

                            // this.setState({
                            //   dependencyData: [...responseJson.data],
                            // });
                        }
                        )
                        .catch((error) => {
                            console.error(error);
                            log("Error", "Getting the Dependency error");
                        });
                }
            });
        });
    }


    render() {
        let index = 0;
        const data = [
            { key: index++, label: '1' },
            { key: index++, label: '2' },
            { key: index++, label: '3' },
            { key: index++, label: '5' },
            { key: index++, label: '8' },
            { key: index++, label: '13', },

        ];

        const data1 = [
            { key: index++, label: '1' },
            { key: index++, label: '2' },
            { key: index++, label: '3' },
            { key: index++, label: '4' },
            { key: index++, label: '5' },


        ];
        return (
            <Modal
                offset={this.state.offset}
                open={this.state.open}
                modalDidOpen={this.modalDidOpen}
                modalDidClose={this.modalDidClose}
                style={{ alignItems: "center", backgroundColor: 'white' }} >


                <View style={{ alignItems: "center", backgroundColor: 'white' }}>

                    <View style={{ marginLeft: 10, width: '100%', height: hp('6%') }}>
                        <Text style={{ color: 'red' }}>{this.state.error1}</Text>
                        <TextInput placeholder="Task Title"
                            style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                            // underlineColorAndroid='black'
                            value={this.state.story_title} onChangeText={(text) => this.setState({ story_title: text })}></TextInput>
                    </View>


                    <View style={{ marginLeft: 10, width: '100%', }}>

                        <Text style={{ color: 'red' }}>{this.state.error2}</Text>
                        <TextInput placeholder='Description:'
                            style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                            value={this.state.story_desc} onChangeText={(text) => this.setState({ story_desc: text })}></TextInput>

                    </View>

                    <View style={{ marginLeft: 10, width: '100%', }}>

                        <Text style={{ color: 'red' }}>{this.state.error4}</Text>
                        <TextInput placeholder="Acceptance Criteria/Definition of Done"
                            style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                            value={this.state.acceptanceCriteria} onChangeText={(text) => this.setState({ acceptanceCriteria: text })}></TextInput>

                    </View>
                    <Text style={{ marginLeft: 10, paddingTop: 10 }}>Story Points</Text>

<View style={{width:'98%'}}>
                    <ModalSelector
                        data={data}
                        initValue="Select something yummy!"
                        // supportedOrientations={['landscape']}
                        accessible={true}
                        optionContainerStyle={{ backgroundColor: 'white' }}
                        scrollViewAccessibilityLabel={'Scrollable options'}
                        cancelButtonAccessibilityLabel={'Cancel Button'}
                        onChange={(option) => { this.setState({ storyPoints: option.label }) }}>

                        <TextInput
                            style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '98%', marginLeft: '1%', color: 'black' }}
                            editable={false}
                            placeholder="Select Story Points!"
                            value={this.state.storyPoints} />

                    </ModalSelector>
                    </View>

                    <Text style={{ marginLeft: 10, paddingTop: 10 }}>Priority Level</Text>
                    <View style={{width:'98%'}}>
                    <ModalSelector
                        data={data1}
                        initValue="Select Priority  Points!"
                        // supportedOrientations={['landscape']}
                        accessible={true}
                        optionContainerStyle={{ backgroundColor: 'white' }}
                        scrollViewAccessibilityLabel={'Scrollable options'}
                        cancelButtonAccessibilityLabel={'Cancel Button'}
                        onChange={(option) => { this.setState({ priorityLevel: option.label }) }}>

                        <TextInput
                            style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '98%', marginLeft: '1%', color: 'black' }}
                            editable={false}
                            placeholder="Select Priority  Points!"
                            value={this.state.priorityLevel} />

                    </ModalSelector>
                    </View>
                    
                    <View style={{ flexDirection: 'row', }}>
                        <TouchableOpacity style={styles.opensave} onPress={this.addSubTask} disabled={this.state.itemPressedDisabled}>
                            <Text style={{ color: 'white' }}>Modify</Text>

                        </TouchableOpacity>
                        <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                            <Text style={{ color: 'white' }}>CANCEL</Text>
                        </TouchableOpacity>

                    </View>

                </View>

            </Modal>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create(
    {
        MainContainer:
        {
            flex: 1,
            width: Dimensions.get('window').width,
            height: Dimensions.get('window').height
        },
        bottomView: {
            flexDirection: 'row',
            justifyContent: 'center',
            position: 'absolute',
            height: FOOTER_MAX_HEIGHT,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundColor: 'black',
            alignItems: 'center'
        },

        textStyle: {
            color: '#fff',
            fontSize: 18
        },
        container: {
            flex: 1,
            width: '90%',
            paddingLeft: hp('2%'),
        },
        footer: {
            position: 'absolute',
            flex: 0.1,
            left: 0,
            right: 0,
            bottom: -10,
            backgroundColor: 'green',
            flexDirection: 'row',
            height: 80,
            alignItems: 'center',
        },
        bottomButtons: {
            alignItems: 'center',
            justifyContent: 'center',
            flex: 1,
        },
        footerText: {
            color: 'white',

            alignItems: 'center',
            fontSize: 18,
        },
        buttonContainer: {
            width: wp('90%'),
            alignSelf: 'baseline',
            marginBottom: 25,
            color: '#d2691e',
            marginLeft: 4,



        },
        signupButton: {

            backgroundColor: '#ffffff',
        },
        subcontainer: {
            flex: 2,
            flexDirection: 'row',
            paddingTop: 40
        },
        signUpText0: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText1: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            paddingLeft: 10,
        },
        end: {

            alignItems: 'flex-end',

        },
        end1: {
            flex: 2,
            height: '50%',
            paddingTop: 20,
            justifyContent: 'space-between',

            flexDirection: 'row',
        },
        s: {
            justifyContent: 'center',

            backgroundColor: '#ed7070',
            shadowOffset: { width: 50, height: 50 },
            alignItems: 'center',
            width: wp('40%'),
            height: hp('12%'),

        },
        signUpText2: {
            fontSize: 10,
            marginLeft: 200,
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText3: {

            fontSize: 12,
            paddingTop: 10,
            paddingLeft: 10,

            alignItems: 'center',
        },
        signUpText4: {
            fontSize: 12,
            paddingTop: 10,


            alignItems: 'center',
        },
        signup: {
            //paddingTop:20,
            color: "#FFF",

        },
        boxone: {
            flex: 1,
            marginTop: 5,

        },
        boxtwo: {
            flex: 1,

        },
        boxthree: {
            flex: 1,

        },
        box: {
            flexDirection: 'row',
            position: 'relative',
            marginBottom: 10,


        },
        signUpText: {
            fontSize: 20,
            justifyContent: 'center',


            color: 'white',
            alignSelf: 'center',
        },
        opencancel: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
        opensave: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
    });



