/*
FileName:AddLicensesPayment.js
Version:1.0.0
Purpose:AddLicensesPayment for User Licenses Upgrade
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import Toast from 'react-native-whc-toast';
import log from '../LogFile/Log';
import SearchableDropdown from 'react-native-searchable-dropdown';
import { ADDMODULE, MODULE_TITLE } from '../CommonComponents/Header';
import DatePicker from 'react-native-datepicker';

export default class AddLicensesPayment extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            open: false,
            modulename: '',
            sprintName: 'Select Sprint',
            taskid: this.props.navigation.state.params.taskid,
            role: '',
            userToken: '',
            modalVisible: false,
            sprintId: '',
            username: this.props.navigation.state.params.username,
            role: '',
            userToken: '',
            modalVisible: false,
            sprintId: '',

            fullName: this.props.navigation.state.params.fullName,
            email: this.props.navigation.state.params.email,

            error1: '',
            resource: [],

            itemPressedDisabled: false,
            targetdate: '',
            targetDate: '',
            license_key: '',
        };

    }
    //Open the Dialog Modal
    modalDidOpen = () => console.log("Modal did open.");
    //close the Dialog Modal
    modalDidClose = () => {
        this.props.navigation.goBack();
        this.setState({ open: false }); this.setState({ open: false });
        console.log("Modal did close.");

    };

    //Dialog actions start
    moveUp = () => this.setState({ offset: -100 });

    resetPosition = () => {
        this.setState({ offset: 0 });
        this.props.navigation.goBack();
    }

    //open the dialog 
    openModal = () => {
        this.setState({ open: true })

    };
    //close the dialog
    closeModal = () => {
        this.setState({ open: false });
        this.props.navigation.goBack();
    }
    //Dialog actions end
    componentDidMount() {
        log("Debug", "Module Add screen is loaded");
        this.openModal();
        // this.getSprints();

        // this.setModalVisible(!this.state.modalVisible);
    }

    //Refresh data
    onRefresh() {
        this.setState({ isFetching: true }, function () { this.add() });
    }

    //getting the Employees list for addind maintask
    getSprints() {
        log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
        const { ModuleId } = this.state;
        const { ideaid } = this.state;

        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'getUpdateSprint.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    crop: cropcode,
                                    action: "get_sprints",
                                    projectId: projectId
                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                // alert(JSON.stringify(responseJson.data));
                                if (responseJson.status === 'True') {


                                    var sprintDetails = [];


                                    responseJson.data.map((sprints) => {
                                        const [year, month, date] = sprints.startDate.split('-');
                                        const [year1, month1, date1] = sprints.targetDate.split('-');
                                        return (
                                            sprintDetails.push({ 'id': sprints.moduleId, 'epicId': sprints.ideaId, 'name': sprints.moduleDesc.concat('[' + month + '.' + date + '.' + year + '-' + month1 + '.' + date1 + '.' + year1 + ']') })
                                        );
                                    })

                                    this.setState({
                                        resource: sprintDetails,

                                    });

                                    this.addSprint(responseJson.data[0].targetDate)
                                    // alert("target"+JSON.stringify(responseJson.data))
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "requested projects error");
                            });
                    }
                });
            });
        });
    }

    //Validatios
    isValid() {
        // alert("Test"+this.state.license_key)
        const { license_key } = this.state;
        let valid = false;

        if (license_key.length === 0) {
            log("Warn", "Enter licenses_key");
            this.setState({ error1: 'Enter licenses_key' });
            alert("Enter licenses_key")
        }



        else {
            valid = true;
        }
        return valid;
    }


    //Modify the existing module
    addSprint(targetDate) {
        // alert(targetDate);
        log("Info", " addEpic(sprintId, cropcode) is used Modify the existing module");
        const { sprintId, sprintName } = this.state;


        // alert(this.state.sprintDesc)
        // const { idea_id } = this.state;
        console.warn("sprintId" + sprintId);
        // alert("sprintId" + sprintId)
        // alert(this.state.targetDate)
        // alert(targetdate);


        //userToken and crop code getting
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            console.log("userToken" + userToken);
            console.log("cropcode" + cropcode);
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
                AsyncStorage.getItem("userId", (err, res) => {
                    const userId = res;
                    // alert(userId)
                    //Checking the Network connection
                    NetInfo.fetch().then(state => {
                        if (state.type == "none") {
                            console.log(state.type);
                            log("Warn", "No internet connection");
                            Snackbar.show({
                                title: 'No Internet Connection',
                                backgroundColor: 'red',
                                duration: Snackbar.LENGTH_LONG,
                            });
                        }
                        // else if(targetDate >= this.state.targetdate){
                        //     alert("Target Date shouild not exceed Sprint target date");
                        //   }
                        else {
                            if (this.isValid()) {
                                this.setState({ itemPressedDisabled: true })
                                fetch(API + 'getUpdateSprint.php',
                                    {
                                        method: 'POST',
                                        headers: {
                                            Accept: 'application/json',
                                            'Content-Type': 'application/json',
                                        },
                                        body: JSON.stringify({
                                            action: "sprint_update",
                                            // idea_id: idea_id,
                                            crop: cropcode,
                                            sprintId: sprintId,
                                            targetDate: this.state.targetdate,
                                            updatedBy: userToken,
                                            userStoryId: this.state.taskid,
                                            projectId: projectId,
                                            device_id: userId,
                                            sprintDesc: this.state.sprintName,
                                            emp_id: userToken,
                                            assign_to: this.state.assign_to,
                                            title: this.state.title,

                                        })
                                    })
                                    .then((response) => response.json())
                                    .then((responseJson) => {
                                        console.log(responseJson)
                                        // alert("AddSprints" + JSON.stringify(responseJson))
                                        if (responseJson.status == 'True') {
                                            this.setState({ open: false });
                                            this.setState({ itemPressedDisabled: false })

                                            //Navigate to AddModule screen
                                            // this.props.navigation.navigate("UserTaskStatus1");
                                            this.props.navigation.navigate("UserBacklog");
                                            Snackbar.show({
                                                title: 'Sprint Added',
                                                backgroundColor: 'green',
                                                duration: Snackbar.LENGTH_LONG,
                                            });
                                        }
                                        // this.refs.toast.show('Project Modified', Toast.Duration.long, Toast.Position.center);

                                    })
                                    .catch((error) => {
                                        console.error(error);
                                        log("Error", "Modify the existing module error");
                                    });
                            }

                        }
                    });
                });
            });
        });

    }


    //Adding Licenses for the user
    addLicenses1() {
        // const [username, extension] = (this.state.username).split('@')
        // var dig1 = username.substring(0, 3)
        // var dig2 = extension.substring(0, 5)
        // var dig3 = Math.floor(Math.random() * 90000) + 10000
        // var license_key = (dig1.concat(dig2, dig3)).toUpperCase()

        log("Info", " Adding Licenses for the user");

        // alert(this.state.fullName)
        // alert(this.state.email)
        // alert(license_key);


        //userToken and crop code getting
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            console.log("userToken" + userToken);
            console.log("cropcode" + cropcode);

            // alert(userId)
            //Checking the Network connection
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                }
                // else if(targetDate >= this.state.targetdate){
                //     alert("Target Date shouild not exceed Sprint target date");
                //   }
                else {
                    if (this.isValid()) {
                        this.setState({ itemPressedDisabled: true })
                        fetch(API + 'get_user.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    action: "'change_account_type",
                                    corp: cropcode,
                                    empId: userToken,
                                    license_key: this.state.license_key

                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.log(responseJson)
                                // alert("AddSprints" + JSON.stringify(responseJson))
                                if (responseJson.status == 'True') {
                                    this.setState({ open: false });
                                    this.setState({ itemPressedDisabled: false })

                                    //Navigate to AddModule screen
                                    // this.props.navigation.navigate("UserTaskStatus1");
                                    this.props.navigation.navigate("UserProfile");
                                    Snackbar.show({
                                        title: 'Licenses Generated',
                                        backgroundColor: 'green',
                                        duration: Snackbar.LENGTH_LONG,
                                    });
                                }
                                else {
                                    alert(responseJson.message)
                                    this.props.navigation.navigate("UserProfile");
                                }
                                // this.refs.toast.show('Project Modified', Toast.Duration.long, Toast.Position.center);

                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "Adding Licenses");
                            });
                    }

                }
            });

        });

    }



    render() {

        return (
            <Modal
                offset={this.state.offset}
                closeOnTouchOutside={false}
                open={this.state.open}
                modalDidOpen={this.modalDidOpen}
                modalDidClose={this.modalDidClose}
                style={{ alignItems: "center" }} >

                <View style={{ alignItems: "center", }}>
                    <Toast ref="toast" />
                    <Text>Licenses Upgrade</Text>

                    <View style={{ paddingTop: 10, width: '100%', marginLeft: '5%' }}>
                        <TextInput placeholder="Licenses Key"
                            style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 10 }}
                            onChangeText={(text) => this.setState({ license_key: text })}
                        />
                        {/* <Text style={{ color: 'red' }}>{this.state.error1}</Text> */}
                    </View>

                </View>


                <View style={{ flexDirection: 'row', alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>
                    <TouchableOpacity style={styles.opensave} onPress={this.addLicenses1.bind(this)} disabled={this.state.itemPressedDisabled}>
                        <Text style={{ color: 'white' }}>UPGRADE</Text>
                    </TouchableOpacity>
                    <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                        <Text style={{ color: 'white' }}>CANCEL</Text>
                    </TouchableOpacity>
                </View>
                <View style={{ flexDirection: 'row', }}>
                    <Text style={{ paddingLeft: 20 }}>
                        Buy license key to upgrade your account
                    </Text>



                </View>
            </Modal>


        );

    }

}
//Styles for UI
const styles = StyleSheet.create(
    {
        MainContainer:
        {
            flex: 1,
            width: Dimensions.get('window').width,
            height: Dimensions.get('window').height
        },
        bottomView: {
            flexDirection: 'row',
            justifyContent: 'center',
            position: 'absolute',
            height: FOOTER_MAX_HEIGHT,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundColor: 'black',
            alignItems: 'center'
        },

        textStyle: {
            color: '#fff',
            fontSize: 18
        },
        container: {
            flex: 1,
            width: '90%',
            paddingLeft: hp('2%'),
        },
        footer: {
            position: 'absolute',
            flex: 0.1,
            left: 0,
            right: 0,
            bottom: -10,
            backgroundColor: 'green',
            flexDirection: 'row',
            height: 80,
            alignItems: 'center',
        },
        bottomButtons: {
            alignItems: 'center',
            justifyContent: 'center',
            flex: 1,
        },
        footerText: {
            color: 'white',
            fontWeight: 'bold',
            alignItems: 'center',
            fontSize: 18,
        },
        buttonContainer: {
            width: wp('90%'),
            alignSelf: 'baseline',
            marginBottom: 25,
            color: '#d2691e',
            marginLeft: 4,



        },
        signupButton: {

            backgroundColor: '#ffffff',
        },
        subcontainer: {
            flex: 2,
            flexDirection: 'row',
            paddingTop: 40
        },
        signUpText0: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText1: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            paddingLeft: 10,
        },
        end: {

            alignItems: 'flex-end',

        },
        end1: {
            flex: 2,
            height: '50%',
            paddingTop: 20,
            justifyContent: 'space-between',

            flexDirection: 'row',
        },
        s: {
            justifyContent: 'center',

            backgroundColor: '#ed7070',
            shadowOffset: { width: 50, height: 50 },
            alignItems: 'center',
            width: wp('40%'),
            height: hp('12%'),

        },
        signUpText2: {
            fontSize: 10,
            marginLeft: 200,
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            //  marginRight: 10,
            //textAlign: "right"

        },
        signUpText3: {

            fontSize: 12,
            paddingTop: 10,
            paddingLeft: 10,

            alignItems: 'center',
        },
        signUpText4: {
            fontSize: 12,
            paddingTop: 10,


            alignItems: 'center',
        },
        signup: {
            //paddingTop:20,
            color: "#FFF",

        },
        boxone: {
            flex: 1,
            marginTop: 5,

        },
        boxtwo: {
            flex: 1,

        },
        boxthree: {
            flex: 1,

        },
        box: {
            flexDirection: 'row',
            position: 'relative',
            marginBottom: 10,


        },
        signUpText: {
            fontSize: 20,
            justifyContent: 'center',


            color: 'white',
            alignSelf: 'center',
        },
        opencancel: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
        opensave: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
    });