/*
FileName:Instrauction.js
Version:1.0.0
Purpose: Select project role 
Devloper:Santhosh Panjala
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, StatusBar, Dimensions, Picker, TouchableOpacity, Linking, TextInput, Alert } from 'react-native';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Icon from 'react-native-vector-icons/MaterialCommunityIcons';
import SearchableDropdown from 'react-native-searchable-dropdown';
import AsyncStorage from '@react-native-community/async-storage';
// import { tsMethodSignature } from '@babel/types';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import ModalSelector from 'react-native-modal-selector';
// import { Dropdown } from 'react-native-material-dropdown';
import log from '../LogFile/Log';
import Toast from 'react-native-whc-toast';
import { MAINTASKINFO, MAINTASKTITLE, DESCRIPTION, } from '../CommonComponents/Header';
import { ScrollView } from 'react-native-gesture-handler';
import { EMPLOYEEID1, FULLNAME, USERNAME1, EMAIL1, MOBILE1, ADDEMPLOYEE, EMPLOYEEDETAILS } from '../CommonComponents/Header';
import RadioButtonRN from 'radio-buttons-react-native';


export default class Instruction extends Component {

    constructor(props) {
        super(props);

        this.state = {
            usertype:'',

        };
    }



    //Adding the new Employee
    updateRole() {
        log("Info", " updateRole( usertype, user_status, password) is used to Adding the new Employee");


            const { user_status, password, usertype } = this.state;
            var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
            var string_length = 8;
            var pass_code = '';
            for (var i=0; i<string_length; i++) {
                var num = Math.floor(Math.random() * chars.length);
                pass_code += chars.substring(num,num+1);
            }
            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                // alert(squadName)
                
                AsyncStorage.getItem("userToken", (err, res) => {
                    const userToken = res;
// alert(userToken)
                    AsyncStorage.getItem("projectId", (err, res) => {
                        const projectId = res;
                        //alert(projectId)

                        NetInfo.fetch().then(state => {
                            if (state.type == "none") {
                                console.log(state.type);
                                log("Warn", "No internet connection");
                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {
                                fetch(API + 'manage_user.php', {
                                    method: 'POST',
                                    headers: {
                                        'Accept': 'application/json',
                                        'Content-Type': 'application/json',
                                    },
                                    body: JSON.stringify({
                                        action: "update_role",
                                        corp: cropcode,
                                        empId: userToken,
                                        projectId: projectId,
                                        password: pass_code,
                                        userType: usertype,
                                    })
                                }).then((response) => response.json())
                                    .then((responseJson) => {
                                        // alert(JSON.stringify(responseJson));
                                        //alert(responseJson);
                                        if (responseJson.status === 'True') {
                                            this.getEmployeesRoles();
                                            this.props.navigation.navigate('MyTask');
                                        }
                                        else {
                                            console.log(JSON.stringify(responseJson));
                                            log("Warn", "Error  found");
                                            // alert("error");
                                            // alert(responseJson.message)
                                        }

                                    }).catch((error) => {
                                        console.error(error);
                                        log("Error", "Adding the new Employee error");
                                    });
                            }
                        });
                    });
                });
            });

        
    }

    getEmployeesRoles() {
        log("Info", " updateRole( usertype, user_status, password) is used to Adding the new Employee");


            const {empId, user_status, password, usertype } = this.state;
            var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
            var string_length = 8;
            var pass_code = '';
            for (var i=0; i<string_length; i++) {
                var num = Math.floor(Math.random() * chars.length);
                pass_code += chars.substring(num,num+1);
            }
            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                // alert(squadName)
                
                AsyncStorage.getItem("userToken", (err, res) => {
                    const userToken = res;

                    AsyncStorage.getItem("projectId", (err, res) => {
                        const projectId = res;
                        //alert(projectId)

                        NetInfo.fetch().then(state => {
                            if (state.type == "none") {
                                console.log(state.type);
                                log("Warn", "No internet connection");
                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {
                                fetch(API + 'manage_user.php', {
                                    method: 'POST',
                                    headers: {
                                        'Accept': 'application/json',
                                        'Content-Type': 'application/json',
                                    },
                                    body: JSON.stringify({
                                        action: "get_user_role",
                                        corp: cropcode,
                                        empId: userToken,
                                        projectId: projectId,
                                       
                                    })
                                }).then((response) => response.json())
                                    .then((responseJson) => {
                                        //alert(JSON.stringify(responseJson));
                                        //alert(responseJson);
                                        if (responseJson.status === 'True') {
                                            // this.props.navigation.navigate('MyTask');
                                        }
                                        else {
                                            console.log(JSON.stringify(responseJson));
                                            log("Warn", "Error  found");
                                            // alert("error");
                                            alert(responseJson.message)
                                        }

                                    }).catch((error) => {
                                        console.error(error);
                                        log("Error", "Adding the new Employee error");
                                    });
                            }
                        });
                    });
                });
            });

        
    }






    render() {



        const data = [
            {
                id: 'Scrum Master',
                label: 'Scrum Master'
            },
            {
                id: 'Product Owner',
                label: 'Product Owner'
            }
        ];

        return (
            <Container>
                <Header
                    androidStatusBarColor="#00A2C1"

                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <Left>
                        <Icon name="arrow-left" size={25} style={{ color: '#fff', }} onPress={() =>
                            this.props.navigation.goBack()} />
                    </Left>
                    <Body>
                        <Title style={{ color: '#fff', fontWeight: '600' }}>ROLE SELECTION</Title>
                    </Body>
                    <Right></Right>
                </Header>

                <Content>
                    <Toast ref="toast" />
                    <View style={{ paddingTop: 20, }}>


                        <View style={{ paddingLeft: 10, paddingTop: 10, }}>
                            <Text>Select Role</Text>
                            <RadioButtonRN
                                data={data}
                                box={false}
                                // horizontal={true}
                                // style={styles.types}
                                // activeButtonId={this.state.role}
                                selectedBtn={(option) => this.setState({ usertype: option.id })}
                                circleStyle={{ fillColor: 'black', borderColor: 'black' }}
                                icon={
                                    <Icon
                                        name="check-circle"
                                        size={25}
                                        color="black"
                                    />
                                }
                            />
                        </View>

                        <View style={{ flexDirection: 'row', marginTop: 10, justifyContent: "space-between" }}>
                            <TouchableOpacity style={styles.opensave}
                                onPress={() => this.updateRole()}                            >
                                <Text style={{ color: 'white' }}>Select</Text>
                            </TouchableOpacity>


                        </View>

                    </View>
                </Content>
            </Container>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create({
    opencancel: {
        flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'red', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
            android: {
                backgroundColor: 'red', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
        }),
    },
    opensave: {
        flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'green', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
            android: {
                backgroundColor: 'green', margin: 20, height: 30, alignItems:
                    "center", justifyContent: 'center'
            },
        }),
    },
});