import React, { Component } from 'react';
import {
  Platform, StyleSheet, TextPropTypes, Picker, Text, View, Image, StatusBar, Dimensions, TextInput, Alert,
  KeyboardAvoidingView,
  TouchableWithoutFeedback,
  Keyboard
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import ModalSelector from 'react-native-modal-selector';
const check = new Main()
import {
  DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';

export default class ReportBurnUp extends Component {

  constructor(props) {
    super(props);

    this.state = {
      isLoading: false,
      isVisibleB: false,
      sprintVelocity: [],
      sprint: [],
      indVelocity: [],
      indWorkload: [],
      epicVelocity:[],
      selectedIndVelocity: [],
      // indWorkload: [],
      dataSource: [],
      dataSource1: [],

      assignedName: 'Select Squad Name',
      sprintName: 'Select Sprint Name',
      epicName: 'Select Epic',
      resource: [],
      resource1: [],
      resource2:[],
      burnUpChart: [],


    }
    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ squadName: res });
      console.warn("squadname" + this.state.squadName);
    });
  }



  componentDidMount() {
    this.getEmployees();
    // this.NetworkEpic();
    this.Network();
    // this.getSprints();
    // this.GetStatus();
    // this.getEpics();
  }

  //getting the Employees list for addind maintask
  getEmployees() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'agile_squads.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  projectId: projectId
                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                if (responseJson.status === 'True') {

                  var empList = [];
                  responseJson.data.map((employee) => {
                    return (
                      empList.push({
                        'id': employee.id, 'name': employee.name
                      })
                    );
                  })
                  //  alert("Employee Data"+JSON.stringify(responseJson))
                  // this.Network1()
                  this.setState({
                    resource: responseJson.data
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


  //Getting the Srpint velocity
  getSprints() {
    // alert("Testing")
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          console.warn(empId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + 'individualSprintVelocity', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  project_id: projectId,
                })

              }).then((response) => response.json())
                .then((responseJson) => {
                  // console.warn("Sprint Velocity" + JSON.stringify(responseJson));
                  // alert("getEpics Data"+JSON.stringify(responseJson))

                  // this.setState({
                  //   resource1: responseJson

                  // },

                  //   function () {

                  //   });


                  var epicList = [];
                  responseJson.map((sprints) => {
                    return (
                      epicList.push({
                        'id': sprints.epic_id, 'name': sprints.epic_name
                      })
                    );
                  })

                  this.setState({
                    resource2: epicList
                  },
                    function () {

                    }
                  );

                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });

    });
  }


  //Getting the Srpint velocity
  Network() {

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          // alert(projectId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + 'burnUp', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                //   sprint_id:sprint_id,
                  project_id: projectId
                })


              }).then((response) => response.json())
                .then((responseJson) => {
                  alert("Burn Sprint Velocity" + JSON.stringify(responseJson));
                  // alert("Sprint Velocity1" + sprintVelocity);
                  //   alert(JSON.stringify(responseJson))

                  this.setState({
                    sprintVelocity: responseJson

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });

    });
  }
  //Getting the Srpint velocity

   //Getting the indVelocity
   NetworkEpic() {
    // alert(id)
    // this.Network3(item);
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          console.warn(empId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + `getEpicsData`, {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                //   epic_id: id,
                })

              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert("epics" + JSON.stringify(responseJson));
                  // alert("abcd"+JSON.stringify(responseJson))

                  var epicDataX = [];
                  var epicDataY = [];
                  responseJson.map((x) => {
                    return (
                      epicDataX.push({ 'x': x.sprint, 'y': parseInt(x.estimated) })
                    );
                  })
                  responseJson.map((x) => {
                    return (
                      epicDataY.push({ 'x': x.sprint, 'y': parseInt(x.completed)})
                    );
                  })

                  this.setState({
                    epicVelocity: [
                      {
                        seriesName: 'series1', data: epicDataX, color: '#209AE5'
                      },
                      {
                        seriesName: 'series2', data: epicDataY, color: '#F8E589'
                      }
                    ]

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });
    });
  }


  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }

    var epicDataX = [];
    var epicDataY = [];
    this.state.epicVelocity.map((x) => {
      return (
        epicDataX.push({ 'x': x.sprint, 'y': parseInt(x.estimated) })
      );
    })
    this.state.epicVelocity.map((x) => {
      return (
        epicDataY.push({ 'x': x.sprint, 'y': parseInt(x.completed)})
      );
    })

//  alert("abc"+JSON.stringify(this.state.epicVelocity))

    const epicVelocityChart = [
      
        {
          seriesName: 'test2', data: epicDataX, color: '#0e95de'
        }
      
 
  ]


    return (
      <KeyboardAvoidingView
        style={{ flex: 1 }}
        behavior={Platform.OS === "ios" ? "padding" : "height"}
      >
        <Container>
        <Text style={{ padding: 10, fontWeight: 'bold' }}>Burn Up Reports</Text>
          <Content>



             {/* Epic Report */}
               <View style={{ flex: 1, marginTop: 10, marginBottom: 10 }}>

              <View style={{ flexDirection: 'row', flex: 1, alignContent: 'center', justifyContent: 'center' }}>
                <View style={{ width: 30, height: 8, backgroundColor: '#209AE5', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Estimated</Text>
                <View style={{ width: 30, height: 8, backgroundColor: '#F8E589', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Completed</Text>
              </View>
              <ScrollView horizontal={true} style={{ marginRight: 2, marginLeft: 2 }}>
                
                <PureChart 
                data={this.state.epicVelocity} 
                type={'line'}
                width={'100%'}
                height={200}
                 gap={120}
                showEvenNumberXaxisLabel={false}
                 defaultColumnWidth={500}
              
                />

              </ScrollView>
              </View>





          </Content>

        </Container>
      </KeyboardAvoidingView>
    );
  }
}

const styles = StyleSheet.create({
  submit: {
    flex: 1,
    ...Platform.select({
      ios: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 10
      },
      android: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 70
      },
    }),
  },
  mobile: {
    flex: 1,
    ...Platform.select({
      ios: {
        marginTop: 12
      },
      android: {

      },
    }),
  },
  role: {
    flex: 1,
    ...Platform.select({
      ios: {
        flexDirection: 'row', marginTop: 10
      },
      android: {
        flexDirection: 'row',
        paddingTop: 10,

      },
    }),
  },

});
const pickerSelectStyles = StyleSheet.create({
  inputIOS: {
    fontSize: 2,
    paddingVertical: 12,
    paddingHorizontal: 10,
    borderWidth: 1,
    borderColor: 'blue',
    borderRadius: 4,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
  inputAndroid: {
    fontSize: 3,
    paddingHorizontal: 10,
    paddingVertical: 8,
    borderWidth: 0.5,
    borderColor: 'purple',
    borderRadius: 8,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
});