/*
FileName:UserGroupChat.js
Version:1.0.0
Purpose:Getting the List of all group chat,and creating group
Developer:Mahesh 
*/
import React, { Component } from 'react';
// import Icon from 'react-native-vector-icons/FontAwesome';
import {
  Platform, StyleSheet, Text, View, Dimensions, FlatList, TextInput,
  TouchableHighlight, Image, TouchableOpacity, Alert, KeyboardAvoidingView,
  TouchableWithoutFeedback,
  Keyboard
} from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input, Body, Title, Icon } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import Toast from 'react-native-whc-toast';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import { NavigationEvents } from 'react-navigation';
import jwt_decode from "jwt-decode";
import Main from '../Maintenance/Main';
const check = new Main()
import UserDatabase from '../OfflineDB/UserDatabase';
const db = new UserDatabase();
import ModalSelector from 'react-native-modal-selector';
import {
  BallIndicator,
  BarIndicator,
  DotIndicator,
  MaterialIndicator,
  PacmanIndicator,
  PulseIndicator,
  SkypeIndicator,
  UIActivityIndicator
} from 'react-native-indicators';
import { PROJECTNO, TITLE, ADDPROJECT, REQUESTED_BY, RELEASEOWNER, PROJECTSTATUS, RO, VERIFY, DELETE } from '../CommonComponents/Header';
import MultiSelect from 'react-native-multiple-select';
import { ScrollView } from 'react-native-gesture-handler';

class ListItem extends React.Component {


  constructor(props) {
    super(props);
    this.state = {

      roledata: '',
      dataSource2: [],
      msg: ''


    }
    this.getMessages();
  }



  getMessages() {
    // alert("hello")
    log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
    // const groupId = this.state.subtaskId;
    // console.warn("getmessages");
    AsyncStorage.multiGet(["cropcode", "userName"], (err, response) => {
      const cropcode = response[0][1];
      const userName = response[1][1];
      // this.setState({ userid: userToken });
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        // console.warn("userToken"+userToken)
        // console.warn("cropcode"+cropcode)

        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          }
          else {
            fetch(API + "group_chat.php",
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({

                  action: "getAllGroupMessages",
                  corp_code: cropcode,
                  projectId: projectId,
                  created_by: userName,


                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                console.warn("Messages For chat application" + JSON.stringify(responseJson.data));
                // alert("Send By Name" + JSON.stringify(responseJson.data))
                // console.warn("Messages from users" + JSON.stringify(responseJson))
                // console.warn("Send By Name" + JSON.stringify(responseJson.data))
                if (responseJson.status === 'True') {

                  console.warn("Setted Data")


                  this.setState({
                    dataSource2: responseJson.data,
                  });
                  console.warn("Method data" + responseJson.data.sendBy)
                }
                else {
                  console.warn("Empty  Data")
                  this.setState({
                    dataSource: '',
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "getting task related messages error");
              });

          }
        });
      });
    });
  }

  // to verify the project in user based like approver 
  // it just validation 
  ProjectVerify() {
    log("Info", "ProjectVerify() method is used to give alert");
    const { item } = this.props;

    Alert.alert(
      'Alert..!',
      'Do you want to Verify Task',
      [
        {
          text: 'Cancel',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'OK', onPress: () => this.ProjectVerification(item.idea_id) },
      ],
      { cancelable: false },
    );

  }

  //to verify the project in user based projects
  ProjectVerification(projectid) {
    log("Info", "ProjectVerification(projectid) method is used to verify approved project");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'manageIdeas.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                crop: cropcode,
                idea_id: projectid,
                action: 'verify'

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              if (responseJson.status == 'True') {

              } else if (responseJson.status == 'false') {

                //Alert.alert(responseJson.message);

              } else { }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "ProjectVerification Error");
            });
        }
      });
    });
  }

  // //Navigate to Project Modify Screen
  // TaskChat(msgCount,id,group_name,members_name,members_email) {
  //   // console.log(item);
  //   // console.log(index);
  //   // alert("message"+msgCount)
  //   console.log("msgCount"+msgCount)
  //   console.log("id"+id)
  //   console.log("groupname"+group_name)
  //   console.log("members_name"+members_name)
  //   console.log("members_email"+members_email)

  //   // log("Info", "ModifyProject() method is used to move Add Module to Add ModifyChat screen");
  //   this.props.navigation.navigate('GroupChat', { sno:msgCount, id: id,group_name:group_name,members_name: members_name, members_email: members_email });

  // }

  //Navigates to TaskChat Screen
  TaskChat(id,item, msgCount) {
    console.warn("msgCount" + msgCount);
    // console.warn("id" + id);
    // alert(id)
    // alert(item.group_name)
    // alert(JSON.stringify(msgCount))
    // log("Info", "UserGroupChat:TaskChat(item, index) used to navigate to taskchat")
    this.props.navigation.navigate("GroupChat", { id: id, group_name:item.group_name, members_name: item.members_name, members_email: item.members_email, sno: msgCount });
  }
  render() {
    // const { item } = this.props;
    const { item, data } = this.props;
    const { username } = this.props;
    // alert(JSON.stringify(item));
    let buttonDelete;
    if (item.created_by === username) {

      buttonDelete =
        <View style={{ flexDirection: 'row', justifyContent: 'flex-end', alignItems: 'center' }}>

          <TouchableOpacity style={{ padding: 5, backgroundColor: '#641A3D', marginLeft: 10, borderRadius: 10 }} onPress={() => this.props.deleteAction()}>
            <Text style={{ color: 'white', fontSize: 12 }}>Delete</Text>
          </TouchableOpacity>
        </View>



    } else {

      buttonDelete = null;

    }

    const getLastMsg = (message, id) => {
      const groupMsg = message.filter(msg => msg.groupId === id).map((mg, i) => {
        return mg.message
      });
      return groupMsg[groupMsg.length - 1]
    }
    const getLastMsgTime = (message, id) => {
      const groupMsg = message.filter(msg => msg.groupId === id).map((mg, i) => {
        return mg.messaged_time
      });
      return groupMsg[groupMsg.length - 1]
    }
    const getLastMsgSendBy = (message, id) => {
      const groupMsg = message.filter(msg => msg.groupId === id).map((mg, i) => {
        return mg.fullname
      });
      return groupMsg[groupMsg.length - 1]
    }


    const getMessagesCount = (id, msg, empId) => {
      // alert("ids"+JSON.stringify(id))
      // alert(JSON.stringify(msg))

      //  var msg=this.state.dataSource1;
      // console.warn("Datasource and id send by"+JSON.stringify(data1.sendBy))
      // let msgCount = data1.filter(message => message.sendBy === id).map((messages, i) => {
      let msgCount = msg.filter(message => message.readBy.split(",").indexOf(empId) === -1 && message.messagedBy !== empId && message.groupId === id).map((messages, i) => {

        return i, messages

      })

      // console.warn("iiiiiiii" + id)
      // console.warn("msgcount" + msgCount)
      // alert("msgcount" +JSON.stringify(msgCount))

      return (
        // console.warn("iiiiiiii" + msgCount),
        <View>
          <Text style={{ color: 'red' }}> {msgCount.length > 0 ? msgCount.length : null} </Text>
          {/* {msgCount.length > 0 ? msgCount.length : null} */}
          {
            msgCount.length > 0 ?

              <TouchableOpacity style={{ marginTop: -20, marginLeft: 10 }} onPress={() => { this.TaskChat(id, item, msgCount) }}>
              {/* <TouchableOpacity style={{ marginTop: -20, marginLeft: 10 }} onPress={() => this.props.TaskChat(id,msgCount)}> */}
                {/* <TouchableOpacity style={{ marginTop: -20, marginLeft: 10 }} onPress={() => { this.TaskChat( msgCount,id,item.group_name,item.members_name,item.members_email) }}> */}

                <Image style={{ width: 25, height: 25 }} source={require('../Images/chat.png')} />
              </TouchableOpacity>
              :

              <TouchableOpacity style={{ marginTop: -20, marginLeft: 10 }} onPress={() => { this.TaskChat(id,item, msgCount) }}>
              {/* <TouchableOpacity style={{ marginTop: -20, marginLeft: 10 }} onPress={() => this.props.TaskChat(id,msgCount)}> */}
                {/* <TouchableOpacity style={{ marginTop: -20, marginLeft: 10 }} onPress={() => { this.TaskChat( msgCount,id,item.group_name,item.members_name,item.members_email) }}> */}

                <Image style={{ width: 25, height: 25, }} source={require('../Images/chat.png')} />

              </TouchableOpacity>

          }

        </View>
      )

    }




    {
      // empSorted.length > 0 ? empSorted.map((group, index) => {
      return (

        <ScrollView style={Number(item.taskStatus) === 1 ? styles.buttonContainer : styles.buttonContainer1}>
          {/* <TouchableOpacity onPress={this.props.Module}> */}
          {/* <TouchableOpacity onPress={this.props.MainTask}> */}
          <View style={styles.signup}>

            <View style={{ borderWidth: 1, borderColor: 'grey', borderRadius: 10 }} >
              <View style={{ margin: 10 }} >

                <View style={styles.box}>
                  <View style={{ flexDirection: 'row', width: wp('85%') }}>
                    <Text style={styles.signUpText0} >Group Name: </Text>

                    <Text style={styles.signUpText1} >{item.group_name}</Text>

                 </View>

                </View>
                <View style={{flexDirection:'row'}}>
                <Text style={{color:'#214274',}}> {getLastMsgSendBy(this.state.dataSource2, item.id) }</Text>
                <Text style={{color:'black',paddingLeft:10,fontSize:10,paddingTop:3}}> {getLastMsgTime(this.state.dataSource2, item.id)}</Text>
                </View>
                <Text style={{width:'60%',color:'grey'}}> {getLastMsg(this.state.dataSource2, item.id)}</Text>
            
                  <View style={{ justifyContent: 'flex-end',flexDirection: 'row' ,marginTop:5}}>
                    {buttonDelete}
                    <View style={{ flexDirection: 'row', justifyContent: 'flex-end', alignItems: 'center' }}>
                      <TouchableOpacity style={{ padding: 5, backgroundColor: '#214274', marginLeft: 10, borderRadius: 10 }} onPress={() => this.props.exitGroup()}>
                        <Text style={{ color: 'white', fontSize: 12 }}>Exit Group</Text>
                      </TouchableOpacity>
                    </View>
                    {getMessagesCount(item.id, this.state.dataSource2, this.props.empId)}
                  </View>

              </View>
            </View>
          </View>
          {/* </TouchableOpacity> */}
        </ScrollView>


      )
      // }) : null
    }
  }
}


export default class UserGroupChat extends Component {
  static navigationOptions = () => {
    return {
      tabBarOnPress({ navigation, defaultHandler }) {
        navigation.state.params.onTabFocus();
        defaultHandler();
        this.onRefresh();
      }
    };
  }
  constructor(props) {

    super(props);
    props.navigation.setParams({
      onTabFocus: this.handleTabFocus
    });
    this.state = {
      isLoading: true,
      dataSource: [],
      isFetching: false,
      ProjectTitle: '',
      // ProjectDescription: '',
      open: false,
      resource: [],
      adminGroupsMsg:[],
      ideaid: '',
      error1: '',
      error2: '',
      error3: '',
      selectedItems: [],
      resource1: [],
      members: [],
      label: [],
      members_name: [],
      msg: '',
      dataSource2: []

    }
    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ squadName: res });
      console.warn("squadname" + this.state.squadName);
    });
    this.arrayholder = [];
  }
  onSelectedItemsChange = selectedItems => {
    this.setState({ selectedItems });

  };
  // setSelectedValue(Array.isArray(e) ? e.map(x => x.value) : []);
  // setLabel(Array.isArray(e) ? e.map(x => x.value) : []);
  // setMem(Array.isArray(e) ? e.map(x => x.label) : []);
  handleTabFocus = () => {
    this.onRefresh();
  };
  moveUp = () => this.setState({ offset: -110 });

  resetPosition = () => this.setState({ offset: 0 });

  openModal = () => this.setState({ open: true });

  closeModal = () => {
    //this.props.navigation.goBack();

    this.setState({
      open: false,
      // ProjectTitle: '',
      // ProjectDescription: '',
      error1: '',
      error2: '',
      error3: '',
      group_name: '',
      // label: '',
      // group_name:'',
    });
  }

  //lifecycle method to call api methods 
  componentDidMount() {
    log("Debug", "User Approved projects screen is loaded");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.GetStatus();
        // this.getGroupDetails()
        this.getApprovedProjectsListOffline() //Offline Approved Projects List
      } else {
        //userApprovedProjects getting
        // this.userApprovedProjects()
        this.GetStatus();
        this.getEmployees();
        this.getGroupDetails();
        this.getAdminGroupNew();
        this.getMessages();

      }
    });
    AsyncStorage.getItem("emp_role", (err, res) => {
      this.setState({ emp_role: res });

      console.warn("Emp role" + this.state.emp_role)
    });
    AsyncStorage.getItem("userToken", (err, res) => {
      this.setState({ empId: res });

      // console.warn(this.state.empId);
    });
    AsyncStorage.getItem("userName", (err, res) => {
      this.setState({ username: res });


    });

    // this.getResource()


  }


  //For store Agile projects for offline Start
  addAgileProjects(data) {
    console.warn("hello naveen" + JSON.stringify(data));
    db.addAgileProjects(data).then((result) => {
      console.log(result);
    }).catch((err) => {
      console.log(err);
    })
  }
  //For store Agile projects for offline End
  //For Getting offline Project List Start
  getAgileProjects() {
    db.getAgileProjects().then((data) => {
      console.warn("AgileProjectsList" + JSON.stringify(data))
      this.setState({
        data2: data,
      });
    }).catch((err) => {
    })
  }
  //For Getting offline Project List End

  //get project list dropdown data
  GetStatus() {
    log("Info", "UserProfile:GetStatus() method is used to get status of employee");
    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          // console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          this.getAgileProjects(); //Get offline Project List
        } else {

          fetch(API + 'squads.php', {
            method: 'POST',
            headers: {
              Accept: 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({

              empId: empId,
              action: 'get_squads',


            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)
              // alert(responseJson.data)
              if (responseJson.status == 'True') {
                // this.setState({
                //     isLoading: false,
                //     dataSource1: [...responseJson.data],
                // }, function () {
                //     // In this block you can do something with new state.
                // });
                console.log("Testing" + JSON.stringify(responseJson.data))
                const data2 = [];
                this.addAgileProjects(responseJson.data) //Project list store in offline

                responseJson.data.map(x => {
                  data2.push({ label: x.value, value: x.value })
                })
                this.setState({
                  data2: data2,
                })
                console.warn("Hello" + JSON.stringify(data2))

                // this.setState({
                //     data2: responseJson.data
                // });
                console.warn(this.state.data2);
              } else {
                log("Warn", "status of employee is not available");
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in  getting status of employee");
            });
        }
      });
    });

  }

  getMessages() {
    // alert("hello")
    log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
    // const groupId = this.state.subtaskId;
    // console.warn("getmessages");
    AsyncStorage.multiGet(["cropcode", "userName"], (err, response) => {
      const cropcode = response[0][1];
      const userName = response[1][1];
      // this.setState({ userid: userToken });
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        // console.warn("userToken"+userToken)
        // console.warn("cropcode"+cropcode)

        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          }
          else {
            fetch(API + "group_chat.php",
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({

                  action: "getAllGroupMessages",
                  corp_code: cropcode,
                  projectId: projectId,
                  created_by: userName,


                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                console.warn("Messages For chat application" + JSON.stringify(responseJson.data));
                // alert("Send By Name" + JSON.stringify(responseJson.data))
                // console.warn("Messages from users" + JSON.stringify(responseJson))
                // console.warn("Send By Name" + JSON.stringify(responseJson.data))
                if (responseJson.status === 'True') {

                  console.warn("Setted Data")


                  this.setState({
                    dataSource2: responseJson.data,
                  });
                  console.warn("Method data" + responseJson.data.sendBy)
                }
                else {
                  console.warn("Empty  Data")
                  this.setState({
                    dataSource: '',
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "getting task related messages error");
              });

          }
        });
      });
    });
  }
  // Update Status of Employee
  UpdateStatus(squadName) {
    // const { squadName } = this.state;
    log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
    console.warn("project" + JSON.stringify(squadName));
    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      console.log(res);

      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;

        // console.log(cropcode);
        NetInfo.fetch().then(state => {
          if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
            console.log(state.type);
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
            //for offline project switching start
            this.setState({
              squadName: squadName
            });
            AsyncStorage.setItem('cropcode', squadName);
            this.getApprovedProjectsListOffline()
            //for offline project switching end
          } else {

            fetch(API + 'squad_login.php', {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                username: empId,
                corp: squadName,
                projectId: projectId

              })
            })
              .then((response) => response.json())
              .then((responseJson) => {
                console.warn(JSON.stringify(responseJson))

                if (responseJson.status == 'TRUE') {
                  AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                  const tokenDetails = jwt_decode(responseJson.jwt);
                  console.log(tokenDetails.data)
                  AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                  // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                  AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                  AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                  AsyncStorage.setItem('userName', tokenDetails.data.userName);
                  AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                  AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
                  AsyncStorage.setItem('projectId', tokenDetails.data.projectId);

                  if (tokenDetails.data.role === "NA") {
                    this.props.navigation.navigate('Instruction')
                  }
                  // this.props.navigation.navigate('UserProfile');
                  // console.warn("HI" + empstatus)
                  this.setState({

                    squadName: tokenDetails.data.corp,

                  });
                  this.getGroupDetails();
                  // this.onRefresh();
                  //  alert("Project Changed Successfully")


                } else {
                  //    alert("user already exist");
                  log("Warn", "status of employee is not able to update");
                }

              })
              .catch((error) => {
                console.warn(error);
                log("Error", "error in updating status of employee");
              });
          }
        });
      });
    });

  }




  //For Approved Projects from offline
  getApprovedProjectsListOffline() {
    AsyncStorage.getItem("cropcode", (err, res) => {
      const projectName = res;
      db.getApprovedProjectsListOffline(projectName, "pending").then((data) => {
        console.warn("Approved ProjectList" + JSON.stringify(data))
        this.setState({
          dataSource: data,
          isLoading: false,
        });
        // this.arrayholder = data;
      }).catch((err) => {
        console.log(err);
        this.setState = {
          isLoading: false
        }
      })
    });
  }

  //For store Approved Projects list from offline
  addApprovedProjectsListOffline(data, cropcode, status) {
    db.addApprovedProjectsListOffline(data, cropcode, status).then((result) => {
      this.setState({
        isLoading: false,
      });
    }).catch((err) => {

      this.setState({
        isLoading: false,
      });
    })
  }

  //to get the user approved projects in to the list 
  getGroupDetails() {

    log("Info", "UserApprovedProjects:getResource() method is used to get all employee list");

    // alert("hello")
    AsyncStorage.getItem("userName", (err, res) => {
      this.setState({ username: res });

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            // alert(this.state.username)
            NetInfo.fetch().then(state => {
              if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                  title: 'No Internet Connection',
                  backgroundColor: 'red',
                  duration: Snackbar.LENGTH_LONG,
                });
              } else {
                fetch(API + 'group_chat.php',
                  {
                    method: 'POST',
                    headers: {
                      Accept: 'application/json',
                      'Content-Type': 'application/json',
                    },
                    body: JSON.stringify({
                      // crop: cropcode,
                      action: 'getGroupDetails',
                      created_by: this.state.username,
                      projectId: projectId,
                      empId: empId

                    })
                  })
                  .then((response) => response.json())
                  .then((responseJson) => {
                    if (responseJson.status === 'True') {
                      // alert(JSON.stringify(responseJson))
                      this.setState({
                        resource: responseJson.data
                      });
                      this.arrayholder = responseJson.data;
                    }

                    else {
                      this.arrayholder = [];

                      this.setState({
                        isLoading: false,
                        resource: []
                      })
                    }

                  })
                  .catch((error) => {
                    console.error(error);
                    log("Error", "error in listing employees");
                  });
              }
            });
          });
        });
      });
    });
  }

   //to get the user approved projects in to the list 
   getAdminGroupNew() {

    log("Info", "UserApprovedProjects:getResource() method is used to get all employee list");

    // alert("hello")
    AsyncStorage.getItem("userName", (err, res) => {
      this.setState({ username: res });

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            // alert(this.state.username)
            NetInfo.fetch().then(state => {
              if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                  title: 'No Internet Connection',
                  backgroundColor: 'red',
                  duration: Snackbar.LENGTH_LONG,
                });
              } else {
                fetch(API + 'group_chat.php',
                  {
                    method: 'POST',
                    headers: {
                      Accept: 'application/json',
                      'Content-Type': 'application/json',
                    },
                    body: JSON.stringify({
                      // crop: cropcode,
                      action: 'getAdminGroup_msg_time',
                      created_by: this.state.username,
                      projectId: projectId,
                      // empId: empId

                    })
                  })
                  .then((response) => response.json())
                  .then((responseJson) => {
                    if (responseJson.status === 'True') {
                      //alert(JSON.stringify(responseJson))
                      this.setState({
                        adminGroupsMsg: responseJson.data
                      });
                      this.arrayholder = responseJson.data;
                    }

                    else {
                      this.arrayholder = [];

                      this.setState({
                        isLoading: false,
                        adminGroupsMsg: []
                      })
                    }

                  })
                  .catch((error) => {
                    console.error(error);
                    log("Error", "error in listing employees");
                  });
              }
            });
          });
        });
      });
    });
  }

  //getting the Employees list for addind maintask
  getEmployees() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;
    // console.warn("ModuleId"+ModuleId)
    AsyncStorage.getItem("projectId", (err, res) => {
      const projectId = res;

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'agile_squads.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  projectId: projectId,

                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                // alert(JSON.stringify(responseJson))
                if (responseJson.status === 'True') {

                  var empList = [];
                  responseJson.data.map((employee) => {
                    return (
                      empList.push({
                        'id': employee.email, 'name': employee.name
                      })
                    );
                  })

                  this.setState({
                    resource1: empList,
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


  //to refreshthe data in user apprroved projects
  onRefresh() {
    this.setState({
      dataSource: [],
    })
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.getApprovedProjectsListOffline() //Offline Approved Projects List
      } else {
        //userApprovedProjects getting
        this.userApprovedProjects()
      }
    });
  }

  isValid() {
    const { group_name } = this.state;
    const { selectedItems } = this.state;
    let valid = false;

    if (group_name.length === 0) {
      this.setState({ error1: 'Enter Group Name ' });
      log("Warn", "project title should not be empty");
      // alert("project title should not be empty ");

    }

    else if (selectedItems.length === 0) {
      this.setState({ error2: 'Select the Group Members ' });
      log("Warn", "project description should not be empty");
      // alert("project description should not be empty");
    }

    else {
      valid = true;
    }
    return valid;
  }//isValid method end

  verifyProjectTitle(ProjectTitle) {
    var reg = /^[^!-\\/:-@\\[-`{-~]+$/;
    return reg.test(ProjectTitle);
  }

  //to add the new project from user 
  addGroup = () => {
    log("Info", "addGroup() method is used to add new project at user side");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == "unknown" || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      }
      else {
        const { group_name, } = this.state;
        if (this.isValid()) {
          // alert(group_name)
          // alert(this.state.selectedItems)

          this.setState({ itemPressedDisabled: true })
          AsyncStorage.multiGet(["cropcode", "userName", "fullName"], (err, response) => {
            const cropcode = response[0][1];
            const userName = response[1][1];
            // console.warn("userToken" + userToken)
            const fullName = response[2][1];
            AsyncStorage.getItem("projectId", (err, res) => {
              const projectId = res;
              fetch(API + 'group_chat.php', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  group_name: group_name,
                  mobileLabel: this.state.selectedItems,
                  created_by: userName, //Async
                  created_by_name: fullName,
                  action: "mobileCreateGroup",
                  crop: cropcode,//Async
                  // members: this.state.selectedItems.toString(),
                  projectId: projectId,
                })
              }).then((response) => response.json())
                .then((responseJson) => {
                  console.log(JSON.stringify(responseJson));
                  console.log(responseJson);
                  // alert(JSON.stringify(responseJson))

                  if (responseJson.status === 'True') {
                    //alert(responseJson.message)
                    this.refs.toast.showBottom('Group Created Succesfully');
                    this.setState({ itemPressedDisabled: false })
                    console.log("done")
                    this.setState({
                      open: false,
                      group_name: '',
                      selectedItems: '',
                    })
                    this.getGroupDetails()

                  }
                }).catch((error) => {
                  console.error(error);
                  log("Error", "error in project adding");
                });
            });
          });
          this.closeModal();
        }
      }

    });


  };

  //Set the RO
  setRO(ideaid) {
    log("Info", "UserApprovedProjects:setRO(ideaid) method is used to set release owner");
    AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      const role = response[2][1];
      // alert(cropcode+userToken+role)
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'manageIdeas.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                crop: cropcode,
                action: 'ro',
                empId: userToken,
                userType: role,
                ideaId: ideaid,
              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              //    alert(JSON.stringify(responseJson));
              console.log(responseJson)
              if (responseJson.setState == "True") {

                this.setState({ open: false });
                this.setState({
                  isLoading: false,

                  isFetching: false
                }, function () {

                });
              }


            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in Release owner setting");
            });
        }
      });
    });
  }

  componentWillReceiveProps(nextProps) {

    this.userApprovedProjects();
    this.getGroupDetails()
  }
  //userApprovedProjects getting
  userApprovedProjects() {
    log("Info", "UserApprovedProjects:setRO(userApprovedProjects() method is used to list the user approved projects");
    AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      const role = response[2][1];
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        // console.warn(userToken)
        // alert(cropcode+userToken+role)
        NetInfo.addEventListener(state => {
          if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
            console.log(state.type);
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'get_epics.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  // action: 'approved',
                  action: 'get_epics',
                  empId: userToken,
                  userType: role,
                  projectId: projectId
                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                //  alert(JSON.stringify(responseJson));
                console.warn(JSON.stringify(responseJson));
                if (responseJson.connection === 'connected ') {
                  if (responseJson.status === 'True') {
                    // this.addApprovedProjectsListOffline(responseJson.data, cropcode,"pending") //Store Approved Projects List Offline
                    this.setState({
                      isLoading: false,
                      dataSource: responseJson.data,
                      isFetching: false
                    }, function () {

                    });
                    // this.onRefresh();
                    this.getGroupDetails();
                    //  console.warn(responseJson.taskStatus);
                    // this.arrayholder = responseJson.data;
                  } else {
                    // this.arrayholder = [];
                    this.setState({
                      isLoading: false,
                      dataSource: [],
                    })
                    Snackbar.show({
                      title: 'No Groups Found',
                      backgroundColor: '#3BB9FF',
                      duration: Snackbar.LENGTH_LONG,
                    });
                  }
                }
                else {
                  this.props.navigation.navigate('Maintenance');
                }
              })
              .catch((error) => {
                check.Maintenance();
                console.error(error);
                log("Error", "error in listing approved projects at user side");
              });
          }
        });
      });
    });
  }


  // Exit Group start
  exitGroup(item, index) {
    // alert("delete"+item)
    // alert(email+""+empid)
    log("Info", "UserManageProjects1:deleteAction(idea_id) method is used to give alert");
    Alert.alert(
      'Alert..!',
      'Do you want to Exit Group ?',
      [
        {
          text: 'Cancel',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'OK', onPress: () => this.exitGroupAction(item, index) },
      ],
      { cancelable: false },
    );
  }
  //delete Employee end

  //delete the Project
  exitGroupAction(item, index) {
    //alert("Helllo");
    // alert(item.id)
    log("Info", "deleteProject() method is used to delete project");
    AsyncStorage.multiGet(["cropcode", "userName", "fullName"], (err, response) => {
      const cropcode = response[0][1];
      const userName = response[1][1];
      console.warn("userToken" + userName)
      const fullName = response[2][1];
      // alert(fullName)
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
            console.log(state.type);
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            // console.warn(item)
            // alert(this.state.email)
            fetch(API + 'group_chat.php', {
              method: 'POST',
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                created_by: item.created_by,
                crop: cropcode,
                action: 'exitGroup',
                group_Id: item.id,
                newMem: userName,
                newLabel: fullName,
                // projectId: projectId,


                // username:email,

              })
            }).then((response) => response.json())
              .then((responseJson) => {
                console.log(JSON.stringify(responseJson));
                console.log(responseJson);
                // alert(JSON.stringify(responseJson));
                if (responseJson.status === 'True') {
                  // this.refs.toast.showCenter('Epic Squad is Deactivated', Toast.Duration.long, Toast.Position.center);
                  console.log("done")
                  // this.deactiveEmployee(email);
                  //alert(responseJson.message);
                  //alert("Employee is Deleted");
                  //this.refs.toast.showBottom('Employee is Deleted');

                  this.setState({ open: false })
                  // this.props.navigation.navigate('Aproved');
                  this.getGroupDetails();
                }
                else {
                  //alert(responseJson.message);
                  // this.refs.toast.showCenter('Epic Squad is not Deactivated', Toast.Duration.long, Toast.Position.center);
                }
              }).catch((error) => {
                console.error(error);
                //alert("Hello");
                log("Error", "error in employee deletion");
              });
          }
        });
      });
    });
  };
  //Delete Group end


  // delete Employee start
  deleteAction(item, index) {
    // alert("delete"+item)
    // alert(email+""+empid)
    log("Info", "UserManageProjects1:deleteAction(idea_id) method is used to give alert");
    Alert.alert(
      'Alert..!',
      'Do you want to delete Group ?',
      [
        {
          text: 'Cancel',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'OK', onPress: () => this.deleteProject(item, index) },
      ],
      { cancelable: false },
    );
  }
  //delete Employee end

  //delete the Project
  deleteProject(item, index) {
    //alert("Helllo");
    // alert(item.id)
    log("Info", "deleteProject() method is used to delete project");
    AsyncStorage.multiGet(["cropcode", "userName", "emp_role"], (err, response) => {
      const cropcode = response[0][1];
      const userName = response[1][1];
      console.warn("userToken" + userName)
      const role = response[2][1];
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
            console.log(state.type);
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            // console.warn(item)
            // alert(this.state.email)
            fetch(API + 'group_chat.php', {
              method: 'POST',
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                created_by: userName,
                crop: cropcode,
                action: 'delete',
                group_Id: item.id,
                // projectId: projectId,


                // username:email,

              })
            }).then((response) => response.json())
              .then((responseJson) => {
                console.log(JSON.stringify(responseJson));
                console.log(responseJson);
                // alert(JSON.stringify(responseJson));
                if (responseJson.status === 'True') {
                  // this.refs.toast.showCenter('Epic Squad is Deactivated', Toast.Duration.long, Toast.Position.center);
                  console.log("done")
                  // this.deactiveEmployee(email);
                  // alert(responseJson.message);
                  //alert("Employee is Deleted");
                  //this.refs.toast.showBottom('Employee is Deleted');

                  this.setState({ open: false })
                  // this.props.navigation.navigate('Aproved');
                  this.getGroupDetails();
                }
                else {
                  //alert(responseJson.message);
                  // this.refs.toast.showCenter('Epic Squad is not Deactivated', Toast.Duration.long, Toast.Position.center);
                }
              }).catch((error) => {
                console.error(error);
                //alert("Hello");
                log("Error", "error in employee deletion");
              });
          }
        });
      });
    });
  };
  //Exit Group end

  //Relese the owner Navigation
  ReleaseOwner = (item, index) => {
    log("Info", "UserApprovedProjects:ReleaseOwner = (item, index) method used to navigate to Release owner screen");
    this.props.navigation.navigate('ReleaseOwner', { idea_id: item.idea_id });

  }

  //Navigate to AddModule sctreen
  Module = (item, index) => {
    log("Info", "UserApprovedProjects:Module() method is used to move module listing screen");
    console.log(item);
    console.log(index);
    this.props.navigation.navigate("AddModule", { id: item.id, group_name: item.group_name, members_name: item.members_name, members_email: item.members_email });

  }

  //Navigate to maintask screen
  // MainTask(item, index) {

  //   console.log(item);
  //   console.log(index);

  //   console.log(item.ideaId + item.moduleId);
  //   log("Info", "MainTask() method is used to move Add Module to Add MainTask screen");

  //   this.props.navigation.navigate('AddMainTask', { moduleId: item.moduleId, empId: item.empId, ideaid: item.idea_id, moduledesc: item.moduleDesc, idea_title: this.state.idea_title });

  // }
  //Navigate to Manageepic screen
  MainTask(item, index) {

    console.log(item);
    console.log(index);

    // console.log(item.ideaId + item.moduleId);
    log("Info", "MainTask() method is used to move Add Module to Add MainTask screen");

    this.props.navigation.navigate('ManageEpic', { moduleId: item.moduleId, empId: item.empId, idea_id: item.idea_id, moduledesc: item.moduleDesc, idea_title: this.state.idea_title });

  }
  //Navigate to Project Modify Screen
  UserGroupChatModify(item, index) {
    console.log(item);
    console.log(index);
    log("Info", "ModifyProject() method is used to move Add Module to Add ModifyChat screen");
    this.props.navigation.navigate('UserGroupChatModify', { id: item.id, group_name: item.group_name, members_name: item.members_name, members_email: item.members_email });

  }
  // //Navigate to Project Modify Screen
  // TaskChat(id,msgCount) {
  //   // console.log(item);
  //   // console.log(index);
  //   alert("message"+msgCount)
  //   log("Info", "ModifyProject() method is used to move Add Module to Add ModifyChat screen");
  //   // this.props.navigation.navigate('GroupChat', { sno: msgCount, id: item.id, group_name: item.group_name, members_name: item.members_name, members_email: item.members_email });

  // }
  //list seperator
  FlatListItemSeparator = () => {
    return (
      <View
        style={{
          //  height: .5,
          width: "100%",
          backgroundColor: "#000",
        }}
      />
    );
  }
  //List data for Empty
  _listEmptyComponent = () => {
    return (
      <View style={{ width: '90%', height: '80%' }}>
        <Text></Text>
      </View>
    )
  }


  //to filter the search in put by user 
  SearchFilterFunction(text) {
    log("Info", "UserApprovedProjects:SearchFilterFunction(text) method is used for search functionality");
    console.log(text);
    const newData = this.arrayholder.filter(function (item) {
      const id = item.id.toUpperCase()
      const id1 = text.toUpperCase()
      // const created_on = item.created_on.toUpperCase()
      // const created_on1 = text.toUpperCase()
      const group_name = item.group_name.toUpperCase()
      const group_name1 = text.toUpperCase()
      const created_by = item.created_by.toUpperCase()
      const created_by1 = text.toUpperCase()

      return id.indexOf(id1) > -1 ||
        group_name.indexOf(group_name1) > -1 ||
        //  created_on.indexOf(created_on1) > -1 ||
        created_by.indexOf(created_by1) > -1

    })
    this.setState({
      resource: newData,
      text: text
    })
  }


  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }
    const key = 'id';
    const arrayUniqueByKey = [...new Map(this.state.adminGroupsMsg.map(item =>
        [item[key], item])).values()].sort((a,b)=> b.sno - a.sno);

    const sortedOne = (msg, emp, empId) => {
      const sortedUserIds = msg
        .sort()
        .filter(m => m.groupId !== null && m.readBy.split(",").indexOf(empId) === -1 && m.messagedBy !== empId)
        .map(m => m.groupId)
      const sortedUsers = [...new Set(sortedUserIds)].map(id => emp.find(u => u.id === id))
      const sorted = sortedUsers.filter(id => id !== undefined)
      const namesToDeleteSet = new Set(sorted);
      const newArr = emp.filter((employee) => {
        return !namesToDeleteSet.has(employee);
      });
      const sortedEmployees = sorted.concat(newArr)
      return sortedEmployees;
    }

    // const empSorted = sortedOne(this.state.dataSource2, this.state.resource, this.state.empId);
    const empSorted = sortedOne(this.state.dataSource2,arrayUniqueByKey,this.state.empId);

    const { modalVisible, selectedItems } = this.state;
    return (
      <KeyboardAvoidingView
        behavior={Platform.OS === "ios" ? "padding" : "height"}
        style={styles.container}
      >
        {/* <TouchableWithoutFeedback onPress={Keyboard.dismiss}> */}
          <Container style={{ height: Dimensions.get('window').height }}>
            <NavigationEvents
              onDidFocus={() => this.onRefresh()}
            />
            <Header
              androidStatusBarColor="#00A2C1"
              style={{
                backgroundColor: '#00A2C1',
                height: 60,
                width: Dimensions.get('window').width,
                borderBottomColor: '#ffffff',
                justifyContent: 'space-between',
              }}>
              <Left>
                <Icon name="md-menu" style={{ color: '#fff' }} onPress={() =>
                  this.props.navigation.toggleDrawer()} />
              </Left>
              <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>
                <ModalSelector
                  style={{ width: 260, backgroundColor: 'transparent', borderColor: 'transparent', marginLeft: 60 }}
                  data={this.state.data2}
                  optionContainerStyle={{ backgroundColor: 'white' }}
                  initValue={this.state.squadName}
                  onChange={(itemValue) => { this.UpdateStatus(itemValue.label) }} >
                  <View style={{ width: 300, borderRadius: 20, backgroundColor: '#00A2C1', height: 45, flexDirection: 'row' }}>
                    <Text style={{ marginTop: 15, color: 'white', width: 80 }}>PROJECT : </Text>

                    <Text style={{ marginTop: 15, color: 'white', width: 120, }}>{this.state.squadName}</Text>

                    <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 10, }}
                    />
                  </View>

                </ModalSelector>
                {/* <Text style={{ width: 300, borderRadius: 20, height: 45, marginTop: 20, flexDirection: 'row', color: 'white',fontWeight:'bold' }}>Chat Room</Text> */}

              </View>
              {/* <Right><Text style={{ color: 'white' }} onPress={() => this.props.navigation.navigate('UserPassword')}>{CHANGEPASSWORD}</Text></Right> */}

            </Header>
            {/* </View> */}
            <Item>
              <Input placeholder="Search"
                onChangeText={(text) => this.SearchFilterFunction(text)} />
              <Icon size={20} style={{ marginRight: 10 }} name="search" />
            </Item>
            <View>
              <Toast ref="toast" />
              <View style={{ height: '92%' }}>

                <FlatList

                  extraData={this.state}
                  keyExtractor={this._keyExtractor}
                  renderItem={this._renderItem}
                  style={{ flex: 1, marginBottom: 50 }}
                  data={empSorted}

                  onRefresh={() => this.onRefresh()}
                  refreshing={this.state.isFetching}

                  ItemSeparatorComponent={this.FlatListItemSeparator}
                  renderItem={({ item, index }) =>
                    <View style={styles.container} >

                      <ListItem navigation={this.props.navigation}
                        item={item}
                        empId={this.state.empId}
                        username={this.state.username}
                        MainTask={() => this.MainTask(item, index)}//For Add Maintask
                        UserGroupChatModify={() => this.UserGroupChatModify(item, index)}//For Modify Project
                        emp_role={this.state.emp_role}
                        Module={() => this.Module(item, index)}
                        TaskChat={() => this.TaskChat(item, index)}//For Group Chat
                        ReleaseOwner={() => this.ReleaseOwner(item, index)}
                        exitGroup={() => this.exitGroup(item, index)}//Exit Group
                        deleteAction={() => this.deleteAction(item, index)}//delete action for project
                      />
                    </View>
                  }
                  keyExtractor={item => item.id}
                  ListEmptyComponent={this._listEmptyComponent}
                />

                <TouchableOpacity onPress={this.openModal} style={styles.bottomView}>
                  <View >


                    <Text style={styles.textStyle}>Create Group</Text>


                  </View>
                </TouchableOpacity>

              </View>


              {/* <View>



          </View> */}




              <Modal
                // offset={this.state.offset}
                open={this.state.open}
                closeOnTouchOutside={false}
                modalDidOpen={this.modalDidOpen}
                modalDidClose={this.modalDidClose}
                style={{ alignItems: "center" }}
              // disableOnBackPress={false}
              >

                <View style={{ alignItems: "center", }}>

                  <Text>Create Group</Text>

                  <TextInput placeholder='Group Name'
                    style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 10 }}
                    maxLength={50}
                    onChangeText={(text) => this.setState({ group_name: text })}
                    value={this.state.group_name} />
                  <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error1}</Text>
                  <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error3}</Text>




                  <View style={{ width: '90%', marginTop: 10 }}>
                    <MultiSelect
                      hideTags
                      items={this.state.resource1}
                      style={{ width: '90%' }}
                      uniqueKey="id"
                      ref={(component) => { this.multiSelect = component }}
                      onSelectedItemsChange={this.onSelectedItemsChange}
                      // onSelectedItemsChange={this.onSelectedItemsChange({members:item.id,label:item.name})}
                      // onItemSelect={(item) => this.setState({ assignedto: item.id })}
                      selectedItems={selectedItems}
                      styleItemsContainer={{ height: 150 }}
                      selectText="    Select Employees"
                      searchInputPlaceholderText="Search Items..."
                      onChangeInput={(text) => console.log(text)}
                      // altFontFamily="ProximaNova-Light"
                      tagRemoveIconColor="#CCC"
                      tagBorderColor="#CCC"
                      tagTextColor="#CCC"
                      selectedItemTextColor="#CCC"
                      selectedItemIconColor="#CCC"
                      itemTextColor="#000"
                      displayKey="name"
                      searchInputStyle={{ color: '#CCC' }}
                      submitButtonColor="#CCC"
                      submitButtonText="Select"
                    />
                  </View>

                </View>
                <View style={{ flexDirection: 'row', marginBottom: 20, alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>

                  <TouchableOpacity style={styles.opensave} onPress={this.addGroup} disabled={this.state.itemPressedDisabled}>
                    <Text style={{ color: 'white' }}>SAVE</Text>

                  </TouchableOpacity>
                  <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                    <Text style={{ color: 'white' }}>CANCEL</Text>
                  </TouchableOpacity>

                </View>
              </Modal>

              {/* <Modal
            offset={this.state.offset}
            open={this.state.open}
            modalDidOpen={this.modalDidOpen}
            modalDidClose={this.modalDidClose}
            style={{ alignItems: "center", }}
          >

            <View style={{ alignItems: "center", paddingBottom: 40 }}>

              <View style={{ marginTop: 30, marginLeft: 10, width: '100%', }}>
                <Text >Select Resources</Text>
                <View style={{ justifyContent: 'center', marginRight: 15 }}>

                  <SearchableDropdown
                    onTextChange={text => console.log(text)}
                    //On text change listner on the searchable input
                    onItemSelect={item => console.log(text)}
                    //onItemSelect called after the selection from the dropdown
                    containerStyle={{ padding: 5 }}
                    //suggestion container style
                    textInputStyle={{
                      //inserted text style
                      padding: 12,
                      borderWidth: 1,
                      borderColor: '#ccc',
                      backgroundColor: '#FAF7F6',
                    }}
                    itemStyle={{
                      //single dropdown item style
                      padding: 10,
                      marginTop: 2,
                      backgroundColor: '#FAF9F8',
                      borderColor: '#bbb',
                      borderWidth: 1,
                    }}
                    itemTextStyle={{
                      //text style of a single dropdown item
                      color: '#222',
                    }}
                    itemsContainerStyle={{
                      //items container style you can pass maxHeight
                      //to restrict the items dropdown hieght
                      // maxHeight: '60%',
                    }}
                    items={this.state.resource}
                    //mapping of item array
                    defaultIndex={0}
                    //default selected item index
                    placeholder="select RO"
                    //place holder for the search input
                    resetValue={false}
                    //reset textInput Value with true and false state
                    underlineColorAndroid="transparent"
                  //To remove the underline from the android input
                  />
                </View>
              </View>

              <View style={{ flexDirection: 'row', marginTop: 30, justifyContent: "space-between" }}>
                <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                  <Text style={{ color: 'white' }}>CANCEL</Text>
                </TouchableOpacity>
                <TouchableOpacity onPress={() => { this.setRO(this.state.ideaid) }} style={styles.opensave} >
                  <Text style={{ color: 'white' }}>SAVE</Text>
                </TouchableOpacity>
              </View>

            </View>
          </Modal> */}

            </View>
          </Container>
        {/* </TouchableWithoutFeedback> */}
      </KeyboardAvoidingView>
    );
  }
}
//Styles for UI
const styles = StyleSheet.create({
  container: {
    flex: 1,
    width: '100%',
    backgroundColor: '#fff',
    // paddingLeft: hp('1%'),
  },
  container1: {
    flex: 1,
    width: '98%',
    backgroundColor: '#BEF29F',

  },
  bottomView: {
    flex: 1,
    ...Platform.select({
      ios: {
        flexDirection: 'row',
        justifyContent: 'center',
        position: 'absolute',
        height: FOOTER_MAX_HEIGHT,
        bottom: 16,
        left: 0,
        right: 0,
        backgroundColor: 'black',
        alignItems: 'center'
      },
      android: {
        flexDirection: 'row',
        justifyContent: 'center',
        position: 'absolute',
        height: FOOTER_MAX_HEIGHT,
        bottom: -7,
        left: 0,
        right: 0,
        backgroundColor: 'black',
        alignItems: 'center'
      },
    }),
  },


  textStyle: {

    color: '#fff',
    fontSize: 22,
    justifyContent: 'center',
    backgroundColor: '#00A2C1',
    paddingBottom: 10,
    paddingLeft: 5,
    paddingRight: 5,
    paddingTop: 5,
    borderRadius: 5,
    marginLeft: 5


  },
  footer: {
    position: 'absolute',
    flex: 0.1,
    left: 0,
    right: 0,
    bottom: -10,
    backgroundColor: 'green',
    flexDirection: 'row',
    height: 80,
    alignItems: 'center',
  },
  bottomButtons: {
    alignItems: 'center',
    justifyContent: 'center',
    flex: 1,
  },
  footerText: {
    color: 'white',
    // fontWeight: 'bold',
    alignItems: 'center',
    fontSize: 18,
  },
  buttonContainer: {
    width: wp('98%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    color: '#d2691e',
    marginLeft: 4,


  },
  buttonContainer1: {
    width: wp('98%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    // backgroundColor: '#BEF29F',
    marginLeft: 4,



  },
  signupButton: {

    backgroundColor: '#ffffff',
  },
  subcontainer: {
    flex: 2,
    flexDirection: 'row',
    paddingTop: 40
  },
  signUpText0: {
    fontSize: 13,
    color: 'green',
    paddingTop: 10,
    // fontWeight:"bold",

  },
  signUpText1: {
    fontSize: 13,
    color: 'green',
    paddingTop: 10,
    // fontWeight:"bold",
    paddingLeft: 10,
  },
  end: {

    alignItems: 'flex-end',

  },
  end1: {
    flex: 2,
    height: '50%',
    paddingTop: 20,
    justifyContent: 'space-between',

    flexDirection: 'row',
  },
  s: {
    justifyContent: 'center',

    backgroundColor: '#ed7070',
    shadowOffset: { width: 50, height: 50 },
    alignItems: 'center',
    width: wp('40%'),
    height: hp('12%'),

  },
  signUpText2: {
    fontSize: 13,
    //marginLeft: 200,
    // fontSize: 13,
    color: 'black',
    paddingTop: 10,

    //  marginRight: 10,
    //textAlign: "right"

  },
  listgap: {
    fontSize: 13,
    paddingTop: 10,
    // paddingLeft: 130,


    alignItems: 'center',
  },
  signUpText03: {
    width: '25%',
    fontSize: 13,
    paddingTop: 10,
    paddingLeft: 10,

    alignItems: 'center',
  },
  signUpText3: {

    fontSize: 13,
    paddingTop: 10,
    paddingLeft: 10,
    // fontWeight:"bold",
    alignItems: 'center',
  },
  signUpText4: {
    fontSize: 13,
    paddingTop: 10,

    color: 'black',
    // fontWeight:"bold",
    alignItems: 'center',
  },
  signUpText9: {
    fontSize: 13,
    paddingTop: 10,
    width: wp('70%'),
    color: 'black',
    // fontWeight:"bold",
    alignItems: 'center',
  },
  signUpText99: {
    fontSize: 13,
    paddingTop: 10,
    width: wp('60%'),
    color: 'black',
    // fontWeight:"bold",
    alignItems: 'center',
  },

  signup: {
    //paddingTop:20,
    color: "#FFF",

  },
  boxone: {
    flex: 1,
    marginTop: 5,

  },
  boxtwo: {
    flex: 1,

  },
  boxthree: {
    flex: 1,

  },
  box: {
    flexDirection: 'row',
    position: 'relative',
    marginBottom: 10,

  },
  signUpText: {
    fontSize: 13,
    justifyContent: 'center',


    color: 'white',
    alignSelf: 'center',
  },
  //Based ON Platform
  opencancel: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'red', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'red', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
  opensave: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
});